import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ApiManagementApiConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_api.html#api_management_name ApiManagementApi#api_management_name}.
     *
     * @stability stable
     */
    readonly apiManagementName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_api.html#description ApiManagementApi#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_api.html#display_name ApiManagementApi#display_name}.
     *
     * @stability stable
     */
    readonly displayName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_api.html#name ApiManagementApi#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_api.html#path ApiManagementApi#path}.
     *
     * @stability stable
     */
    readonly path: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_api.html#protocols ApiManagementApi#protocols}.
     *
     * @stability stable
     */
    readonly protocols: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_api.html#resource_group_name ApiManagementApi#resource_group_name}.
     *
     * @stability stable
     */
    readonly resourceGroupName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_api.html#revision ApiManagementApi#revision}.
     *
     * @stability stable
     */
    readonly revision: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_api.html#service_url ApiManagementApi#service_url}.
     *
     * @stability stable
     */
    readonly serviceUrl?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_api.html#soap_pass_through ApiManagementApi#soap_pass_through}.
     *
     * @stability stable
     */
    readonly soapPassThrough?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_api.html#subscription_required ApiManagementApi#subscription_required}.
     *
     * @stability stable
     */
    readonly subscriptionRequired?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_api.html#version ApiManagementApi#version}.
     *
     * @stability stable
     */
    readonly version?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_api.html#version_set_id ApiManagementApi#version_set_id}.
     *
     * @stability stable
     */
    readonly versionSetId?: string;
    /**
     * import block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_api.html#import ApiManagementApi#import}
     *
     * @stability stable
     */
    readonly import?: ApiManagementApiImport[];
    /**
     * oauth2_authorization block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_api.html#oauth2_authorization ApiManagementApi#oauth2_authorization}
     *
     * @stability stable
     */
    readonly oauth2Authorization?: ApiManagementApiOauth2Authorization[];
    /**
     * openid_authentication block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_api.html#openid_authentication ApiManagementApi#openid_authentication}
     *
     * @stability stable
     */
    readonly openidAuthentication?: ApiManagementApiOpenidAuthentication[];
    /**
     * subscription_key_parameter_names block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_api.html#subscription_key_parameter_names ApiManagementApi#subscription_key_parameter_names}
     *
     * @stability stable
     */
    readonly subscriptionKeyParameterNames?: ApiManagementApiSubscriptionKeyParameterNames[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_api.html#timeouts ApiManagementApi#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: ApiManagementApiTimeouts;
}
/**
 * @stability stable
 */
export interface ApiManagementApiImportWsdlSelector {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_api.html#endpoint_name ApiManagementApi#endpoint_name}.
     *
     * @stability stable
     */
    readonly endpointName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_api.html#service_name ApiManagementApi#service_name}.
     *
     * @stability stable
     */
    readonly serviceName: string;
}
/**
 * @stability stable
 */
export interface ApiManagementApiImport {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_api.html#content_format ApiManagementApi#content_format}.
     *
     * @stability stable
     */
    readonly contentFormat: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_api.html#content_value ApiManagementApi#content_value}.
     *
     * @stability stable
     */
    readonly contentValue: string;
    /**
     * wsdl_selector block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_api.html#wsdl_selector ApiManagementApi#wsdl_selector}
     *
     * @stability stable
     */
    readonly wsdlSelector?: ApiManagementApiImportWsdlSelector[];
}
/**
 * @stability stable
 */
export interface ApiManagementApiOauth2Authorization {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_api.html#authorization_server_name ApiManagementApi#authorization_server_name}.
     *
     * @stability stable
     */
    readonly authorizationServerName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_api.html#scope ApiManagementApi#scope}.
     *
     * @stability stable
     */
    readonly scope?: string;
}
/**
 * @stability stable
 */
export interface ApiManagementApiOpenidAuthentication {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_api.html#bearer_token_sending_methods ApiManagementApi#bearer_token_sending_methods}.
     *
     * @stability stable
     */
    readonly bearerTokenSendingMethods?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_api.html#openid_provider_name ApiManagementApi#openid_provider_name}.
     *
     * @stability stable
     */
    readonly openidProviderName: string;
}
/**
 * @stability stable
 */
export interface ApiManagementApiSubscriptionKeyParameterNames {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_api.html#header ApiManagementApi#header}.
     *
     * @stability stable
     */
    readonly header: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_api.html#query ApiManagementApi#query}.
     *
     * @stability stable
     */
    readonly query: string;
}
/**
 * @stability stable
 */
export interface ApiManagementApiTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_api.html#create ApiManagementApi#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_api.html#delete ApiManagementApi#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_api.html#read ApiManagementApi#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_api.html#update ApiManagementApi#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_api.html azurerm_api_management_api}.
 *
 * @stability stable
 */
export declare class ApiManagementApi extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_api.html azurerm_api_management_api} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ApiManagementApiConfig);
    private _apiManagementName;
    /**
     * @stability stable
     */
    get apiManagementName(): string;
    /**
     * @stability stable
     */
    set apiManagementName(value: string);
    /**
     * @stability stable
     */
    get apiManagementNameInput(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _displayName;
    /**
     * @stability stable
     */
    get displayName(): string;
    /**
     * @stability stable
     */
    set displayName(value: string);
    /**
     * @stability stable
     */
    get displayNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get isCurrent(): boolean;
    /**
     * @stability stable
     */
    get isOnline(): boolean;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _path;
    /**
     * @stability stable
     */
    get path(): string;
    /**
     * @stability stable
     */
    set path(value: string);
    /**
     * @stability stable
     */
    get pathInput(): string;
    private _protocols;
    /**
     * @stability stable
     */
    get protocols(): string[];
    /**
     * @stability stable
     */
    set protocols(value: string[]);
    /**
     * @stability stable
     */
    get protocolsInput(): string[];
    private _resourceGroupName;
    /**
     * @stability stable
     */
    get resourceGroupName(): string;
    /**
     * @stability stable
     */
    set resourceGroupName(value: string);
    /**
     * @stability stable
     */
    get resourceGroupNameInput(): string;
    private _revision;
    /**
     * @stability stable
     */
    get revision(): string;
    /**
     * @stability stable
     */
    set revision(value: string);
    /**
     * @stability stable
     */
    get revisionInput(): string;
    private _serviceUrl?;
    /**
     * @stability stable
     */
    get serviceUrl(): string;
    /**
     * @stability stable
     */
    set serviceUrl(value: string);
    /**
     * @stability stable
     */
    resetServiceUrl(): void;
    /**
     * @stability stable
     */
    get serviceUrlInput(): string | undefined;
    private _soapPassThrough?;
    /**
     * @stability stable
     */
    get soapPassThrough(): boolean;
    /**
     * @stability stable
     */
    set soapPassThrough(value: boolean);
    /**
     * @stability stable
     */
    resetSoapPassThrough(): void;
    /**
     * @stability stable
     */
    get soapPassThroughInput(): boolean | undefined;
    private _subscriptionRequired?;
    /**
     * @stability stable
     */
    get subscriptionRequired(): boolean;
    /**
     * @stability stable
     */
    set subscriptionRequired(value: boolean);
    /**
     * @stability stable
     */
    resetSubscriptionRequired(): void;
    /**
     * @stability stable
     */
    get subscriptionRequiredInput(): boolean | undefined;
    private _version?;
    /**
     * @stability stable
     */
    get version(): string;
    /**
     * @stability stable
     */
    set version(value: string);
    /**
     * @stability stable
     */
    resetVersion(): void;
    /**
     * @stability stable
     */
    get versionInput(): string | undefined;
    private _versionSetId?;
    /**
     * @stability stable
     */
    get versionSetId(): string;
    /**
     * @stability stable
     */
    set versionSetId(value: string);
    /**
     * @stability stable
     */
    resetVersionSetId(): void;
    /**
     * @stability stable
     */
    get versionSetIdInput(): string | undefined;
    private _import?;
    /**
     * @stability stable
     */
    get import(): ApiManagementApiImport[];
    /**
     * @stability stable
     */
    set import(value: ApiManagementApiImport[]);
    /**
     * @stability stable
     */
    resetImport(): void;
    /**
     * @stability stable
     */
    get importInput(): ApiManagementApiImport[] | undefined;
    private _oauth2Authorization?;
    /**
     * @stability stable
     */
    get oauth2Authorization(): ApiManagementApiOauth2Authorization[];
    /**
     * @stability stable
     */
    set oauth2Authorization(value: ApiManagementApiOauth2Authorization[]);
    /**
     * @stability stable
     */
    resetOauth2Authorization(): void;
    /**
     * @stability stable
     */
    get oauth2AuthorizationInput(): ApiManagementApiOauth2Authorization[] | undefined;
    private _openidAuthentication?;
    /**
     * @stability stable
     */
    get openidAuthentication(): ApiManagementApiOpenidAuthentication[];
    /**
     * @stability stable
     */
    set openidAuthentication(value: ApiManagementApiOpenidAuthentication[]);
    /**
     * @stability stable
     */
    resetOpenidAuthentication(): void;
    /**
     * @stability stable
     */
    get openidAuthenticationInput(): ApiManagementApiOpenidAuthentication[] | undefined;
    private _subscriptionKeyParameterNames?;
    /**
     * @stability stable
     */
    get subscriptionKeyParameterNames(): ApiManagementApiSubscriptionKeyParameterNames[];
    /**
     * @stability stable
     */
    set subscriptionKeyParameterNames(value: ApiManagementApiSubscriptionKeyParameterNames[]);
    /**
     * @stability stable
     */
    resetSubscriptionKeyParameterNames(): void;
    /**
     * @stability stable
     */
    get subscriptionKeyParameterNamesInput(): ApiManagementApiSubscriptionKeyParameterNames[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): ApiManagementApiTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: ApiManagementApiTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): ApiManagementApiTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
