import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ApiManagementConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#client_certificate_enabled ApiManagement#client_certificate_enabled}.
     *
     * @stability stable
     */
    readonly clientCertificateEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#gateway_disabled ApiManagement#gateway_disabled}.
     *
     * @stability stable
     */
    readonly gatewayDisabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#location ApiManagement#location}.
     *
     * @stability stable
     */
    readonly location: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#min_api_version ApiManagement#min_api_version}.
     *
     * @stability stable
     */
    readonly minApiVersion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#name ApiManagement#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#notification_sender_email ApiManagement#notification_sender_email}.
     *
     * @stability stable
     */
    readonly notificationSenderEmail?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#policy ApiManagement#policy}.
     *
     * @stability stable
     */
    readonly policy?: ApiManagementPolicy[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#publisher_email ApiManagement#publisher_email}.
     *
     * @stability stable
     */
    readonly publisherEmail: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#publisher_name ApiManagement#publisher_name}.
     *
     * @stability stable
     */
    readonly publisherName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#resource_group_name ApiManagement#resource_group_name}.
     *
     * @stability stable
     */
    readonly resourceGroupName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#sku_name ApiManagement#sku_name}.
     *
     * @stability stable
     */
    readonly skuName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#tags ApiManagement#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#virtual_network_type ApiManagement#virtual_network_type}.
     *
     * @stability stable
     */
    readonly virtualNetworkType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#zones ApiManagement#zones}.
     *
     * @stability stable
     */
    readonly zones?: string[];
    /**
     * additional_location block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#additional_location ApiManagement#additional_location}
     *
     * @stability stable
     */
    readonly additionalLocation?: ApiManagementAdditionalLocation[];
    /**
     * certificate block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#certificate ApiManagement#certificate}
     *
     * @stability stable
     */
    readonly certificate?: ApiManagementCertificate[];
    /**
     * hostname_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#hostname_configuration ApiManagement#hostname_configuration}
     *
     * @stability stable
     */
    readonly hostnameConfiguration?: ApiManagementHostnameConfiguration[];
    /**
     * identity block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#identity ApiManagement#identity}
     *
     * @stability stable
     */
    readonly identity?: ApiManagementIdentity[];
    /**
     * protocols block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#protocols ApiManagement#protocols}
     *
     * @stability stable
     */
    readonly protocols?: ApiManagementProtocols[];
    /**
     * security block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#security ApiManagement#security}
     *
     * @stability stable
     */
    readonly security?: ApiManagementSecurity[];
    /**
     * sign_in block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#sign_in ApiManagement#sign_in}
     *
     * @stability stable
     */
    readonly signIn?: ApiManagementSignIn[];
    /**
     * sign_up block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#sign_up ApiManagement#sign_up}
     *
     * @stability stable
     */
    readonly signUp?: ApiManagementSignUp[];
    /**
     * tenant_access block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#tenant_access ApiManagement#tenant_access}
     *
     * @stability stable
     */
    readonly tenantAccess?: ApiManagementTenantAccess[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#timeouts ApiManagement#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: ApiManagementTimeouts;
    /**
     * virtual_network_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#virtual_network_configuration ApiManagement#virtual_network_configuration}
     *
     * @stability stable
     */
    readonly virtualNetworkConfiguration?: ApiManagementVirtualNetworkConfiguration[];
}
/**
 * @stability stable
 */
export interface ApiManagementPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#xml_content ApiManagement#xml_content}.
     *
     * @stability stable
     */
    readonly xmlContent?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#xml_link ApiManagement#xml_link}.
     *
     * @stability stable
     */
    readonly xmlLink?: string;
}
/**
 * @stability stable
 */
export interface ApiManagementAdditionalLocationVirtualNetworkConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#subnet_id ApiManagement#subnet_id}.
     *
     * @stability stable
     */
    readonly subnetId: string;
}
/**
 * @stability stable
 */
export interface ApiManagementAdditionalLocation {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#location ApiManagement#location}.
     *
     * @stability stable
     */
    readonly location: string;
    /**
     * virtual_network_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#virtual_network_configuration ApiManagement#virtual_network_configuration}
     *
     * @stability stable
     */
    readonly virtualNetworkConfiguration?: ApiManagementAdditionalLocationVirtualNetworkConfiguration[];
}
/**
 * @stability stable
 */
export interface ApiManagementCertificate {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#certificate_password ApiManagement#certificate_password}.
     *
     * @stability stable
     */
    readonly certificatePassword?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#encoded_certificate ApiManagement#encoded_certificate}.
     *
     * @stability stable
     */
    readonly encodedCertificate: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#store_name ApiManagement#store_name}.
     *
     * @stability stable
     */
    readonly storeName: string;
}
/**
 * @stability stable
 */
export interface ApiManagementHostnameConfigurationDeveloperPortal {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#certificate ApiManagement#certificate}.
     *
     * @stability stable
     */
    readonly certificate?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#certificate_password ApiManagement#certificate_password}.
     *
     * @stability stable
     */
    readonly certificatePassword?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#host_name ApiManagement#host_name}.
     *
     * @stability stable
     */
    readonly hostName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#key_vault_id ApiManagement#key_vault_id}.
     *
     * @stability stable
     */
    readonly keyVaultId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#negotiate_client_certificate ApiManagement#negotiate_client_certificate}.
     *
     * @stability stable
     */
    readonly negotiateClientCertificate?: boolean;
}
/**
 * @stability stable
 */
export interface ApiManagementHostnameConfigurationManagement {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#certificate ApiManagement#certificate}.
     *
     * @stability stable
     */
    readonly certificate?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#certificate_password ApiManagement#certificate_password}.
     *
     * @stability stable
     */
    readonly certificatePassword?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#host_name ApiManagement#host_name}.
     *
     * @stability stable
     */
    readonly hostName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#key_vault_id ApiManagement#key_vault_id}.
     *
     * @stability stable
     */
    readonly keyVaultId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#negotiate_client_certificate ApiManagement#negotiate_client_certificate}.
     *
     * @stability stable
     */
    readonly negotiateClientCertificate?: boolean;
}
/**
 * @stability stable
 */
export interface ApiManagementHostnameConfigurationPortal {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#certificate ApiManagement#certificate}.
     *
     * @stability stable
     */
    readonly certificate?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#certificate_password ApiManagement#certificate_password}.
     *
     * @stability stable
     */
    readonly certificatePassword?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#host_name ApiManagement#host_name}.
     *
     * @stability stable
     */
    readonly hostName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#key_vault_id ApiManagement#key_vault_id}.
     *
     * @stability stable
     */
    readonly keyVaultId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#negotiate_client_certificate ApiManagement#negotiate_client_certificate}.
     *
     * @stability stable
     */
    readonly negotiateClientCertificate?: boolean;
}
/**
 * @stability stable
 */
export interface ApiManagementHostnameConfigurationProxy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#certificate ApiManagement#certificate}.
     *
     * @stability stable
     */
    readonly certificate?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#certificate_password ApiManagement#certificate_password}.
     *
     * @stability stable
     */
    readonly certificatePassword?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#default_ssl_binding ApiManagement#default_ssl_binding}.
     *
     * @stability stable
     */
    readonly defaultSslBinding?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#host_name ApiManagement#host_name}.
     *
     * @stability stable
     */
    readonly hostName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#key_vault_id ApiManagement#key_vault_id}.
     *
     * @stability stable
     */
    readonly keyVaultId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#negotiate_client_certificate ApiManagement#negotiate_client_certificate}.
     *
     * @stability stable
     */
    readonly negotiateClientCertificate?: boolean;
}
/**
 * @stability stable
 */
export interface ApiManagementHostnameConfigurationScm {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#certificate ApiManagement#certificate}.
     *
     * @stability stable
     */
    readonly certificate?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#certificate_password ApiManagement#certificate_password}.
     *
     * @stability stable
     */
    readonly certificatePassword?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#host_name ApiManagement#host_name}.
     *
     * @stability stable
     */
    readonly hostName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#key_vault_id ApiManagement#key_vault_id}.
     *
     * @stability stable
     */
    readonly keyVaultId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#negotiate_client_certificate ApiManagement#negotiate_client_certificate}.
     *
     * @stability stable
     */
    readonly negotiateClientCertificate?: boolean;
}
/**
 * @stability stable
 */
export interface ApiManagementHostnameConfiguration {
    /**
     * developer_portal block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#developer_portal ApiManagement#developer_portal}
     *
     * @stability stable
     */
    readonly developerPortal?: ApiManagementHostnameConfigurationDeveloperPortal[];
    /**
     * management block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#management ApiManagement#management}
     *
     * @stability stable
     */
    readonly management?: ApiManagementHostnameConfigurationManagement[];
    /**
     * portal block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#portal ApiManagement#portal}
     *
     * @stability stable
     */
    readonly portal?: ApiManagementHostnameConfigurationPortal[];
    /**
     * proxy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#proxy ApiManagement#proxy}
     *
     * @stability stable
     */
    readonly proxy?: ApiManagementHostnameConfigurationProxy[];
    /**
     * scm block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#scm ApiManagement#scm}
     *
     * @stability stable
     */
    readonly scm?: ApiManagementHostnameConfigurationScm[];
}
/**
 * @stability stable
 */
export interface ApiManagementIdentity {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#identity_ids ApiManagement#identity_ids}.
     *
     * @stability stable
     */
    readonly identityIds?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#type ApiManagement#type}.
     *
     * @stability stable
     */
    readonly type?: string;
}
/**
 * @stability stable
 */
export interface ApiManagementProtocols {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#enable_http2 ApiManagement#enable_http2}.
     *
     * @stability stable
     */
    readonly enableHttp2?: boolean;
}
/**
 * @stability stable
 */
export interface ApiManagementSecurity {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#enable_backend_ssl30 ApiManagement#enable_backend_ssl30}.
     *
     * @stability stable
     */
    readonly enableBackendSsl30?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#enable_backend_tls10 ApiManagement#enable_backend_tls10}.
     *
     * @stability stable
     */
    readonly enableBackendTls10?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#enable_backend_tls11 ApiManagement#enable_backend_tls11}.
     *
     * @stability stable
     */
    readonly enableBackendTls11?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#enable_frontend_ssl30 ApiManagement#enable_frontend_ssl30}.
     *
     * @stability stable
     */
    readonly enableFrontendSsl30?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#enable_frontend_tls10 ApiManagement#enable_frontend_tls10}.
     *
     * @stability stable
     */
    readonly enableFrontendTls10?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#enable_frontend_tls11 ApiManagement#enable_frontend_tls11}.
     *
     * @stability stable
     */
    readonly enableFrontendTls11?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#enable_triple_des_ciphers ApiManagement#enable_triple_des_ciphers}.
     *
     * @stability stable
     */
    readonly enableTripleDesCiphers?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#tls_ecdhe_ecdsa_with_aes128_cbc_sha_ciphers_enabled ApiManagement#tls_ecdhe_ecdsa_with_aes128_cbc_sha_ciphers_enabled}.
     *
     * @stability stable
     */
    readonly tlsEcdheEcdsaWithAes128CbcShaCiphersEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#tls_ecdhe_ecdsa_with_aes256_cbc_sha_ciphers_enabled ApiManagement#tls_ecdhe_ecdsa_with_aes256_cbc_sha_ciphers_enabled}.
     *
     * @stability stable
     */
    readonly tlsEcdheEcdsaWithAes256CbcShaCiphersEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#tls_ecdhe_rsa_with_aes128_cbc_sha_ciphers_enabled ApiManagement#tls_ecdhe_rsa_with_aes128_cbc_sha_ciphers_enabled}.
     *
     * @stability stable
     */
    readonly tlsEcdheRsaWithAes128CbcShaCiphersEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#tls_ecdhe_rsa_with_aes256_cbc_sha_ciphers_enabled ApiManagement#tls_ecdhe_rsa_with_aes256_cbc_sha_ciphers_enabled}.
     *
     * @stability stable
     */
    readonly tlsEcdheRsaWithAes256CbcShaCiphersEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#tls_rsa_with_aes128_cbc_sha256_ciphers_enabled ApiManagement#tls_rsa_with_aes128_cbc_sha256_ciphers_enabled}.
     *
     * @stability stable
     */
    readonly tlsRsaWithAes128CbcSha256CiphersEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#tls_rsa_with_aes128_cbc_sha_ciphers_enabled ApiManagement#tls_rsa_with_aes128_cbc_sha_ciphers_enabled}.
     *
     * @stability stable
     */
    readonly tlsRsaWithAes128CbcShaCiphersEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#tls_rsa_with_aes128_gcm_sha256_ciphers_enabled ApiManagement#tls_rsa_with_aes128_gcm_sha256_ciphers_enabled}.
     *
     * @stability stable
     */
    readonly tlsRsaWithAes128GcmSha256CiphersEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#tls_rsa_with_aes256_cbc_sha256_ciphers_enabled ApiManagement#tls_rsa_with_aes256_cbc_sha256_ciphers_enabled}.
     *
     * @stability stable
     */
    readonly tlsRsaWithAes256CbcSha256CiphersEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#tls_rsa_with_aes256_cbc_sha_ciphers_enabled ApiManagement#tls_rsa_with_aes256_cbc_sha_ciphers_enabled}.
     *
     * @stability stable
     */
    readonly tlsRsaWithAes256CbcShaCiphersEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#triple_des_ciphers_enabled ApiManagement#triple_des_ciphers_enabled}.
     *
     * @stability stable
     */
    readonly tripleDesCiphersEnabled?: boolean;
}
/**
 * @stability stable
 */
export interface ApiManagementSignIn {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#enabled ApiManagement#enabled}.
     *
     * @stability stable
     */
    readonly enabled: boolean;
}
/**
 * @stability stable
 */
export interface ApiManagementSignUpTermsOfService {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#consent_required ApiManagement#consent_required}.
     *
     * @stability stable
     */
    readonly consentRequired: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#enabled ApiManagement#enabled}.
     *
     * @stability stable
     */
    readonly enabled: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#text ApiManagement#text}.
     *
     * @stability stable
     */
    readonly text?: string;
}
/**
 * @stability stable
 */
export interface ApiManagementSignUp {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#enabled ApiManagement#enabled}.
     *
     * @stability stable
     */
    readonly enabled: boolean;
    /**
     * terms_of_service block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#terms_of_service ApiManagement#terms_of_service}
     *
     * @stability stable
     */
    readonly termsOfService: ApiManagementSignUpTermsOfService[];
}
/**
 * @stability stable
 */
export interface ApiManagementTenantAccess {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#enabled ApiManagement#enabled}.
     *
     * @stability stable
     */
    readonly enabled: boolean;
}
/**
 * @stability stable
 */
export interface ApiManagementTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#create ApiManagement#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#delete ApiManagement#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#read ApiManagement#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#update ApiManagement#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export interface ApiManagementVirtualNetworkConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html#subnet_id ApiManagement#subnet_id}.
     *
     * @stability stable
     */
    readonly subnetId: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html azurerm_api_management}.
 *
 * @stability stable
 */
export declare class ApiManagement extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/api_management.html azurerm_api_management} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ApiManagementConfig);
    private _clientCertificateEnabled?;
    /**
     * @stability stable
     */
    get clientCertificateEnabled(): boolean;
    /**
     * @stability stable
     */
    set clientCertificateEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetClientCertificateEnabled(): void;
    /**
     * @stability stable
     */
    get clientCertificateEnabledInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get developerPortalUrl(): string;
    private _gatewayDisabled?;
    /**
     * @stability stable
     */
    get gatewayDisabled(): boolean;
    /**
     * @stability stable
     */
    set gatewayDisabled(value: boolean);
    /**
     * @stability stable
     */
    resetGatewayDisabled(): void;
    /**
     * @stability stable
     */
    get gatewayDisabledInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get gatewayRegionalUrl(): string;
    /**
     * @stability stable
     */
    get gatewayUrl(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _location;
    /**
     * @stability stable
     */
    get location(): string;
    /**
     * @stability stable
     */
    set location(value: string);
    /**
     * @stability stable
     */
    get locationInput(): string;
    /**
     * @stability stable
     */
    get managementApiUrl(): string;
    private _minApiVersion?;
    /**
     * @stability stable
     */
    get minApiVersion(): string;
    /**
     * @stability stable
     */
    set minApiVersion(value: string);
    /**
     * @stability stable
     */
    resetMinApiVersion(): void;
    /**
     * @stability stable
     */
    get minApiVersionInput(): string | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _notificationSenderEmail?;
    /**
     * @stability stable
     */
    get notificationSenderEmail(): string;
    /**
     * @stability stable
     */
    set notificationSenderEmail(value: string);
    /**
     * @stability stable
     */
    resetNotificationSenderEmail(): void;
    /**
     * @stability stable
     */
    get notificationSenderEmailInput(): string | undefined;
    private _policy?;
    /**
     * @stability stable
     */
    get policy(): ApiManagementPolicy[];
    /**
     * @stability stable
     */
    set policy(value: ApiManagementPolicy[]);
    /**
     * @stability stable
     */
    resetPolicy(): void;
    /**
     * @stability stable
     */
    get policyInput(): ApiManagementPolicy[] | undefined;
    /**
     * @stability stable
     */
    get portalUrl(): string;
    /**
     * @stability stable
     */
    get privateIpAddresses(): string[];
    /**
     * @stability stable
     */
    get publicIpAddresses(): string[];
    private _publisherEmail;
    /**
     * @stability stable
     */
    get publisherEmail(): string;
    /**
     * @stability stable
     */
    set publisherEmail(value: string);
    /**
     * @stability stable
     */
    get publisherEmailInput(): string;
    private _publisherName;
    /**
     * @stability stable
     */
    get publisherName(): string;
    /**
     * @stability stable
     */
    set publisherName(value: string);
    /**
     * @stability stable
     */
    get publisherNameInput(): string;
    private _resourceGroupName;
    /**
     * @stability stable
     */
    get resourceGroupName(): string;
    /**
     * @stability stable
     */
    set resourceGroupName(value: string);
    /**
     * @stability stable
     */
    get resourceGroupNameInput(): string;
    /**
     * @stability stable
     */
    get scmUrl(): string;
    private _skuName;
    /**
     * @stability stable
     */
    get skuName(): string;
    /**
     * @stability stable
     */
    set skuName(value: string);
    /**
     * @stability stable
     */
    get skuNameInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _virtualNetworkType?;
    /**
     * @stability stable
     */
    get virtualNetworkType(): string;
    /**
     * @stability stable
     */
    set virtualNetworkType(value: string);
    /**
     * @stability stable
     */
    resetVirtualNetworkType(): void;
    /**
     * @stability stable
     */
    get virtualNetworkTypeInput(): string | undefined;
    private _zones?;
    /**
     * @stability stable
     */
    get zones(): string[];
    /**
     * @stability stable
     */
    set zones(value: string[]);
    /**
     * @stability stable
     */
    resetZones(): void;
    /**
     * @stability stable
     */
    get zonesInput(): string[] | undefined;
    private _additionalLocation?;
    /**
     * @stability stable
     */
    get additionalLocation(): ApiManagementAdditionalLocation[];
    /**
     * @stability stable
     */
    set additionalLocation(value: ApiManagementAdditionalLocation[]);
    /**
     * @stability stable
     */
    resetAdditionalLocation(): void;
    /**
     * @stability stable
     */
    get additionalLocationInput(): ApiManagementAdditionalLocation[] | undefined;
    private _certificate?;
    /**
     * @stability stable
     */
    get certificate(): ApiManagementCertificate[];
    /**
     * @stability stable
     */
    set certificate(value: ApiManagementCertificate[]);
    /**
     * @stability stable
     */
    resetCertificate(): void;
    /**
     * @stability stable
     */
    get certificateInput(): ApiManagementCertificate[] | undefined;
    private _hostnameConfiguration?;
    /**
     * @stability stable
     */
    get hostnameConfiguration(): ApiManagementHostnameConfiguration[];
    /**
     * @stability stable
     */
    set hostnameConfiguration(value: ApiManagementHostnameConfiguration[]);
    /**
     * @stability stable
     */
    resetHostnameConfiguration(): void;
    /**
     * @stability stable
     */
    get hostnameConfigurationInput(): ApiManagementHostnameConfiguration[] | undefined;
    private _identity?;
    /**
     * @stability stable
     */
    get identity(): ApiManagementIdentity[];
    /**
     * @stability stable
     */
    set identity(value: ApiManagementIdentity[]);
    /**
     * @stability stable
     */
    resetIdentity(): void;
    /**
     * @stability stable
     */
    get identityInput(): ApiManagementIdentity[] | undefined;
    private _protocols?;
    /**
     * @stability stable
     */
    get protocols(): ApiManagementProtocols[];
    /**
     * @stability stable
     */
    set protocols(value: ApiManagementProtocols[]);
    /**
     * @stability stable
     */
    resetProtocols(): void;
    /**
     * @stability stable
     */
    get protocolsInput(): ApiManagementProtocols[] | undefined;
    private _security?;
    /**
     * @stability stable
     */
    get security(): ApiManagementSecurity[];
    /**
     * @stability stable
     */
    set security(value: ApiManagementSecurity[]);
    /**
     * @stability stable
     */
    resetSecurity(): void;
    /**
     * @stability stable
     */
    get securityInput(): ApiManagementSecurity[] | undefined;
    private _signIn?;
    /**
     * @stability stable
     */
    get signIn(): ApiManagementSignIn[];
    /**
     * @stability stable
     */
    set signIn(value: ApiManagementSignIn[]);
    /**
     * @stability stable
     */
    resetSignIn(): void;
    /**
     * @stability stable
     */
    get signInInput(): ApiManagementSignIn[] | undefined;
    private _signUp?;
    /**
     * @stability stable
     */
    get signUp(): ApiManagementSignUp[];
    /**
     * @stability stable
     */
    set signUp(value: ApiManagementSignUp[]);
    /**
     * @stability stable
     */
    resetSignUp(): void;
    /**
     * @stability stable
     */
    get signUpInput(): ApiManagementSignUp[] | undefined;
    private _tenantAccess?;
    /**
     * @stability stable
     */
    get tenantAccess(): ApiManagementTenantAccess[];
    /**
     * @stability stable
     */
    set tenantAccess(value: ApiManagementTenantAccess[]);
    /**
     * @stability stable
     */
    resetTenantAccess(): void;
    /**
     * @stability stable
     */
    get tenantAccessInput(): ApiManagementTenantAccess[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): ApiManagementTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: ApiManagementTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): ApiManagementTimeouts | undefined;
    private _virtualNetworkConfiguration?;
    /**
     * @stability stable
     */
    get virtualNetworkConfiguration(): ApiManagementVirtualNetworkConfiguration[];
    /**
     * @stability stable
     */
    set virtualNetworkConfiguration(value: ApiManagementVirtualNetworkConfiguration[]);
    /**
     * @stability stable
     */
    resetVirtualNetworkConfiguration(): void;
    /**
     * @stability stable
     */
    get virtualNetworkConfigurationInput(): ApiManagementVirtualNetworkConfiguration[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
