import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CdnEndpointConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#content_types_to_compress CdnEndpoint#content_types_to_compress}.
     *
     * @stability stable
     */
    readonly contentTypesToCompress?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#is_compression_enabled CdnEndpoint#is_compression_enabled}.
     *
     * @stability stable
     */
    readonly isCompressionEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#is_http_allowed CdnEndpoint#is_http_allowed}.
     *
     * @stability stable
     */
    readonly isHttpAllowed?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#is_https_allowed CdnEndpoint#is_https_allowed}.
     *
     * @stability stable
     */
    readonly isHttpsAllowed?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#location CdnEndpoint#location}.
     *
     * @stability stable
     */
    readonly location: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#name CdnEndpoint#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#optimization_type CdnEndpoint#optimization_type}.
     *
     * @stability stable
     */
    readonly optimizationType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#origin_host_header CdnEndpoint#origin_host_header}.
     *
     * @stability stable
     */
    readonly originHostHeader?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#origin_path CdnEndpoint#origin_path}.
     *
     * @stability stable
     */
    readonly originPath?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#probe_path CdnEndpoint#probe_path}.
     *
     * @stability stable
     */
    readonly probePath?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#profile_name CdnEndpoint#profile_name}.
     *
     * @stability stable
     */
    readonly profileName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#querystring_caching_behaviour CdnEndpoint#querystring_caching_behaviour}.
     *
     * @stability stable
     */
    readonly querystringCachingBehaviour?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#resource_group_name CdnEndpoint#resource_group_name}.
     *
     * @stability stable
     */
    readonly resourceGroupName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#tags CdnEndpoint#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * delivery_rule block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#delivery_rule CdnEndpoint#delivery_rule}
     *
     * @stability stable
     */
    readonly deliveryRule?: CdnEndpointDeliveryRule[];
    /**
     * geo_filter block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#geo_filter CdnEndpoint#geo_filter}
     *
     * @stability stable
     */
    readonly geoFilter?: CdnEndpointGeoFilter[];
    /**
     * global_delivery_rule block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#global_delivery_rule CdnEndpoint#global_delivery_rule}
     *
     * @stability stable
     */
    readonly globalDeliveryRule?: CdnEndpointGlobalDeliveryRule[];
    /**
     * origin block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#origin CdnEndpoint#origin}
     *
     * @stability stable
     */
    readonly origin: CdnEndpointOrigin[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#timeouts CdnEndpoint#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: CdnEndpointTimeouts;
}
/**
 * @stability stable
 */
export interface CdnEndpointDeliveryRuleCacheExpirationAction {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#behavior CdnEndpoint#behavior}.
     *
     * @stability stable
     */
    readonly behavior: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#duration CdnEndpoint#duration}.
     *
     * @stability stable
     */
    readonly duration?: string;
}
/**
 * @stability stable
 */
export interface CdnEndpointDeliveryRuleCacheKeyQueryStringAction {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#behavior CdnEndpoint#behavior}.
     *
     * @stability stable
     */
    readonly behavior: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#parameters CdnEndpoint#parameters}.
     *
     * @stability stable
     */
    readonly parameters?: string;
}
/**
 * @stability stable
 */
export interface CdnEndpointDeliveryRuleCookiesCondition {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#match_values CdnEndpoint#match_values}.
     *
     * @stability stable
     */
    readonly matchValues?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#negate_condition CdnEndpoint#negate_condition}.
     *
     * @stability stable
     */
    readonly negateCondition?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#operator CdnEndpoint#operator}.
     *
     * @stability stable
     */
    readonly operator: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#selector CdnEndpoint#selector}.
     *
     * @stability stable
     */
    readonly selector: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#transforms CdnEndpoint#transforms}.
     *
     * @stability stable
     */
    readonly transforms?: string[];
}
/**
 * @stability stable
 */
export interface CdnEndpointDeliveryRuleDeviceCondition {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#match_values CdnEndpoint#match_values}.
     *
     * @stability stable
     */
    readonly matchValues: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#negate_condition CdnEndpoint#negate_condition}.
     *
     * @stability stable
     */
    readonly negateCondition?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#operator CdnEndpoint#operator}.
     *
     * @stability stable
     */
    readonly operator?: string;
}
/**
 * @stability stable
 */
export interface CdnEndpointDeliveryRuleHttpVersionCondition {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#match_values CdnEndpoint#match_values}.
     *
     * @stability stable
     */
    readonly matchValues: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#negate_condition CdnEndpoint#negate_condition}.
     *
     * @stability stable
     */
    readonly negateCondition?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#operator CdnEndpoint#operator}.
     *
     * @stability stable
     */
    readonly operator?: string;
}
/**
 * @stability stable
 */
export interface CdnEndpointDeliveryRuleModifyRequestHeaderAction {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#action CdnEndpoint#action}.
     *
     * @stability stable
     */
    readonly action: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#name CdnEndpoint#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#value CdnEndpoint#value}.
     *
     * @stability stable
     */
    readonly value?: string;
}
/**
 * @stability stable
 */
export interface CdnEndpointDeliveryRuleModifyResponseHeaderAction {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#action CdnEndpoint#action}.
     *
     * @stability stable
     */
    readonly action: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#name CdnEndpoint#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#value CdnEndpoint#value}.
     *
     * @stability stable
     */
    readonly value?: string;
}
/**
 * @stability stable
 */
export interface CdnEndpointDeliveryRulePostArgCondition {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#match_values CdnEndpoint#match_values}.
     *
     * @stability stable
     */
    readonly matchValues?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#negate_condition CdnEndpoint#negate_condition}.
     *
     * @stability stable
     */
    readonly negateCondition?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#operator CdnEndpoint#operator}.
     *
     * @stability stable
     */
    readonly operator: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#selector CdnEndpoint#selector}.
     *
     * @stability stable
     */
    readonly selector: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#transforms CdnEndpoint#transforms}.
     *
     * @stability stable
     */
    readonly transforms?: string[];
}
/**
 * @stability stable
 */
export interface CdnEndpointDeliveryRuleQueryStringCondition {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#match_values CdnEndpoint#match_values}.
     *
     * @stability stable
     */
    readonly matchValues?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#negate_condition CdnEndpoint#negate_condition}.
     *
     * @stability stable
     */
    readonly negateCondition?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#operator CdnEndpoint#operator}.
     *
     * @stability stable
     */
    readonly operator: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#transforms CdnEndpoint#transforms}.
     *
     * @stability stable
     */
    readonly transforms?: string[];
}
/**
 * @stability stable
 */
export interface CdnEndpointDeliveryRuleRemoteAddressCondition {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#match_values CdnEndpoint#match_values}.
     *
     * @stability stable
     */
    readonly matchValues?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#negate_condition CdnEndpoint#negate_condition}.
     *
     * @stability stable
     */
    readonly negateCondition?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#operator CdnEndpoint#operator}.
     *
     * @stability stable
     */
    readonly operator: string;
}
/**
 * @stability stable
 */
export interface CdnEndpointDeliveryRuleRequestBodyCondition {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#match_values CdnEndpoint#match_values}.
     *
     * @stability stable
     */
    readonly matchValues?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#negate_condition CdnEndpoint#negate_condition}.
     *
     * @stability stable
     */
    readonly negateCondition?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#operator CdnEndpoint#operator}.
     *
     * @stability stable
     */
    readonly operator: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#transforms CdnEndpoint#transforms}.
     *
     * @stability stable
     */
    readonly transforms?: string[];
}
/**
 * @stability stable
 */
export interface CdnEndpointDeliveryRuleRequestHeaderCondition {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#match_values CdnEndpoint#match_values}.
     *
     * @stability stable
     */
    readonly matchValues?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#negate_condition CdnEndpoint#negate_condition}.
     *
     * @stability stable
     */
    readonly negateCondition?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#operator CdnEndpoint#operator}.
     *
     * @stability stable
     */
    readonly operator: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#selector CdnEndpoint#selector}.
     *
     * @stability stable
     */
    readonly selector: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#transforms CdnEndpoint#transforms}.
     *
     * @stability stable
     */
    readonly transforms?: string[];
}
/**
 * @stability stable
 */
export interface CdnEndpointDeliveryRuleRequestMethodCondition {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#match_values CdnEndpoint#match_values}.
     *
     * @stability stable
     */
    readonly matchValues: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#negate_condition CdnEndpoint#negate_condition}.
     *
     * @stability stable
     */
    readonly negateCondition?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#operator CdnEndpoint#operator}.
     *
     * @stability stable
     */
    readonly operator?: string;
}
/**
 * @stability stable
 */
export interface CdnEndpointDeliveryRuleRequestSchemeCondition {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#match_values CdnEndpoint#match_values}.
     *
     * @stability stable
     */
    readonly matchValues: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#negate_condition CdnEndpoint#negate_condition}.
     *
     * @stability stable
     */
    readonly negateCondition?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#operator CdnEndpoint#operator}.
     *
     * @stability stable
     */
    readonly operator?: string;
}
/**
 * @stability stable
 */
export interface CdnEndpointDeliveryRuleRequestUriCondition {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#match_values CdnEndpoint#match_values}.
     *
     * @stability stable
     */
    readonly matchValues?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#negate_condition CdnEndpoint#negate_condition}.
     *
     * @stability stable
     */
    readonly negateCondition?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#operator CdnEndpoint#operator}.
     *
     * @stability stable
     */
    readonly operator: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#transforms CdnEndpoint#transforms}.
     *
     * @stability stable
     */
    readonly transforms?: string[];
}
/**
 * @stability stable
 */
export interface CdnEndpointDeliveryRuleUrlFileExtensionCondition {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#match_values CdnEndpoint#match_values}.
     *
     * @stability stable
     */
    readonly matchValues?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#negate_condition CdnEndpoint#negate_condition}.
     *
     * @stability stable
     */
    readonly negateCondition?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#operator CdnEndpoint#operator}.
     *
     * @stability stable
     */
    readonly operator: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#transforms CdnEndpoint#transforms}.
     *
     * @stability stable
     */
    readonly transforms?: string[];
}
/**
 * @stability stable
 */
export interface CdnEndpointDeliveryRuleUrlFileNameCondition {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#match_values CdnEndpoint#match_values}.
     *
     * @stability stable
     */
    readonly matchValues?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#negate_condition CdnEndpoint#negate_condition}.
     *
     * @stability stable
     */
    readonly negateCondition?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#operator CdnEndpoint#operator}.
     *
     * @stability stable
     */
    readonly operator: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#transforms CdnEndpoint#transforms}.
     *
     * @stability stable
     */
    readonly transforms?: string[];
}
/**
 * @stability stable
 */
export interface CdnEndpointDeliveryRuleUrlPathCondition {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#match_values CdnEndpoint#match_values}.
     *
     * @stability stable
     */
    readonly matchValues?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#negate_condition CdnEndpoint#negate_condition}.
     *
     * @stability stable
     */
    readonly negateCondition?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#operator CdnEndpoint#operator}.
     *
     * @stability stable
     */
    readonly operator: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#transforms CdnEndpoint#transforms}.
     *
     * @stability stable
     */
    readonly transforms?: string[];
}
/**
 * @stability stable
 */
export interface CdnEndpointDeliveryRuleUrlRedirectAction {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#fragment CdnEndpoint#fragment}.
     *
     * @stability stable
     */
    readonly fragment?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#hostname CdnEndpoint#hostname}.
     *
     * @stability stable
     */
    readonly hostname?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#path CdnEndpoint#path}.
     *
     * @stability stable
     */
    readonly path?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#protocol CdnEndpoint#protocol}.
     *
     * @stability stable
     */
    readonly protocol?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#query_string CdnEndpoint#query_string}.
     *
     * @stability stable
     */
    readonly queryString?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#redirect_type CdnEndpoint#redirect_type}.
     *
     * @stability stable
     */
    readonly redirectType: string;
}
/**
 * @stability stable
 */
export interface CdnEndpointDeliveryRuleUrlRewriteAction {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#destination CdnEndpoint#destination}.
     *
     * @stability stable
     */
    readonly destination: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#preserve_unmatched_path CdnEndpoint#preserve_unmatched_path}.
     *
     * @stability stable
     */
    readonly preserveUnmatchedPath?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#source_pattern CdnEndpoint#source_pattern}.
     *
     * @stability stable
     */
    readonly sourcePattern: string;
}
/**
 * @stability stable
 */
export interface CdnEndpointDeliveryRule {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#name CdnEndpoint#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#order CdnEndpoint#order}.
     *
     * @stability stable
     */
    readonly order: number;
    /**
     * cache_expiration_action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#cache_expiration_action CdnEndpoint#cache_expiration_action}
     *
     * @stability stable
     */
    readonly cacheExpirationAction?: CdnEndpointDeliveryRuleCacheExpirationAction[];
    /**
     * cache_key_query_string_action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#cache_key_query_string_action CdnEndpoint#cache_key_query_string_action}
     *
     * @stability stable
     */
    readonly cacheKeyQueryStringAction?: CdnEndpointDeliveryRuleCacheKeyQueryStringAction[];
    /**
     * cookies_condition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#cookies_condition CdnEndpoint#cookies_condition}
     *
     * @stability stable
     */
    readonly cookiesCondition?: CdnEndpointDeliveryRuleCookiesCondition[];
    /**
     * device_condition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#device_condition CdnEndpoint#device_condition}
     *
     * @stability stable
     */
    readonly deviceCondition?: CdnEndpointDeliveryRuleDeviceCondition[];
    /**
     * http_version_condition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#http_version_condition CdnEndpoint#http_version_condition}
     *
     * @stability stable
     */
    readonly httpVersionCondition?: CdnEndpointDeliveryRuleHttpVersionCondition[];
    /**
     * modify_request_header_action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#modify_request_header_action CdnEndpoint#modify_request_header_action}
     *
     * @stability stable
     */
    readonly modifyRequestHeaderAction?: CdnEndpointDeliveryRuleModifyRequestHeaderAction[];
    /**
     * modify_response_header_action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#modify_response_header_action CdnEndpoint#modify_response_header_action}
     *
     * @stability stable
     */
    readonly modifyResponseHeaderAction?: CdnEndpointDeliveryRuleModifyResponseHeaderAction[];
    /**
     * post_arg_condition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#post_arg_condition CdnEndpoint#post_arg_condition}
     *
     * @stability stable
     */
    readonly postArgCondition?: CdnEndpointDeliveryRulePostArgCondition[];
    /**
     * query_string_condition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#query_string_condition CdnEndpoint#query_string_condition}
     *
     * @stability stable
     */
    readonly queryStringCondition?: CdnEndpointDeliveryRuleQueryStringCondition[];
    /**
     * remote_address_condition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#remote_address_condition CdnEndpoint#remote_address_condition}
     *
     * @stability stable
     */
    readonly remoteAddressCondition?: CdnEndpointDeliveryRuleRemoteAddressCondition[];
    /**
     * request_body_condition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#request_body_condition CdnEndpoint#request_body_condition}
     *
     * @stability stable
     */
    readonly requestBodyCondition?: CdnEndpointDeliveryRuleRequestBodyCondition[];
    /**
     * request_header_condition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#request_header_condition CdnEndpoint#request_header_condition}
     *
     * @stability stable
     */
    readonly requestHeaderCondition?: CdnEndpointDeliveryRuleRequestHeaderCondition[];
    /**
     * request_method_condition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#request_method_condition CdnEndpoint#request_method_condition}
     *
     * @stability stable
     */
    readonly requestMethodCondition?: CdnEndpointDeliveryRuleRequestMethodCondition[];
    /**
     * request_scheme_condition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#request_scheme_condition CdnEndpoint#request_scheme_condition}
     *
     * @stability stable
     */
    readonly requestSchemeCondition?: CdnEndpointDeliveryRuleRequestSchemeCondition[];
    /**
     * request_uri_condition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#request_uri_condition CdnEndpoint#request_uri_condition}
     *
     * @stability stable
     */
    readonly requestUriCondition?: CdnEndpointDeliveryRuleRequestUriCondition[];
    /**
     * url_file_extension_condition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#url_file_extension_condition CdnEndpoint#url_file_extension_condition}
     *
     * @stability stable
     */
    readonly urlFileExtensionCondition?: CdnEndpointDeliveryRuleUrlFileExtensionCondition[];
    /**
     * url_file_name_condition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#url_file_name_condition CdnEndpoint#url_file_name_condition}
     *
     * @stability stable
     */
    readonly urlFileNameCondition?: CdnEndpointDeliveryRuleUrlFileNameCondition[];
    /**
     * url_path_condition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#url_path_condition CdnEndpoint#url_path_condition}
     *
     * @stability stable
     */
    readonly urlPathCondition?: CdnEndpointDeliveryRuleUrlPathCondition[];
    /**
     * url_redirect_action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#url_redirect_action CdnEndpoint#url_redirect_action}
     *
     * @stability stable
     */
    readonly urlRedirectAction?: CdnEndpointDeliveryRuleUrlRedirectAction[];
    /**
     * url_rewrite_action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#url_rewrite_action CdnEndpoint#url_rewrite_action}
     *
     * @stability stable
     */
    readonly urlRewriteAction?: CdnEndpointDeliveryRuleUrlRewriteAction[];
}
/**
 * @stability stable
 */
export interface CdnEndpointGeoFilter {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#action CdnEndpoint#action}.
     *
     * @stability stable
     */
    readonly action: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#country_codes CdnEndpoint#country_codes}.
     *
     * @stability stable
     */
    readonly countryCodes: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#relative_path CdnEndpoint#relative_path}.
     *
     * @stability stable
     */
    readonly relativePath: string;
}
/**
 * @stability stable
 */
export interface CdnEndpointGlobalDeliveryRuleCacheExpirationAction {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#behavior CdnEndpoint#behavior}.
     *
     * @stability stable
     */
    readonly behavior: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#duration CdnEndpoint#duration}.
     *
     * @stability stable
     */
    readonly duration?: string;
}
/**
 * @stability stable
 */
export interface CdnEndpointGlobalDeliveryRuleCacheKeyQueryStringAction {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#behavior CdnEndpoint#behavior}.
     *
     * @stability stable
     */
    readonly behavior: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#parameters CdnEndpoint#parameters}.
     *
     * @stability stable
     */
    readonly parameters?: string;
}
/**
 * @stability stable
 */
export interface CdnEndpointGlobalDeliveryRuleModifyRequestHeaderAction {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#action CdnEndpoint#action}.
     *
     * @stability stable
     */
    readonly action: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#name CdnEndpoint#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#value CdnEndpoint#value}.
     *
     * @stability stable
     */
    readonly value?: string;
}
/**
 * @stability stable
 */
export interface CdnEndpointGlobalDeliveryRuleModifyResponseHeaderAction {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#action CdnEndpoint#action}.
     *
     * @stability stable
     */
    readonly action: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#name CdnEndpoint#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#value CdnEndpoint#value}.
     *
     * @stability stable
     */
    readonly value?: string;
}
/**
 * @stability stable
 */
export interface CdnEndpointGlobalDeliveryRuleUrlRedirectAction {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#fragment CdnEndpoint#fragment}.
     *
     * @stability stable
     */
    readonly fragment?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#hostname CdnEndpoint#hostname}.
     *
     * @stability stable
     */
    readonly hostname?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#path CdnEndpoint#path}.
     *
     * @stability stable
     */
    readonly path?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#protocol CdnEndpoint#protocol}.
     *
     * @stability stable
     */
    readonly protocol?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#query_string CdnEndpoint#query_string}.
     *
     * @stability stable
     */
    readonly queryString?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#redirect_type CdnEndpoint#redirect_type}.
     *
     * @stability stable
     */
    readonly redirectType: string;
}
/**
 * @stability stable
 */
export interface CdnEndpointGlobalDeliveryRuleUrlRewriteAction {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#destination CdnEndpoint#destination}.
     *
     * @stability stable
     */
    readonly destination: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#preserve_unmatched_path CdnEndpoint#preserve_unmatched_path}.
     *
     * @stability stable
     */
    readonly preserveUnmatchedPath?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#source_pattern CdnEndpoint#source_pattern}.
     *
     * @stability stable
     */
    readonly sourcePattern: string;
}
/**
 * @stability stable
 */
export interface CdnEndpointGlobalDeliveryRule {
    /**
     * cache_expiration_action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#cache_expiration_action CdnEndpoint#cache_expiration_action}
     *
     * @stability stable
     */
    readonly cacheExpirationAction?: CdnEndpointGlobalDeliveryRuleCacheExpirationAction[];
    /**
     * cache_key_query_string_action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#cache_key_query_string_action CdnEndpoint#cache_key_query_string_action}
     *
     * @stability stable
     */
    readonly cacheKeyQueryStringAction?: CdnEndpointGlobalDeliveryRuleCacheKeyQueryStringAction[];
    /**
     * modify_request_header_action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#modify_request_header_action CdnEndpoint#modify_request_header_action}
     *
     * @stability stable
     */
    readonly modifyRequestHeaderAction?: CdnEndpointGlobalDeliveryRuleModifyRequestHeaderAction[];
    /**
     * modify_response_header_action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#modify_response_header_action CdnEndpoint#modify_response_header_action}
     *
     * @stability stable
     */
    readonly modifyResponseHeaderAction?: CdnEndpointGlobalDeliveryRuleModifyResponseHeaderAction[];
    /**
     * url_redirect_action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#url_redirect_action CdnEndpoint#url_redirect_action}
     *
     * @stability stable
     */
    readonly urlRedirectAction?: CdnEndpointGlobalDeliveryRuleUrlRedirectAction[];
    /**
     * url_rewrite_action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#url_rewrite_action CdnEndpoint#url_rewrite_action}
     *
     * @stability stable
     */
    readonly urlRewriteAction?: CdnEndpointGlobalDeliveryRuleUrlRewriteAction[];
}
/**
 * @stability stable
 */
export interface CdnEndpointOrigin {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#host_name CdnEndpoint#host_name}.
     *
     * @stability stable
     */
    readonly hostName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#http_port CdnEndpoint#http_port}.
     *
     * @stability stable
     */
    readonly httpPort?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#https_port CdnEndpoint#https_port}.
     *
     * @stability stable
     */
    readonly httpsPort?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#name CdnEndpoint#name}.
     *
     * @stability stable
     */
    readonly name: string;
}
/**
 * @stability stable
 */
export interface CdnEndpointTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#create CdnEndpoint#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#delete CdnEndpoint#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#read CdnEndpoint#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html#update CdnEndpoint#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html azurerm_cdn_endpoint}.
 *
 * @stability stable
 */
export declare class CdnEndpoint extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/cdn_endpoint.html azurerm_cdn_endpoint} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CdnEndpointConfig);
    private _contentTypesToCompress?;
    /**
     * @stability stable
     */
    get contentTypesToCompress(): string[];
    /**
     * @stability stable
     */
    set contentTypesToCompress(value: string[]);
    /**
     * @stability stable
     */
    resetContentTypesToCompress(): void;
    /**
     * @stability stable
     */
    get contentTypesToCompressInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get hostName(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _isCompressionEnabled?;
    /**
     * @stability stable
     */
    get isCompressionEnabled(): boolean;
    /**
     * @stability stable
     */
    set isCompressionEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetIsCompressionEnabled(): void;
    /**
     * @stability stable
     */
    get isCompressionEnabledInput(): boolean | undefined;
    private _isHttpAllowed?;
    /**
     * @stability stable
     */
    get isHttpAllowed(): boolean;
    /**
     * @stability stable
     */
    set isHttpAllowed(value: boolean);
    /**
     * @stability stable
     */
    resetIsHttpAllowed(): void;
    /**
     * @stability stable
     */
    get isHttpAllowedInput(): boolean | undefined;
    private _isHttpsAllowed?;
    /**
     * @stability stable
     */
    get isHttpsAllowed(): boolean;
    /**
     * @stability stable
     */
    set isHttpsAllowed(value: boolean);
    /**
     * @stability stable
     */
    resetIsHttpsAllowed(): void;
    /**
     * @stability stable
     */
    get isHttpsAllowedInput(): boolean | undefined;
    private _location;
    /**
     * @stability stable
     */
    get location(): string;
    /**
     * @stability stable
     */
    set location(value: string);
    /**
     * @stability stable
     */
    get locationInput(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _optimizationType?;
    /**
     * @stability stable
     */
    get optimizationType(): string;
    /**
     * @stability stable
     */
    set optimizationType(value: string);
    /**
     * @stability stable
     */
    resetOptimizationType(): void;
    /**
     * @stability stable
     */
    get optimizationTypeInput(): string | undefined;
    private _originHostHeader?;
    /**
     * @stability stable
     */
    get originHostHeader(): string;
    /**
     * @stability stable
     */
    set originHostHeader(value: string);
    /**
     * @stability stable
     */
    resetOriginHostHeader(): void;
    /**
     * @stability stable
     */
    get originHostHeaderInput(): string | undefined;
    private _originPath?;
    /**
     * @stability stable
     */
    get originPath(): string;
    /**
     * @stability stable
     */
    set originPath(value: string);
    /**
     * @stability stable
     */
    resetOriginPath(): void;
    /**
     * @stability stable
     */
    get originPathInput(): string | undefined;
    private _probePath?;
    /**
     * @stability stable
     */
    get probePath(): string;
    /**
     * @stability stable
     */
    set probePath(value: string);
    /**
     * @stability stable
     */
    resetProbePath(): void;
    /**
     * @stability stable
     */
    get probePathInput(): string | undefined;
    private _profileName;
    /**
     * @stability stable
     */
    get profileName(): string;
    /**
     * @stability stable
     */
    set profileName(value: string);
    /**
     * @stability stable
     */
    get profileNameInput(): string;
    private _querystringCachingBehaviour?;
    /**
     * @stability stable
     */
    get querystringCachingBehaviour(): string;
    /**
     * @stability stable
     */
    set querystringCachingBehaviour(value: string);
    /**
     * @stability stable
     */
    resetQuerystringCachingBehaviour(): void;
    /**
     * @stability stable
     */
    get querystringCachingBehaviourInput(): string | undefined;
    private _resourceGroupName;
    /**
     * @stability stable
     */
    get resourceGroupName(): string;
    /**
     * @stability stable
     */
    set resourceGroupName(value: string);
    /**
     * @stability stable
     */
    get resourceGroupNameInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _deliveryRule?;
    /**
     * @stability stable
     */
    get deliveryRule(): CdnEndpointDeliveryRule[];
    /**
     * @stability stable
     */
    set deliveryRule(value: CdnEndpointDeliveryRule[]);
    /**
     * @stability stable
     */
    resetDeliveryRule(): void;
    /**
     * @stability stable
     */
    get deliveryRuleInput(): CdnEndpointDeliveryRule[] | undefined;
    private _geoFilter?;
    /**
     * @stability stable
     */
    get geoFilter(): CdnEndpointGeoFilter[];
    /**
     * @stability stable
     */
    set geoFilter(value: CdnEndpointGeoFilter[]);
    /**
     * @stability stable
     */
    resetGeoFilter(): void;
    /**
     * @stability stable
     */
    get geoFilterInput(): CdnEndpointGeoFilter[] | undefined;
    private _globalDeliveryRule?;
    /**
     * @stability stable
     */
    get globalDeliveryRule(): CdnEndpointGlobalDeliveryRule[];
    /**
     * @stability stable
     */
    set globalDeliveryRule(value: CdnEndpointGlobalDeliveryRule[]);
    /**
     * @stability stable
     */
    resetGlobalDeliveryRule(): void;
    /**
     * @stability stable
     */
    get globalDeliveryRuleInput(): CdnEndpointGlobalDeliveryRule[] | undefined;
    private _origin;
    /**
     * @stability stable
     */
    get origin(): CdnEndpointOrigin[];
    /**
     * @stability stable
     */
    set origin(value: CdnEndpointOrigin[]);
    /**
     * @stability stable
     */
    get originInput(): CdnEndpointOrigin[];
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): CdnEndpointTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: CdnEndpointTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): CdnEndpointTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
