import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CosmosdbAccountConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#access_key_metadata_writes_enabled CosmosdbAccount#access_key_metadata_writes_enabled}.
     *
     * @stability stable
     */
    readonly accessKeyMetadataWritesEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#analytical_storage_enabled CosmosdbAccount#analytical_storage_enabled}.
     *
     * @stability stable
     */
    readonly analyticalStorageEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#enable_automatic_failover CosmosdbAccount#enable_automatic_failover}.
     *
     * @stability stable
     */
    readonly enableAutomaticFailover?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#enable_free_tier CosmosdbAccount#enable_free_tier}.
     *
     * @stability stable
     */
    readonly enableFreeTier?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#enable_multiple_write_locations CosmosdbAccount#enable_multiple_write_locations}.
     *
     * @stability stable
     */
    readonly enableMultipleWriteLocations?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#ip_range_filter CosmosdbAccount#ip_range_filter}.
     *
     * @stability stable
     */
    readonly ipRangeFilter?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#is_virtual_network_filter_enabled CosmosdbAccount#is_virtual_network_filter_enabled}.
     *
     * @stability stable
     */
    readonly isVirtualNetworkFilterEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#key_vault_key_id CosmosdbAccount#key_vault_key_id}.
     *
     * @stability stable
     */
    readonly keyVaultKeyId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#kind CosmosdbAccount#kind}.
     *
     * @stability stable
     */
    readonly kind?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#location CosmosdbAccount#location}.
     *
     * @stability stable
     */
    readonly location: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#mongo_server_version CosmosdbAccount#mongo_server_version}.
     *
     * @stability stable
     */
    readonly mongoServerVersion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#name CosmosdbAccount#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#network_acl_bypass_for_azure_services CosmosdbAccount#network_acl_bypass_for_azure_services}.
     *
     * @stability stable
     */
    readonly networkAclBypassForAzureServices?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#network_acl_bypass_ids CosmosdbAccount#network_acl_bypass_ids}.
     *
     * @stability stable
     */
    readonly networkAclBypassIds?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#offer_type CosmosdbAccount#offer_type}.
     *
     * @stability stable
     */
    readonly offerType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#public_network_access_enabled CosmosdbAccount#public_network_access_enabled}.
     *
     * @stability stable
     */
    readonly publicNetworkAccessEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#resource_group_name CosmosdbAccount#resource_group_name}.
     *
     * @stability stable
     */
    readonly resourceGroupName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#tags CosmosdbAccount#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * backup block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#backup CosmosdbAccount#backup}
     *
     * @stability stable
     */
    readonly backup?: CosmosdbAccountBackup[];
    /**
     * capabilities block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#capabilities CosmosdbAccount#capabilities}
     *
     * @stability stable
     */
    readonly capabilities?: CosmosdbAccountCapabilities[];
    /**
     * consistency_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#consistency_policy CosmosdbAccount#consistency_policy}
     *
     * @stability stable
     */
    readonly consistencyPolicy: CosmosdbAccountConsistencyPolicy[];
    /**
     * cors_rule block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#cors_rule CosmosdbAccount#cors_rule}
     *
     * @stability stable
     */
    readonly corsRule?: CosmosdbAccountCorsRule[];
    /**
     * geo_location block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#geo_location CosmosdbAccount#geo_location}
     *
     * @stability stable
     */
    readonly geoLocation: CosmosdbAccountGeoLocation[];
    /**
     * identity block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#identity CosmosdbAccount#identity}
     *
     * @stability stable
     */
    readonly identity?: CosmosdbAccountIdentity[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#timeouts CosmosdbAccount#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: CosmosdbAccountTimeouts;
    /**
     * virtual_network_rule block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#virtual_network_rule CosmosdbAccount#virtual_network_rule}
     *
     * @stability stable
     */
    readonly virtualNetworkRule?: CosmosdbAccountVirtualNetworkRule[];
}
/**
 * @stability stable
 */
export interface CosmosdbAccountBackup {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#interval_in_minutes CosmosdbAccount#interval_in_minutes}.
     *
     * @stability stable
     */
    readonly intervalInMinutes?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#retention_in_hours CosmosdbAccount#retention_in_hours}.
     *
     * @stability stable
     */
    readonly retentionInHours?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#type CosmosdbAccount#type}.
     *
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface CosmosdbAccountCapabilities {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#name CosmosdbAccount#name}.
     *
     * @stability stable
     */
    readonly name: string;
}
/**
 * @stability stable
 */
export interface CosmosdbAccountConsistencyPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#consistency_level CosmosdbAccount#consistency_level}.
     *
     * @stability stable
     */
    readonly consistencyLevel: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#max_interval_in_seconds CosmosdbAccount#max_interval_in_seconds}.
     *
     * @stability stable
     */
    readonly maxIntervalInSeconds?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#max_staleness_prefix CosmosdbAccount#max_staleness_prefix}.
     *
     * @stability stable
     */
    readonly maxStalenessPrefix?: number;
}
/**
 * @stability stable
 */
export interface CosmosdbAccountCorsRule {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#allowed_headers CosmosdbAccount#allowed_headers}.
     *
     * @stability stable
     */
    readonly allowedHeaders: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#allowed_methods CosmosdbAccount#allowed_methods}.
     *
     * @stability stable
     */
    readonly allowedMethods: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#allowed_origins CosmosdbAccount#allowed_origins}.
     *
     * @stability stable
     */
    readonly allowedOrigins: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#exposed_headers CosmosdbAccount#exposed_headers}.
     *
     * @stability stable
     */
    readonly exposedHeaders: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#max_age_in_seconds CosmosdbAccount#max_age_in_seconds}.
     *
     * @stability stable
     */
    readonly maxAgeInSeconds: number;
}
/**
 * @stability stable
 */
export interface CosmosdbAccountGeoLocation {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#failover_priority CosmosdbAccount#failover_priority}.
     *
     * @stability stable
     */
    readonly failoverPriority: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#location CosmosdbAccount#location}.
     *
     * @stability stable
     */
    readonly location: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#prefix CosmosdbAccount#prefix}.
     *
     * @stability stable
     */
    readonly prefix?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#zone_redundant CosmosdbAccount#zone_redundant}.
     *
     * @stability stable
     */
    readonly zoneRedundant?: boolean;
}
/**
 * @stability stable
 */
export interface CosmosdbAccountIdentity {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#type CosmosdbAccount#type}.
     *
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface CosmosdbAccountTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#create CosmosdbAccount#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#delete CosmosdbAccount#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#read CosmosdbAccount#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#update CosmosdbAccount#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export interface CosmosdbAccountVirtualNetworkRule {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#id CosmosdbAccount#id}.
     *
     * @stability stable
     */
    readonly id: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html#ignore_missing_vnet_service_endpoint CosmosdbAccount#ignore_missing_vnet_service_endpoint}.
     *
     * @stability stable
     */
    readonly ignoreMissingVnetServiceEndpoint?: boolean;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html azurerm_cosmosdb_account}.
 *
 * @stability stable
 */
export declare class CosmosdbAccount extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_account.html azurerm_cosmosdb_account} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CosmosdbAccountConfig);
    private _accessKeyMetadataWritesEnabled?;
    /**
     * @stability stable
     */
    get accessKeyMetadataWritesEnabled(): boolean;
    /**
     * @stability stable
     */
    set accessKeyMetadataWritesEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetAccessKeyMetadataWritesEnabled(): void;
    /**
     * @stability stable
     */
    get accessKeyMetadataWritesEnabledInput(): boolean | undefined;
    private _analyticalStorageEnabled?;
    /**
     * @stability stable
     */
    get analyticalStorageEnabled(): boolean;
    /**
     * @stability stable
     */
    set analyticalStorageEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetAnalyticalStorageEnabled(): void;
    /**
     * @stability stable
     */
    get analyticalStorageEnabledInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get connectionStrings(): string[];
    private _enableAutomaticFailover?;
    /**
     * @stability stable
     */
    get enableAutomaticFailover(): boolean;
    /**
     * @stability stable
     */
    set enableAutomaticFailover(value: boolean);
    /**
     * @stability stable
     */
    resetEnableAutomaticFailover(): void;
    /**
     * @stability stable
     */
    get enableAutomaticFailoverInput(): boolean | undefined;
    private _enableFreeTier?;
    /**
     * @stability stable
     */
    get enableFreeTier(): boolean;
    /**
     * @stability stable
     */
    set enableFreeTier(value: boolean);
    /**
     * @stability stable
     */
    resetEnableFreeTier(): void;
    /**
     * @stability stable
     */
    get enableFreeTierInput(): boolean | undefined;
    private _enableMultipleWriteLocations?;
    /**
     * @stability stable
     */
    get enableMultipleWriteLocations(): boolean;
    /**
     * @stability stable
     */
    set enableMultipleWriteLocations(value: boolean);
    /**
     * @stability stable
     */
    resetEnableMultipleWriteLocations(): void;
    /**
     * @stability stable
     */
    get enableMultipleWriteLocationsInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get endpoint(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _ipRangeFilter?;
    /**
     * @stability stable
     */
    get ipRangeFilter(): string;
    /**
     * @stability stable
     */
    set ipRangeFilter(value: string);
    /**
     * @stability stable
     */
    resetIpRangeFilter(): void;
    /**
     * @stability stable
     */
    get ipRangeFilterInput(): string | undefined;
    private _isVirtualNetworkFilterEnabled?;
    /**
     * @stability stable
     */
    get isVirtualNetworkFilterEnabled(): boolean;
    /**
     * @stability stable
     */
    set isVirtualNetworkFilterEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetIsVirtualNetworkFilterEnabled(): void;
    /**
     * @stability stable
     */
    get isVirtualNetworkFilterEnabledInput(): boolean | undefined;
    private _keyVaultKeyId?;
    /**
     * @stability stable
     */
    get keyVaultKeyId(): string;
    /**
     * @stability stable
     */
    set keyVaultKeyId(value: string);
    /**
     * @stability stable
     */
    resetKeyVaultKeyId(): void;
    /**
     * @stability stable
     */
    get keyVaultKeyIdInput(): string | undefined;
    private _kind?;
    /**
     * @stability stable
     */
    get kind(): string;
    /**
     * @stability stable
     */
    set kind(value: string);
    /**
     * @stability stable
     */
    resetKind(): void;
    /**
     * @stability stable
     */
    get kindInput(): string | undefined;
    private _location;
    /**
     * @stability stable
     */
    get location(): string;
    /**
     * @stability stable
     */
    set location(value: string);
    /**
     * @stability stable
     */
    get locationInput(): string;
    private _mongoServerVersion?;
    /**
     * @stability stable
     */
    get mongoServerVersion(): string;
    /**
     * @stability stable
     */
    set mongoServerVersion(value: string);
    /**
     * @stability stable
     */
    resetMongoServerVersion(): void;
    /**
     * @stability stable
     */
    get mongoServerVersionInput(): string | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _networkAclBypassForAzureServices?;
    /**
     * @stability stable
     */
    get networkAclBypassForAzureServices(): boolean;
    /**
     * @stability stable
     */
    set networkAclBypassForAzureServices(value: boolean);
    /**
     * @stability stable
     */
    resetNetworkAclBypassForAzureServices(): void;
    /**
     * @stability stable
     */
    get networkAclBypassForAzureServicesInput(): boolean | undefined;
    private _networkAclBypassIds?;
    /**
     * @stability stable
     */
    get networkAclBypassIds(): string[];
    /**
     * @stability stable
     */
    set networkAclBypassIds(value: string[]);
    /**
     * @stability stable
     */
    resetNetworkAclBypassIds(): void;
    /**
     * @stability stable
     */
    get networkAclBypassIdsInput(): string[] | undefined;
    private _offerType;
    /**
     * @stability stable
     */
    get offerType(): string;
    /**
     * @stability stable
     */
    set offerType(value: string);
    /**
     * @stability stable
     */
    get offerTypeInput(): string;
    /**
     * @stability stable
     */
    get primaryKey(): string;
    /**
     * @stability stable
     */
    get primaryMasterKey(): string;
    /**
     * @stability stable
     */
    get primaryReadonlyKey(): string;
    /**
     * @stability stable
     */
    get primaryReadonlyMasterKey(): string;
    private _publicNetworkAccessEnabled?;
    /**
     * @stability stable
     */
    get publicNetworkAccessEnabled(): boolean;
    /**
     * @stability stable
     */
    set publicNetworkAccessEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetPublicNetworkAccessEnabled(): void;
    /**
     * @stability stable
     */
    get publicNetworkAccessEnabledInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get readEndpoints(): string[];
    private _resourceGroupName;
    /**
     * @stability stable
     */
    get resourceGroupName(): string;
    /**
     * @stability stable
     */
    set resourceGroupName(value: string);
    /**
     * @stability stable
     */
    get resourceGroupNameInput(): string;
    /**
     * @stability stable
     */
    get secondaryKey(): string;
    /**
     * @stability stable
     */
    get secondaryMasterKey(): string;
    /**
     * @stability stable
     */
    get secondaryReadonlyKey(): string;
    /**
     * @stability stable
     */
    get secondaryReadonlyMasterKey(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get writeEndpoints(): string[];
    private _backup?;
    /**
     * @stability stable
     */
    get backup(): CosmosdbAccountBackup[];
    /**
     * @stability stable
     */
    set backup(value: CosmosdbAccountBackup[]);
    /**
     * @stability stable
     */
    resetBackup(): void;
    /**
     * @stability stable
     */
    get backupInput(): CosmosdbAccountBackup[] | undefined;
    private _capabilities?;
    /**
     * @stability stable
     */
    get capabilities(): CosmosdbAccountCapabilities[];
    /**
     * @stability stable
     */
    set capabilities(value: CosmosdbAccountCapabilities[]);
    /**
     * @stability stable
     */
    resetCapabilities(): void;
    /**
     * @stability stable
     */
    get capabilitiesInput(): CosmosdbAccountCapabilities[] | undefined;
    private _consistencyPolicy;
    /**
     * @stability stable
     */
    get consistencyPolicy(): CosmosdbAccountConsistencyPolicy[];
    /**
     * @stability stable
     */
    set consistencyPolicy(value: CosmosdbAccountConsistencyPolicy[]);
    /**
     * @stability stable
     */
    get consistencyPolicyInput(): CosmosdbAccountConsistencyPolicy[];
    private _corsRule?;
    /**
     * @stability stable
     */
    get corsRule(): CosmosdbAccountCorsRule[];
    /**
     * @stability stable
     */
    set corsRule(value: CosmosdbAccountCorsRule[]);
    /**
     * @stability stable
     */
    resetCorsRule(): void;
    /**
     * @stability stable
     */
    get corsRuleInput(): CosmosdbAccountCorsRule[] | undefined;
    private _geoLocation;
    /**
     * @stability stable
     */
    get geoLocation(): CosmosdbAccountGeoLocation[];
    /**
     * @stability stable
     */
    set geoLocation(value: CosmosdbAccountGeoLocation[]);
    /**
     * @stability stable
     */
    get geoLocationInput(): CosmosdbAccountGeoLocation[];
    private _identity?;
    /**
     * @stability stable
     */
    get identity(): CosmosdbAccountIdentity[];
    /**
     * @stability stable
     */
    set identity(value: CosmosdbAccountIdentity[]);
    /**
     * @stability stable
     */
    resetIdentity(): void;
    /**
     * @stability stable
     */
    get identityInput(): CosmosdbAccountIdentity[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): CosmosdbAccountTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: CosmosdbAccountTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): CosmosdbAccountTimeouts | undefined;
    private _virtualNetworkRule?;
    /**
     * @stability stable
     */
    get virtualNetworkRule(): CosmosdbAccountVirtualNetworkRule[];
    /**
     * @stability stable
     */
    set virtualNetworkRule(value: CosmosdbAccountVirtualNetworkRule[]);
    /**
     * @stability stable
     */
    resetVirtualNetworkRule(): void;
    /**
     * @stability stable
     */
    get virtualNetworkRuleInput(): CosmosdbAccountVirtualNetworkRule[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
