import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAzurermAppServicePlanConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/app_service_plan.html#name DataAzurermAppServicePlan#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/app_service_plan.html#resource_group_name DataAzurermAppServicePlan#resource_group_name}.
     *
     * @stability stable
     */
    readonly resourceGroupName: string;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/app_service_plan.html#timeouts DataAzurermAppServicePlan#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: DataAzurermAppServicePlanTimeouts;
}
/**
 * @stability stable
 */
export declare class DataAzurermAppServicePlanSku extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get capacity(): number;
    /**
     * @stability stable
     */
    get size(): string;
    /**
     * @stability stable
     */
    get tier(): string;
}
/**
 * @stability stable
 */
export interface DataAzurermAppServicePlanTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/app_service_plan.html#read DataAzurermAppServicePlan#read}.
     *
     * @stability stable
     */
    readonly read?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/d/app_service_plan.html azurerm_app_service_plan}.
 *
 * @stability stable
 */
export declare class DataAzurermAppServicePlan extends cdktf.TerraformDataSource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/d/app_service_plan.html azurerm_app_service_plan} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAzurermAppServicePlanConfig);
    /**
     * @stability stable
     */
    get appServiceEnvironmentId(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get isXenon(): boolean;
    /**
     * @stability stable
     */
    get kind(): string;
    /**
     * @stability stable
     */
    get location(): string;
    /**
     * @stability stable
     */
    get maximumElasticWorkerCount(): number;
    /**
     * @stability stable
     */
    get maximumNumberOfWorkers(): number;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    /**
     * @stability stable
     */
    get perSiteScaling(): boolean;
    /**
     * @stability stable
     */
    get reserved(): boolean;
    private _resourceGroupName;
    /**
     * @stability stable
     */
    get resourceGroupName(): string;
    /**
     * @stability stable
     */
    set resourceGroupName(value: string);
    /**
     * @stability stable
     */
    get resourceGroupNameInput(): string;
    /**
     * @stability stable
     */
    sku(index: string): DataAzurermAppServicePlanSku;
    /**
     * @stability stable
     */
    tags(key: string): string;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): DataAzurermAppServicePlanTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: DataAzurermAppServicePlanTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): DataAzurermAppServicePlanTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
