import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAzurermBillingEnrollmentAccountScopeConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/billing_enrollment_account_scope.html#billing_account_name DataAzurermBillingEnrollmentAccountScope#billing_account_name}.
     *
     * @stability stable
     */
    readonly billingAccountName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/billing_enrollment_account_scope.html#enrollment_account_name DataAzurermBillingEnrollmentAccountScope#enrollment_account_name}.
     *
     * @stability stable
     */
    readonly enrollmentAccountName: string;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/billing_enrollment_account_scope.html#timeouts DataAzurermBillingEnrollmentAccountScope#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: DataAzurermBillingEnrollmentAccountScopeTimeouts;
}
/**
 * @stability stable
 */
export interface DataAzurermBillingEnrollmentAccountScopeTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/billing_enrollment_account_scope.html#read DataAzurermBillingEnrollmentAccountScope#read}.
     *
     * @stability stable
     */
    readonly read?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/d/billing_enrollment_account_scope.html azurerm_billing_enrollment_account_scope}.
 *
 * @stability stable
 */
export declare class DataAzurermBillingEnrollmentAccountScope extends cdktf.TerraformDataSource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/d/billing_enrollment_account_scope.html azurerm_billing_enrollment_account_scope} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAzurermBillingEnrollmentAccountScopeConfig);
    private _billingAccountName;
    /**
     * @stability stable
     */
    get billingAccountName(): string;
    /**
     * @stability stable
     */
    set billingAccountName(value: string);
    /**
     * @stability stable
     */
    get billingAccountNameInput(): string;
    private _enrollmentAccountName;
    /**
     * @stability stable
     */
    get enrollmentAccountName(): string;
    /**
     * @stability stable
     */
    set enrollmentAccountName(value: string);
    /**
     * @stability stable
     */
    get enrollmentAccountNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): DataAzurermBillingEnrollmentAccountScopeTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: DataAzurermBillingEnrollmentAccountScopeTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): DataAzurermBillingEnrollmentAccountScopeTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
