import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAzurermSnapshotConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/snapshot.html#name DataAzurermSnapshot#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/snapshot.html#resource_group_name DataAzurermSnapshot#resource_group_name}.
     *
     * @stability stable
     */
    readonly resourceGroupName: string;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/snapshot.html#timeouts DataAzurermSnapshot#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: DataAzurermSnapshotTimeouts;
}
/**
 * @stability stable
 */
export declare class DataAzurermSnapshotEncryptionSettingsDiskEncryptionKey extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get secretUrl(): string;
    /**
     * @stability stable
     */
    get sourceVaultId(): string;
}
/**
 * @stability stable
 */
export declare class DataAzurermSnapshotEncryptionSettingsKeyEncryptionKey extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get keyUrl(): string;
    /**
     * @stability stable
     */
    get sourceVaultId(): string;
}
/**
 * @stability stable
 */
export declare class DataAzurermSnapshotEncryptionSettings extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get diskEncryptionKey(): any;
    /**
     * @stability stable
     */
    get enabled(): boolean;
    /**
     * @stability stable
     */
    get keyEncryptionKey(): any;
}
/**
 * @stability stable
 */
export interface DataAzurermSnapshotTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/snapshot.html#read DataAzurermSnapshot#read}.
     *
     * @stability stable
     */
    readonly read?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/d/snapshot.html azurerm_snapshot}.
 *
 * @stability stable
 */
export declare class DataAzurermSnapshot extends cdktf.TerraformDataSource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/d/snapshot.html azurerm_snapshot} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAzurermSnapshotConfig);
    /**
     * @stability stable
     */
    get creationOption(): string;
    /**
     * @stability stable
     */
    get diskSizeGb(): number;
    /**
     * @stability stable
     */
    encryptionSettings(index: string): DataAzurermSnapshotEncryptionSettings;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    /**
     * @stability stable
     */
    get osType(): string;
    private _resourceGroupName;
    /**
     * @stability stable
     */
    get resourceGroupName(): string;
    /**
     * @stability stable
     */
    set resourceGroupName(value: string);
    /**
     * @stability stable
     */
    get resourceGroupNameInput(): string;
    /**
     * @stability stable
     */
    get sourceResourceId(): string;
    /**
     * @stability stable
     */
    get sourceUri(): string;
    /**
     * @stability stable
     */
    get storageAccountId(): string;
    /**
     * @stability stable
     */
    get timeCreated(): string;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): DataAzurermSnapshotTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: DataAzurermSnapshotTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): DataAzurermSnapshotTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
