import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataFactoryDatasetDelimitedTextConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/data_factory_dataset_delimited_text.html#additional_properties DataFactoryDatasetDelimitedText#additional_properties}.
     *
     * @stability stable
     */
    readonly additionalProperties?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/data_factory_dataset_delimited_text.html#annotations DataFactoryDatasetDelimitedText#annotations}.
     *
     * @stability stable
     */
    readonly annotations?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/data_factory_dataset_delimited_text.html#column_delimiter DataFactoryDatasetDelimitedText#column_delimiter}.
     *
     * @stability stable
     */
    readonly columnDelimiter?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/data_factory_dataset_delimited_text.html#compression_codec DataFactoryDatasetDelimitedText#compression_codec}.
     *
     * @stability stable
     */
    readonly compressionCodec?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/data_factory_dataset_delimited_text.html#compression_level DataFactoryDatasetDelimitedText#compression_level}.
     *
     * @stability stable
     */
    readonly compressionLevel?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/data_factory_dataset_delimited_text.html#data_factory_name DataFactoryDatasetDelimitedText#data_factory_name}.
     *
     * @stability stable
     */
    readonly dataFactoryName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/data_factory_dataset_delimited_text.html#description DataFactoryDatasetDelimitedText#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/data_factory_dataset_delimited_text.html#encoding DataFactoryDatasetDelimitedText#encoding}.
     *
     * @stability stable
     */
    readonly encoding?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/data_factory_dataset_delimited_text.html#escape_character DataFactoryDatasetDelimitedText#escape_character}.
     *
     * @stability stable
     */
    readonly escapeCharacter?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/data_factory_dataset_delimited_text.html#first_row_as_header DataFactoryDatasetDelimitedText#first_row_as_header}.
     *
     * @stability stable
     */
    readonly firstRowAsHeader?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/data_factory_dataset_delimited_text.html#folder DataFactoryDatasetDelimitedText#folder}.
     *
     * @stability stable
     */
    readonly folder?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/data_factory_dataset_delimited_text.html#linked_service_name DataFactoryDatasetDelimitedText#linked_service_name}.
     *
     * @stability stable
     */
    readonly linkedServiceName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/data_factory_dataset_delimited_text.html#name DataFactoryDatasetDelimitedText#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/data_factory_dataset_delimited_text.html#null_value DataFactoryDatasetDelimitedText#null_value}.
     *
     * @stability stable
     */
    readonly nullValue?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/data_factory_dataset_delimited_text.html#parameters DataFactoryDatasetDelimitedText#parameters}.
     *
     * @stability stable
     */
    readonly parameters?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/data_factory_dataset_delimited_text.html#quote_character DataFactoryDatasetDelimitedText#quote_character}.
     *
     * @stability stable
     */
    readonly quoteCharacter?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/data_factory_dataset_delimited_text.html#resource_group_name DataFactoryDatasetDelimitedText#resource_group_name}.
     *
     * @stability stable
     */
    readonly resourceGroupName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/data_factory_dataset_delimited_text.html#row_delimiter DataFactoryDatasetDelimitedText#row_delimiter}.
     *
     * @stability stable
     */
    readonly rowDelimiter?: string;
    /**
     * azure_blob_fs_location block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/data_factory_dataset_delimited_text.html#azure_blob_fs_location DataFactoryDatasetDelimitedText#azure_blob_fs_location}
     *
     * @stability stable
     */
    readonly azureBlobFsLocation?: DataFactoryDatasetDelimitedTextAzureBlobFsLocation[];
    /**
     * azure_blob_storage_location block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/data_factory_dataset_delimited_text.html#azure_blob_storage_location DataFactoryDatasetDelimitedText#azure_blob_storage_location}
     *
     * @stability stable
     */
    readonly azureBlobStorageLocation?: DataFactoryDatasetDelimitedTextAzureBlobStorageLocation[];
    /**
     * http_server_location block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/data_factory_dataset_delimited_text.html#http_server_location DataFactoryDatasetDelimitedText#http_server_location}
     *
     * @stability stable
     */
    readonly httpServerLocation?: DataFactoryDatasetDelimitedTextHttpServerLocation[];
    /**
     * schema_column block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/data_factory_dataset_delimited_text.html#schema_column DataFactoryDatasetDelimitedText#schema_column}
     *
     * @stability stable
     */
    readonly schemaColumn?: DataFactoryDatasetDelimitedTextSchemaColumn[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/data_factory_dataset_delimited_text.html#timeouts DataFactoryDatasetDelimitedText#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: DataFactoryDatasetDelimitedTextTimeouts;
}
/**
 * @stability stable
 */
export interface DataFactoryDatasetDelimitedTextAzureBlobFsLocation {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/data_factory_dataset_delimited_text.html#file_system DataFactoryDatasetDelimitedText#file_system}.
     *
     * @stability stable
     */
    readonly fileSystem: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/data_factory_dataset_delimited_text.html#filename DataFactoryDatasetDelimitedText#filename}.
     *
     * @stability stable
     */
    readonly filename?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/data_factory_dataset_delimited_text.html#path DataFactoryDatasetDelimitedText#path}.
     *
     * @stability stable
     */
    readonly path?: string;
}
/**
 * @stability stable
 */
export interface DataFactoryDatasetDelimitedTextAzureBlobStorageLocation {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/data_factory_dataset_delimited_text.html#container DataFactoryDatasetDelimitedText#container}.
     *
     * @stability stable
     */
    readonly container: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/data_factory_dataset_delimited_text.html#filename DataFactoryDatasetDelimitedText#filename}.
     *
     * @stability stable
     */
    readonly filename: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/data_factory_dataset_delimited_text.html#path DataFactoryDatasetDelimitedText#path}.
     *
     * @stability stable
     */
    readonly path: string;
}
/**
 * @stability stable
 */
export interface DataFactoryDatasetDelimitedTextHttpServerLocation {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/data_factory_dataset_delimited_text.html#filename DataFactoryDatasetDelimitedText#filename}.
     *
     * @stability stable
     */
    readonly filename: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/data_factory_dataset_delimited_text.html#path DataFactoryDatasetDelimitedText#path}.
     *
     * @stability stable
     */
    readonly path: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/data_factory_dataset_delimited_text.html#relative_url DataFactoryDatasetDelimitedText#relative_url}.
     *
     * @stability stable
     */
    readonly relativeUrl: string;
}
/**
 * @stability stable
 */
export interface DataFactoryDatasetDelimitedTextSchemaColumn {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/data_factory_dataset_delimited_text.html#description DataFactoryDatasetDelimitedText#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/data_factory_dataset_delimited_text.html#name DataFactoryDatasetDelimitedText#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/data_factory_dataset_delimited_text.html#type DataFactoryDatasetDelimitedText#type}.
     *
     * @stability stable
     */
    readonly type?: string;
}
/**
 * @stability stable
 */
export interface DataFactoryDatasetDelimitedTextTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/data_factory_dataset_delimited_text.html#create DataFactoryDatasetDelimitedText#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/data_factory_dataset_delimited_text.html#delete DataFactoryDatasetDelimitedText#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/data_factory_dataset_delimited_text.html#read DataFactoryDatasetDelimitedText#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/data_factory_dataset_delimited_text.html#update DataFactoryDatasetDelimitedText#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/data_factory_dataset_delimited_text.html azurerm_data_factory_dataset_delimited_text}.
 *
 * @stability stable
 */
export declare class DataFactoryDatasetDelimitedText extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/data_factory_dataset_delimited_text.html azurerm_data_factory_dataset_delimited_text} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataFactoryDatasetDelimitedTextConfig);
    private _additionalProperties?;
    /**
     * @stability stable
     */
    get additionalProperties(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set additionalProperties(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetAdditionalProperties(): void;
    /**
     * @stability stable
     */
    get additionalPropertiesInput(): {
        [key: string]: string;
    } | undefined;
    private _annotations?;
    /**
     * @stability stable
     */
    get annotations(): string[];
    /**
     * @stability stable
     */
    set annotations(value: string[]);
    /**
     * @stability stable
     */
    resetAnnotations(): void;
    /**
     * @stability stable
     */
    get annotationsInput(): string[] | undefined;
    private _columnDelimiter?;
    /**
     * @stability stable
     */
    get columnDelimiter(): string;
    /**
     * @stability stable
     */
    set columnDelimiter(value: string);
    /**
     * @stability stable
     */
    resetColumnDelimiter(): void;
    /**
     * @stability stable
     */
    get columnDelimiterInput(): string | undefined;
    private _compressionCodec?;
    /**
     * @stability stable
     */
    get compressionCodec(): string;
    /**
     * @stability stable
     */
    set compressionCodec(value: string);
    /**
     * @stability stable
     */
    resetCompressionCodec(): void;
    /**
     * @stability stable
     */
    get compressionCodecInput(): string | undefined;
    private _compressionLevel?;
    /**
     * @stability stable
     */
    get compressionLevel(): string;
    /**
     * @stability stable
     */
    set compressionLevel(value: string);
    /**
     * @stability stable
     */
    resetCompressionLevel(): void;
    /**
     * @stability stable
     */
    get compressionLevelInput(): string | undefined;
    private _dataFactoryName;
    /**
     * @stability stable
     */
    get dataFactoryName(): string;
    /**
     * @stability stable
     */
    set dataFactoryName(value: string);
    /**
     * @stability stable
     */
    get dataFactoryNameInput(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _encoding?;
    /**
     * @stability stable
     */
    get encoding(): string;
    /**
     * @stability stable
     */
    set encoding(value: string);
    /**
     * @stability stable
     */
    resetEncoding(): void;
    /**
     * @stability stable
     */
    get encodingInput(): string | undefined;
    private _escapeCharacter?;
    /**
     * @stability stable
     */
    get escapeCharacter(): string;
    /**
     * @stability stable
     */
    set escapeCharacter(value: string);
    /**
     * @stability stable
     */
    resetEscapeCharacter(): void;
    /**
     * @stability stable
     */
    get escapeCharacterInput(): string | undefined;
    private _firstRowAsHeader?;
    /**
     * @stability stable
     */
    get firstRowAsHeader(): boolean;
    /**
     * @stability stable
     */
    set firstRowAsHeader(value: boolean);
    /**
     * @stability stable
     */
    resetFirstRowAsHeader(): void;
    /**
     * @stability stable
     */
    get firstRowAsHeaderInput(): boolean | undefined;
    private _folder?;
    /**
     * @stability stable
     */
    get folder(): string;
    /**
     * @stability stable
     */
    set folder(value: string);
    /**
     * @stability stable
     */
    resetFolder(): void;
    /**
     * @stability stable
     */
    get folderInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _linkedServiceName;
    /**
     * @stability stable
     */
    get linkedServiceName(): string;
    /**
     * @stability stable
     */
    set linkedServiceName(value: string);
    /**
     * @stability stable
     */
    get linkedServiceNameInput(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _nullValue?;
    /**
     * @stability stable
     */
    get nullValue(): string;
    /**
     * @stability stable
     */
    set nullValue(value: string);
    /**
     * @stability stable
     */
    resetNullValue(): void;
    /**
     * @stability stable
     */
    get nullValueInput(): string | undefined;
    private _parameters?;
    /**
     * @stability stable
     */
    get parameters(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set parameters(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetParameters(): void;
    /**
     * @stability stable
     */
    get parametersInput(): {
        [key: string]: string;
    } | undefined;
    private _quoteCharacter?;
    /**
     * @stability stable
     */
    get quoteCharacter(): string;
    /**
     * @stability stable
     */
    set quoteCharacter(value: string);
    /**
     * @stability stable
     */
    resetQuoteCharacter(): void;
    /**
     * @stability stable
     */
    get quoteCharacterInput(): string | undefined;
    private _resourceGroupName;
    /**
     * @stability stable
     */
    get resourceGroupName(): string;
    /**
     * @stability stable
     */
    set resourceGroupName(value: string);
    /**
     * @stability stable
     */
    get resourceGroupNameInput(): string;
    private _rowDelimiter?;
    /**
     * @stability stable
     */
    get rowDelimiter(): string;
    /**
     * @stability stable
     */
    set rowDelimiter(value: string);
    /**
     * @stability stable
     */
    resetRowDelimiter(): void;
    /**
     * @stability stable
     */
    get rowDelimiterInput(): string | undefined;
    private _azureBlobFsLocation?;
    /**
     * @stability stable
     */
    get azureBlobFsLocation(): DataFactoryDatasetDelimitedTextAzureBlobFsLocation[];
    /**
     * @stability stable
     */
    set azureBlobFsLocation(value: DataFactoryDatasetDelimitedTextAzureBlobFsLocation[]);
    /**
     * @stability stable
     */
    resetAzureBlobFsLocation(): void;
    /**
     * @stability stable
     */
    get azureBlobFsLocationInput(): DataFactoryDatasetDelimitedTextAzureBlobFsLocation[] | undefined;
    private _azureBlobStorageLocation?;
    /**
     * @stability stable
     */
    get azureBlobStorageLocation(): DataFactoryDatasetDelimitedTextAzureBlobStorageLocation[];
    /**
     * @stability stable
     */
    set azureBlobStorageLocation(value: DataFactoryDatasetDelimitedTextAzureBlobStorageLocation[]);
    /**
     * @stability stable
     */
    resetAzureBlobStorageLocation(): void;
    /**
     * @stability stable
     */
    get azureBlobStorageLocationInput(): DataFactoryDatasetDelimitedTextAzureBlobStorageLocation[] | undefined;
    private _httpServerLocation?;
    /**
     * @stability stable
     */
    get httpServerLocation(): DataFactoryDatasetDelimitedTextHttpServerLocation[];
    /**
     * @stability stable
     */
    set httpServerLocation(value: DataFactoryDatasetDelimitedTextHttpServerLocation[]);
    /**
     * @stability stable
     */
    resetHttpServerLocation(): void;
    /**
     * @stability stable
     */
    get httpServerLocationInput(): DataFactoryDatasetDelimitedTextHttpServerLocation[] | undefined;
    private _schemaColumn?;
    /**
     * @stability stable
     */
    get schemaColumn(): DataFactoryDatasetDelimitedTextSchemaColumn[];
    /**
     * @stability stable
     */
    set schemaColumn(value: DataFactoryDatasetDelimitedTextSchemaColumn[]);
    /**
     * @stability stable
     */
    resetSchemaColumn(): void;
    /**
     * @stability stable
     */
    get schemaColumnInput(): DataFactoryDatasetDelimitedTextSchemaColumn[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): DataFactoryDatasetDelimitedTextTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: DataFactoryDatasetDelimitedTextTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): DataFactoryDatasetDelimitedTextTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
