import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface EventgridSystemTopicEventSubscriptionConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#event_delivery_schema EventgridSystemTopicEventSubscription#event_delivery_schema}.
     *
     * @stability stable
     */
    readonly eventDeliverySchema?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#eventhub_endpoint_id EventgridSystemTopicEventSubscription#eventhub_endpoint_id}.
     *
     * @stability stable
     */
    readonly eventhubEndpointId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#expiration_time_utc EventgridSystemTopicEventSubscription#expiration_time_utc}.
     *
     * @stability stable
     */
    readonly expirationTimeUtc?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#hybrid_connection_endpoint_id EventgridSystemTopicEventSubscription#hybrid_connection_endpoint_id}.
     *
     * @stability stable
     */
    readonly hybridConnectionEndpointId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#included_event_types EventgridSystemTopicEventSubscription#included_event_types}.
     *
     * @stability stable
     */
    readonly includedEventTypes?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#labels EventgridSystemTopicEventSubscription#labels}.
     *
     * @stability stable
     */
    readonly labels?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#name EventgridSystemTopicEventSubscription#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#resource_group_name EventgridSystemTopicEventSubscription#resource_group_name}.
     *
     * @stability stable
     */
    readonly resourceGroupName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#service_bus_queue_endpoint_id EventgridSystemTopicEventSubscription#service_bus_queue_endpoint_id}.
     *
     * @stability stable
     */
    readonly serviceBusQueueEndpointId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#service_bus_topic_endpoint_id EventgridSystemTopicEventSubscription#service_bus_topic_endpoint_id}.
     *
     * @stability stable
     */
    readonly serviceBusTopicEndpointId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#system_topic EventgridSystemTopicEventSubscription#system_topic}.
     *
     * @stability stable
     */
    readonly systemTopic: string;
    /**
     * advanced_filter block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#advanced_filter EventgridSystemTopicEventSubscription#advanced_filter}
     *
     * @stability stable
     */
    readonly advancedFilter?: EventgridSystemTopicEventSubscriptionAdvancedFilter[];
    /**
     * azure_function_endpoint block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#azure_function_endpoint EventgridSystemTopicEventSubscription#azure_function_endpoint}
     *
     * @stability stable
     */
    readonly azureFunctionEndpoint?: EventgridSystemTopicEventSubscriptionAzureFunctionEndpoint[];
    /**
     * retry_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#retry_policy EventgridSystemTopicEventSubscription#retry_policy}
     *
     * @stability stable
     */
    readonly retryPolicy?: EventgridSystemTopicEventSubscriptionRetryPolicy[];
    /**
     * storage_blob_dead_letter_destination block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#storage_blob_dead_letter_destination EventgridSystemTopicEventSubscription#storage_blob_dead_letter_destination}
     *
     * @stability stable
     */
    readonly storageBlobDeadLetterDestination?: EventgridSystemTopicEventSubscriptionStorageBlobDeadLetterDestination[];
    /**
     * storage_queue_endpoint block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#storage_queue_endpoint EventgridSystemTopicEventSubscription#storage_queue_endpoint}
     *
     * @stability stable
     */
    readonly storageQueueEndpoint?: EventgridSystemTopicEventSubscriptionStorageQueueEndpoint[];
    /**
     * subject_filter block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#subject_filter EventgridSystemTopicEventSubscription#subject_filter}
     *
     * @stability stable
     */
    readonly subjectFilter?: EventgridSystemTopicEventSubscriptionSubjectFilter[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#timeouts EventgridSystemTopicEventSubscription#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: EventgridSystemTopicEventSubscriptionTimeouts;
    /**
     * webhook_endpoint block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#webhook_endpoint EventgridSystemTopicEventSubscription#webhook_endpoint}
     *
     * @stability stable
     */
    readonly webhookEndpoint?: EventgridSystemTopicEventSubscriptionWebhookEndpoint[];
}
/**
 * @stability stable
 */
export interface EventgridSystemTopicEventSubscriptionAdvancedFilterBoolEquals {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#key EventgridSystemTopicEventSubscription#key}.
     *
     * @stability stable
     */
    readonly key: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#value EventgridSystemTopicEventSubscription#value}.
     *
     * @stability stable
     */
    readonly value: boolean;
}
/**
 * @stability stable
 */
export interface EventgridSystemTopicEventSubscriptionAdvancedFilterNumberGreaterThan {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#key EventgridSystemTopicEventSubscription#key}.
     *
     * @stability stable
     */
    readonly key: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#value EventgridSystemTopicEventSubscription#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
/**
 * @stability stable
 */
export interface EventgridSystemTopicEventSubscriptionAdvancedFilterNumberGreaterThanOrEquals {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#key EventgridSystemTopicEventSubscription#key}.
     *
     * @stability stable
     */
    readonly key: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#value EventgridSystemTopicEventSubscription#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
/**
 * @stability stable
 */
export interface EventgridSystemTopicEventSubscriptionAdvancedFilterNumberIn {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#key EventgridSystemTopicEventSubscription#key}.
     *
     * @stability stable
     */
    readonly key: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#values EventgridSystemTopicEventSubscription#values}.
     *
     * @stability stable
     */
    readonly values: number[];
}
/**
 * @stability stable
 */
export interface EventgridSystemTopicEventSubscriptionAdvancedFilterNumberLessThan {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#key EventgridSystemTopicEventSubscription#key}.
     *
     * @stability stable
     */
    readonly key: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#value EventgridSystemTopicEventSubscription#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
/**
 * @stability stable
 */
export interface EventgridSystemTopicEventSubscriptionAdvancedFilterNumberLessThanOrEquals {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#key EventgridSystemTopicEventSubscription#key}.
     *
     * @stability stable
     */
    readonly key: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#value EventgridSystemTopicEventSubscription#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
/**
 * @stability stable
 */
export interface EventgridSystemTopicEventSubscriptionAdvancedFilterNumberNotIn {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#key EventgridSystemTopicEventSubscription#key}.
     *
     * @stability stable
     */
    readonly key: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#values EventgridSystemTopicEventSubscription#values}.
     *
     * @stability stable
     */
    readonly values: number[];
}
/**
 * @stability stable
 */
export interface EventgridSystemTopicEventSubscriptionAdvancedFilterStringBeginsWith {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#key EventgridSystemTopicEventSubscription#key}.
     *
     * @stability stable
     */
    readonly key: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#values EventgridSystemTopicEventSubscription#values}.
     *
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export interface EventgridSystemTopicEventSubscriptionAdvancedFilterStringContains {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#key EventgridSystemTopicEventSubscription#key}.
     *
     * @stability stable
     */
    readonly key: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#values EventgridSystemTopicEventSubscription#values}.
     *
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export interface EventgridSystemTopicEventSubscriptionAdvancedFilterStringEndsWith {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#key EventgridSystemTopicEventSubscription#key}.
     *
     * @stability stable
     */
    readonly key: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#values EventgridSystemTopicEventSubscription#values}.
     *
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export interface EventgridSystemTopicEventSubscriptionAdvancedFilterStringIn {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#key EventgridSystemTopicEventSubscription#key}.
     *
     * @stability stable
     */
    readonly key: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#values EventgridSystemTopicEventSubscription#values}.
     *
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export interface EventgridSystemTopicEventSubscriptionAdvancedFilterStringNotIn {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#key EventgridSystemTopicEventSubscription#key}.
     *
     * @stability stable
     */
    readonly key: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#values EventgridSystemTopicEventSubscription#values}.
     *
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export interface EventgridSystemTopicEventSubscriptionAdvancedFilter {
    /**
     * bool_equals block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#bool_equals EventgridSystemTopicEventSubscription#bool_equals}
     *
     * @stability stable
     */
    readonly boolEquals?: EventgridSystemTopicEventSubscriptionAdvancedFilterBoolEquals[];
    /**
     * number_greater_than block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#number_greater_than EventgridSystemTopicEventSubscription#number_greater_than}
     *
     * @stability stable
     */
    readonly numberGreaterThan?: EventgridSystemTopicEventSubscriptionAdvancedFilterNumberGreaterThan[];
    /**
     * number_greater_than_or_equals block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#number_greater_than_or_equals EventgridSystemTopicEventSubscription#number_greater_than_or_equals}
     *
     * @stability stable
     */
    readonly numberGreaterThanOrEquals?: EventgridSystemTopicEventSubscriptionAdvancedFilterNumberGreaterThanOrEquals[];
    /**
     * number_in block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#number_in EventgridSystemTopicEventSubscription#number_in}
     *
     * @stability stable
     */
    readonly numberIn?: EventgridSystemTopicEventSubscriptionAdvancedFilterNumberIn[];
    /**
     * number_less_than block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#number_less_than EventgridSystemTopicEventSubscription#number_less_than}
     *
     * @stability stable
     */
    readonly numberLessThan?: EventgridSystemTopicEventSubscriptionAdvancedFilterNumberLessThan[];
    /**
     * number_less_than_or_equals block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#number_less_than_or_equals EventgridSystemTopicEventSubscription#number_less_than_or_equals}
     *
     * @stability stable
     */
    readonly numberLessThanOrEquals?: EventgridSystemTopicEventSubscriptionAdvancedFilterNumberLessThanOrEquals[];
    /**
     * number_not_in block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#number_not_in EventgridSystemTopicEventSubscription#number_not_in}
     *
     * @stability stable
     */
    readonly numberNotIn?: EventgridSystemTopicEventSubscriptionAdvancedFilterNumberNotIn[];
    /**
     * string_begins_with block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#string_begins_with EventgridSystemTopicEventSubscription#string_begins_with}
     *
     * @stability stable
     */
    readonly stringBeginsWith?: EventgridSystemTopicEventSubscriptionAdvancedFilterStringBeginsWith[];
    /**
     * string_contains block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#string_contains EventgridSystemTopicEventSubscription#string_contains}
     *
     * @stability stable
     */
    readonly stringContains?: EventgridSystemTopicEventSubscriptionAdvancedFilterStringContains[];
    /**
     * string_ends_with block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#string_ends_with EventgridSystemTopicEventSubscription#string_ends_with}
     *
     * @stability stable
     */
    readonly stringEndsWith?: EventgridSystemTopicEventSubscriptionAdvancedFilterStringEndsWith[];
    /**
     * string_in block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#string_in EventgridSystemTopicEventSubscription#string_in}
     *
     * @stability stable
     */
    readonly stringIn?: EventgridSystemTopicEventSubscriptionAdvancedFilterStringIn[];
    /**
     * string_not_in block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#string_not_in EventgridSystemTopicEventSubscription#string_not_in}
     *
     * @stability stable
     */
    readonly stringNotIn?: EventgridSystemTopicEventSubscriptionAdvancedFilterStringNotIn[];
}
/**
 * @stability stable
 */
export interface EventgridSystemTopicEventSubscriptionAzureFunctionEndpoint {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#function_id EventgridSystemTopicEventSubscription#function_id}.
     *
     * @stability stable
     */
    readonly functionId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#max_events_per_batch EventgridSystemTopicEventSubscription#max_events_per_batch}.
     *
     * @stability stable
     */
    readonly maxEventsPerBatch?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#preferred_batch_size_in_kilobytes EventgridSystemTopicEventSubscription#preferred_batch_size_in_kilobytes}.
     *
     * @stability stable
     */
    readonly preferredBatchSizeInKilobytes?: number;
}
/**
 * @stability stable
 */
export interface EventgridSystemTopicEventSubscriptionRetryPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#event_time_to_live EventgridSystemTopicEventSubscription#event_time_to_live}.
     *
     * @stability stable
     */
    readonly eventTimeToLive: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#max_delivery_attempts EventgridSystemTopicEventSubscription#max_delivery_attempts}.
     *
     * @stability stable
     */
    readonly maxDeliveryAttempts: number;
}
/**
 * @stability stable
 */
export interface EventgridSystemTopicEventSubscriptionStorageBlobDeadLetterDestination {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#storage_account_id EventgridSystemTopicEventSubscription#storage_account_id}.
     *
     * @stability stable
     */
    readonly storageAccountId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#storage_blob_container_name EventgridSystemTopicEventSubscription#storage_blob_container_name}.
     *
     * @stability stable
     */
    readonly storageBlobContainerName: string;
}
/**
 * @stability stable
 */
export interface EventgridSystemTopicEventSubscriptionStorageQueueEndpoint {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#queue_name EventgridSystemTopicEventSubscription#queue_name}.
     *
     * @stability stable
     */
    readonly queueName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#storage_account_id EventgridSystemTopicEventSubscription#storage_account_id}.
     *
     * @stability stable
     */
    readonly storageAccountId: string;
}
/**
 * @stability stable
 */
export interface EventgridSystemTopicEventSubscriptionSubjectFilter {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#case_sensitive EventgridSystemTopicEventSubscription#case_sensitive}.
     *
     * @stability stable
     */
    readonly caseSensitive?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#subject_begins_with EventgridSystemTopicEventSubscription#subject_begins_with}.
     *
     * @stability stable
     */
    readonly subjectBeginsWith?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#subject_ends_with EventgridSystemTopicEventSubscription#subject_ends_with}.
     *
     * @stability stable
     */
    readonly subjectEndsWith?: string;
}
/**
 * @stability stable
 */
export interface EventgridSystemTopicEventSubscriptionTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#create EventgridSystemTopicEventSubscription#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#delete EventgridSystemTopicEventSubscription#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#read EventgridSystemTopicEventSubscription#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#update EventgridSystemTopicEventSubscription#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export interface EventgridSystemTopicEventSubscriptionWebhookEndpoint {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#active_directory_app_id_or_uri EventgridSystemTopicEventSubscription#active_directory_app_id_or_uri}.
     *
     * @stability stable
     */
    readonly activeDirectoryAppIdOrUri?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#active_directory_tenant_id EventgridSystemTopicEventSubscription#active_directory_tenant_id}.
     *
     * @stability stable
     */
    readonly activeDirectoryTenantId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#max_events_per_batch EventgridSystemTopicEventSubscription#max_events_per_batch}.
     *
     * @stability stable
     */
    readonly maxEventsPerBatch?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#preferred_batch_size_in_kilobytes EventgridSystemTopicEventSubscription#preferred_batch_size_in_kilobytes}.
     *
     * @stability stable
     */
    readonly preferredBatchSizeInKilobytes?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html#url EventgridSystemTopicEventSubscription#url}.
     *
     * @stability stable
     */
    readonly url: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html azurerm_eventgrid_system_topic_event_subscription}.
 *
 * @stability stable
 */
export declare class EventgridSystemTopicEventSubscription extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_system_topic_event_subscription.html azurerm_eventgrid_system_topic_event_subscription} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: EventgridSystemTopicEventSubscriptionConfig);
    private _eventDeliverySchema?;
    /**
     * @stability stable
     */
    get eventDeliverySchema(): string;
    /**
     * @stability stable
     */
    set eventDeliverySchema(value: string);
    /**
     * @stability stable
     */
    resetEventDeliverySchema(): void;
    /**
     * @stability stable
     */
    get eventDeliverySchemaInput(): string | undefined;
    private _eventhubEndpointId?;
    /**
     * @stability stable
     */
    get eventhubEndpointId(): string;
    /**
     * @stability stable
     */
    set eventhubEndpointId(value: string);
    /**
     * @stability stable
     */
    resetEventhubEndpointId(): void;
    /**
     * @stability stable
     */
    get eventhubEndpointIdInput(): string | undefined;
    private _expirationTimeUtc?;
    /**
     * @stability stable
     */
    get expirationTimeUtc(): string;
    /**
     * @stability stable
     */
    set expirationTimeUtc(value: string);
    /**
     * @stability stable
     */
    resetExpirationTimeUtc(): void;
    /**
     * @stability stable
     */
    get expirationTimeUtcInput(): string | undefined;
    private _hybridConnectionEndpointId?;
    /**
     * @stability stable
     */
    get hybridConnectionEndpointId(): string;
    /**
     * @stability stable
     */
    set hybridConnectionEndpointId(value: string);
    /**
     * @stability stable
     */
    resetHybridConnectionEndpointId(): void;
    /**
     * @stability stable
     */
    get hybridConnectionEndpointIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _includedEventTypes?;
    /**
     * @stability stable
     */
    get includedEventTypes(): string[];
    /**
     * @stability stable
     */
    set includedEventTypes(value: string[]);
    /**
     * @stability stable
     */
    resetIncludedEventTypes(): void;
    /**
     * @stability stable
     */
    get includedEventTypesInput(): string[] | undefined;
    private _labels?;
    /**
     * @stability stable
     */
    get labels(): string[];
    /**
     * @stability stable
     */
    set labels(value: string[]);
    /**
     * @stability stable
     */
    resetLabels(): void;
    /**
     * @stability stable
     */
    get labelsInput(): string[] | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _resourceGroupName;
    /**
     * @stability stable
     */
    get resourceGroupName(): string;
    /**
     * @stability stable
     */
    set resourceGroupName(value: string);
    /**
     * @stability stable
     */
    get resourceGroupNameInput(): string;
    private _serviceBusQueueEndpointId?;
    /**
     * @stability stable
     */
    get serviceBusQueueEndpointId(): string;
    /**
     * @stability stable
     */
    set serviceBusQueueEndpointId(value: string);
    /**
     * @stability stable
     */
    resetServiceBusQueueEndpointId(): void;
    /**
     * @stability stable
     */
    get serviceBusQueueEndpointIdInput(): string | undefined;
    private _serviceBusTopicEndpointId?;
    /**
     * @stability stable
     */
    get serviceBusTopicEndpointId(): string;
    /**
     * @stability stable
     */
    set serviceBusTopicEndpointId(value: string);
    /**
     * @stability stable
     */
    resetServiceBusTopicEndpointId(): void;
    /**
     * @stability stable
     */
    get serviceBusTopicEndpointIdInput(): string | undefined;
    private _systemTopic;
    /**
     * @stability stable
     */
    get systemTopic(): string;
    /**
     * @stability stable
     */
    set systemTopic(value: string);
    /**
     * @stability stable
     */
    get systemTopicInput(): string;
    private _advancedFilter?;
    /**
     * @stability stable
     */
    get advancedFilter(): EventgridSystemTopicEventSubscriptionAdvancedFilter[];
    /**
     * @stability stable
     */
    set advancedFilter(value: EventgridSystemTopicEventSubscriptionAdvancedFilter[]);
    /**
     * @stability stable
     */
    resetAdvancedFilter(): void;
    /**
     * @stability stable
     */
    get advancedFilterInput(): EventgridSystemTopicEventSubscriptionAdvancedFilter[] | undefined;
    private _azureFunctionEndpoint?;
    /**
     * @stability stable
     */
    get azureFunctionEndpoint(): EventgridSystemTopicEventSubscriptionAzureFunctionEndpoint[];
    /**
     * @stability stable
     */
    set azureFunctionEndpoint(value: EventgridSystemTopicEventSubscriptionAzureFunctionEndpoint[]);
    /**
     * @stability stable
     */
    resetAzureFunctionEndpoint(): void;
    /**
     * @stability stable
     */
    get azureFunctionEndpointInput(): EventgridSystemTopicEventSubscriptionAzureFunctionEndpoint[] | undefined;
    private _retryPolicy?;
    /**
     * @stability stable
     */
    get retryPolicy(): EventgridSystemTopicEventSubscriptionRetryPolicy[];
    /**
     * @stability stable
     */
    set retryPolicy(value: EventgridSystemTopicEventSubscriptionRetryPolicy[]);
    /**
     * @stability stable
     */
    resetRetryPolicy(): void;
    /**
     * @stability stable
     */
    get retryPolicyInput(): EventgridSystemTopicEventSubscriptionRetryPolicy[] | undefined;
    private _storageBlobDeadLetterDestination?;
    /**
     * @stability stable
     */
    get storageBlobDeadLetterDestination(): EventgridSystemTopicEventSubscriptionStorageBlobDeadLetterDestination[];
    /**
     * @stability stable
     */
    set storageBlobDeadLetterDestination(value: EventgridSystemTopicEventSubscriptionStorageBlobDeadLetterDestination[]);
    /**
     * @stability stable
     */
    resetStorageBlobDeadLetterDestination(): void;
    /**
     * @stability stable
     */
    get storageBlobDeadLetterDestinationInput(): EventgridSystemTopicEventSubscriptionStorageBlobDeadLetterDestination[] | undefined;
    private _storageQueueEndpoint?;
    /**
     * @stability stable
     */
    get storageQueueEndpoint(): EventgridSystemTopicEventSubscriptionStorageQueueEndpoint[];
    /**
     * @stability stable
     */
    set storageQueueEndpoint(value: EventgridSystemTopicEventSubscriptionStorageQueueEndpoint[]);
    /**
     * @stability stable
     */
    resetStorageQueueEndpoint(): void;
    /**
     * @stability stable
     */
    get storageQueueEndpointInput(): EventgridSystemTopicEventSubscriptionStorageQueueEndpoint[] | undefined;
    private _subjectFilter?;
    /**
     * @stability stable
     */
    get subjectFilter(): EventgridSystemTopicEventSubscriptionSubjectFilter[];
    /**
     * @stability stable
     */
    set subjectFilter(value: EventgridSystemTopicEventSubscriptionSubjectFilter[]);
    /**
     * @stability stable
     */
    resetSubjectFilter(): void;
    /**
     * @stability stable
     */
    get subjectFilterInput(): EventgridSystemTopicEventSubscriptionSubjectFilter[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): EventgridSystemTopicEventSubscriptionTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: EventgridSystemTopicEventSubscriptionTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): EventgridSystemTopicEventSubscriptionTimeouts | undefined;
    private _webhookEndpoint?;
    /**
     * @stability stable
     */
    get webhookEndpoint(): EventgridSystemTopicEventSubscriptionWebhookEndpoint[];
    /**
     * @stability stable
     */
    set webhookEndpoint(value: EventgridSystemTopicEventSubscriptionWebhookEndpoint[]);
    /**
     * @stability stable
     */
    resetWebhookEndpoint(): void;
    /**
     * @stability stable
     */
    get webhookEndpointInput(): EventgridSystemTopicEventSubscriptionWebhookEndpoint[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
