import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface FrontdoorCustomHttpsConfigurationConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/frontdoor_custom_https_configuration.html#custom_https_provisioning_enabled FrontdoorCustomHttpsConfiguration#custom_https_provisioning_enabled}.
     *
     * @stability stable
     */
    readonly customHttpsProvisioningEnabled: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/frontdoor_custom_https_configuration.html#frontend_endpoint_id FrontdoorCustomHttpsConfiguration#frontend_endpoint_id}.
     *
     * @stability stable
     */
    readonly frontendEndpointId: string;
    /**
     * custom_https_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/frontdoor_custom_https_configuration.html#custom_https_configuration FrontdoorCustomHttpsConfiguration#custom_https_configuration}
     *
     * @stability stable
     */
    readonly customHttpsConfiguration?: FrontdoorCustomHttpsConfigurationCustomHttpsConfiguration[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/frontdoor_custom_https_configuration.html#timeouts FrontdoorCustomHttpsConfiguration#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: FrontdoorCustomHttpsConfigurationTimeouts;
}
/**
 * @stability stable
 */
export interface FrontdoorCustomHttpsConfigurationCustomHttpsConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/frontdoor_custom_https_configuration.html#azure_key_vault_certificate_secret_name FrontdoorCustomHttpsConfiguration#azure_key_vault_certificate_secret_name}.
     *
     * @stability stable
     */
    readonly azureKeyVaultCertificateSecretName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/frontdoor_custom_https_configuration.html#azure_key_vault_certificate_secret_version FrontdoorCustomHttpsConfiguration#azure_key_vault_certificate_secret_version}.
     *
     * @stability stable
     */
    readonly azureKeyVaultCertificateSecretVersion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/frontdoor_custom_https_configuration.html#azure_key_vault_certificate_vault_id FrontdoorCustomHttpsConfiguration#azure_key_vault_certificate_vault_id}.
     *
     * @stability stable
     */
    readonly azureKeyVaultCertificateVaultId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/frontdoor_custom_https_configuration.html#certificate_source FrontdoorCustomHttpsConfiguration#certificate_source}.
     *
     * @stability stable
     */
    readonly certificateSource?: string;
}
/**
 * @stability stable
 */
export interface FrontdoorCustomHttpsConfigurationTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/frontdoor_custom_https_configuration.html#create FrontdoorCustomHttpsConfiguration#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/frontdoor_custom_https_configuration.html#delete FrontdoorCustomHttpsConfiguration#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/frontdoor_custom_https_configuration.html#read FrontdoorCustomHttpsConfiguration#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/frontdoor_custom_https_configuration.html#update FrontdoorCustomHttpsConfiguration#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/frontdoor_custom_https_configuration.html azurerm_frontdoor_custom_https_configuration}.
 *
 * @stability stable
 */
export declare class FrontdoorCustomHttpsConfiguration extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/frontdoor_custom_https_configuration.html azurerm_frontdoor_custom_https_configuration} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: FrontdoorCustomHttpsConfigurationConfig);
    private _customHttpsProvisioningEnabled;
    /**
     * @stability stable
     */
    get customHttpsProvisioningEnabled(): boolean;
    /**
     * @stability stable
     */
    set customHttpsProvisioningEnabled(value: boolean);
    /**
     * @stability stable
     */
    get customHttpsProvisioningEnabledInput(): boolean;
    private _frontendEndpointId;
    /**
     * @stability stable
     */
    get frontendEndpointId(): string;
    /**
     * @stability stable
     */
    set frontendEndpointId(value: string);
    /**
     * @stability stable
     */
    get frontendEndpointIdInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _customHttpsConfiguration?;
    /**
     * @stability stable
     */
    get customHttpsConfiguration(): FrontdoorCustomHttpsConfigurationCustomHttpsConfiguration[];
    /**
     * @stability stable
     */
    set customHttpsConfiguration(value: FrontdoorCustomHttpsConfigurationCustomHttpsConfiguration[]);
    /**
     * @stability stable
     */
    resetCustomHttpsConfiguration(): void;
    /**
     * @stability stable
     */
    get customHttpsConfigurationInput(): FrontdoorCustomHttpsConfigurationCustomHttpsConfiguration[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): FrontdoorCustomHttpsConfigurationTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: FrontdoorCustomHttpsConfigurationTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): FrontdoorCustomHttpsConfigurationTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
