import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface HdinsightSparkClusterConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#cluster_version HdinsightSparkCluster#cluster_version}.
     *
     * @stability stable
     */
    readonly clusterVersion: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#location HdinsightSparkCluster#location}.
     *
     * @stability stable
     */
    readonly location: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#name HdinsightSparkCluster#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#resource_group_name HdinsightSparkCluster#resource_group_name}.
     *
     * @stability stable
     */
    readonly resourceGroupName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#tags HdinsightSparkCluster#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#tier HdinsightSparkCluster#tier}.
     *
     * @stability stable
     */
    readonly tier: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#tls_min_version HdinsightSparkCluster#tls_min_version}.
     *
     * @stability stable
     */
    readonly tlsMinVersion?: string;
    /**
     * component_version block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#component_version HdinsightSparkCluster#component_version}
     *
     * @stability stable
     */
    readonly componentVersion: HdinsightSparkClusterComponentVersion[];
    /**
     * gateway block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#gateway HdinsightSparkCluster#gateway}
     *
     * @stability stable
     */
    readonly gateway: HdinsightSparkClusterGateway[];
    /**
     * metastores block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#metastores HdinsightSparkCluster#metastores}
     *
     * @stability stable
     */
    readonly metastores?: HdinsightSparkClusterMetastores[];
    /**
     * monitor block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#monitor HdinsightSparkCluster#monitor}
     *
     * @stability stable
     */
    readonly monitor?: HdinsightSparkClusterMonitor[];
    /**
     * network block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#network HdinsightSparkCluster#network}
     *
     * @stability stable
     */
    readonly network?: HdinsightSparkClusterNetwork[];
    /**
     * roles block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#roles HdinsightSparkCluster#roles}
     *
     * @stability stable
     */
    readonly roles: HdinsightSparkClusterRoles[];
    /**
     * storage_account block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#storage_account HdinsightSparkCluster#storage_account}
     *
     * @stability stable
     */
    readonly storageAccount?: HdinsightSparkClusterStorageAccount[];
    /**
     * storage_account_gen2 block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#storage_account_gen2 HdinsightSparkCluster#storage_account_gen2}
     *
     * @stability stable
     */
    readonly storageAccountGen2?: HdinsightSparkClusterStorageAccountGen2[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#timeouts HdinsightSparkCluster#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: HdinsightSparkClusterTimeouts;
}
/**
 * @stability stable
 */
export interface HdinsightSparkClusterComponentVersion {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#spark HdinsightSparkCluster#spark}.
     *
     * @stability stable
     */
    readonly spark: string;
}
/**
 * @stability stable
 */
export interface HdinsightSparkClusterGateway {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#enabled HdinsightSparkCluster#enabled}.
     *
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#password HdinsightSparkCluster#password}.
     *
     * @stability stable
     */
    readonly password: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#username HdinsightSparkCluster#username}.
     *
     * @stability stable
     */
    readonly username: string;
}
/**
 * @stability stable
 */
export interface HdinsightSparkClusterMetastoresAmbari {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#database_name HdinsightSparkCluster#database_name}.
     *
     * @stability stable
     */
    readonly databaseName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#password HdinsightSparkCluster#password}.
     *
     * @stability stable
     */
    readonly password: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#server HdinsightSparkCluster#server}.
     *
     * @stability stable
     */
    readonly server: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#username HdinsightSparkCluster#username}.
     *
     * @stability stable
     */
    readonly username: string;
}
/**
 * @stability stable
 */
export interface HdinsightSparkClusterMetastoresHive {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#database_name HdinsightSparkCluster#database_name}.
     *
     * @stability stable
     */
    readonly databaseName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#password HdinsightSparkCluster#password}.
     *
     * @stability stable
     */
    readonly password: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#server HdinsightSparkCluster#server}.
     *
     * @stability stable
     */
    readonly server: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#username HdinsightSparkCluster#username}.
     *
     * @stability stable
     */
    readonly username: string;
}
/**
 * @stability stable
 */
export interface HdinsightSparkClusterMetastoresOozie {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#database_name HdinsightSparkCluster#database_name}.
     *
     * @stability stable
     */
    readonly databaseName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#password HdinsightSparkCluster#password}.
     *
     * @stability stable
     */
    readonly password: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#server HdinsightSparkCluster#server}.
     *
     * @stability stable
     */
    readonly server: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#username HdinsightSparkCluster#username}.
     *
     * @stability stable
     */
    readonly username: string;
}
/**
 * @stability stable
 */
export interface HdinsightSparkClusterMetastores {
    /**
     * ambari block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#ambari HdinsightSparkCluster#ambari}
     *
     * @stability stable
     */
    readonly ambari?: HdinsightSparkClusterMetastoresAmbari[];
    /**
     * hive block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#hive HdinsightSparkCluster#hive}
     *
     * @stability stable
     */
    readonly hive?: HdinsightSparkClusterMetastoresHive[];
    /**
     * oozie block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#oozie HdinsightSparkCluster#oozie}
     *
     * @stability stable
     */
    readonly oozie?: HdinsightSparkClusterMetastoresOozie[];
}
/**
 * @stability stable
 */
export interface HdinsightSparkClusterMonitor {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#log_analytics_workspace_id HdinsightSparkCluster#log_analytics_workspace_id}.
     *
     * @stability stable
     */
    readonly logAnalyticsWorkspaceId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#primary_key HdinsightSparkCluster#primary_key}.
     *
     * @stability stable
     */
    readonly primaryKey: string;
}
/**
 * @stability stable
 */
export interface HdinsightSparkClusterNetwork {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#connection_direction HdinsightSparkCluster#connection_direction}.
     *
     * @stability stable
     */
    readonly connectionDirection?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#private_link_enabled HdinsightSparkCluster#private_link_enabled}.
     *
     * @stability stable
     */
    readonly privateLinkEnabled?: boolean;
}
/**
 * @stability stable
 */
export interface HdinsightSparkClusterRolesHeadNode {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#password HdinsightSparkCluster#password}.
     *
     * @stability stable
     */
    readonly password?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#ssh_keys HdinsightSparkCluster#ssh_keys}.
     *
     * @stability stable
     */
    readonly sshKeys?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#subnet_id HdinsightSparkCluster#subnet_id}.
     *
     * @stability stable
     */
    readonly subnetId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#username HdinsightSparkCluster#username}.
     *
     * @stability stable
     */
    readonly username: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#virtual_network_id HdinsightSparkCluster#virtual_network_id}.
     *
     * @stability stable
     */
    readonly virtualNetworkId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#vm_size HdinsightSparkCluster#vm_size}.
     *
     * @stability stable
     */
    readonly vmSize: string;
}
/**
 * @stability stable
 */
export interface HdinsightSparkClusterRolesWorkerNodeAutoscaleCapacity {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#max_instance_count HdinsightSparkCluster#max_instance_count}.
     *
     * @stability stable
     */
    readonly maxInstanceCount: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#min_instance_count HdinsightSparkCluster#min_instance_count}.
     *
     * @stability stable
     */
    readonly minInstanceCount: number;
}
/**
 * @stability stable
 */
export interface HdinsightSparkClusterRolesWorkerNodeAutoscaleRecurrenceSchedule {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#days HdinsightSparkCluster#days}.
     *
     * @stability stable
     */
    readonly days: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#target_instance_count HdinsightSparkCluster#target_instance_count}.
     *
     * @stability stable
     */
    readonly targetInstanceCount: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#time HdinsightSparkCluster#time}.
     *
     * @stability stable
     */
    readonly time: string;
}
/**
 * @stability stable
 */
export interface HdinsightSparkClusterRolesWorkerNodeAutoscaleRecurrence {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#timezone HdinsightSparkCluster#timezone}.
     *
     * @stability stable
     */
    readonly timezone: string;
    /**
     * schedule block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#schedule HdinsightSparkCluster#schedule}
     *
     * @stability stable
     */
    readonly schedule: HdinsightSparkClusterRolesWorkerNodeAutoscaleRecurrenceSchedule[];
}
/**
 * @stability stable
 */
export interface HdinsightSparkClusterRolesWorkerNodeAutoscale {
    /**
     * capacity block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#capacity HdinsightSparkCluster#capacity}
     *
     * @stability stable
     */
    readonly capacity?: HdinsightSparkClusterRolesWorkerNodeAutoscaleCapacity[];
    /**
     * recurrence block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#recurrence HdinsightSparkCluster#recurrence}
     *
     * @stability stable
     */
    readonly recurrence?: HdinsightSparkClusterRolesWorkerNodeAutoscaleRecurrence[];
}
/**
 * @stability stable
 */
export interface HdinsightSparkClusterRolesWorkerNode {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#min_instance_count HdinsightSparkCluster#min_instance_count}.
     *
     * @stability stable
     */
    readonly minInstanceCount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#password HdinsightSparkCluster#password}.
     *
     * @stability stable
     */
    readonly password?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#ssh_keys HdinsightSparkCluster#ssh_keys}.
     *
     * @stability stable
     */
    readonly sshKeys?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#subnet_id HdinsightSparkCluster#subnet_id}.
     *
     * @stability stable
     */
    readonly subnetId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#target_instance_count HdinsightSparkCluster#target_instance_count}.
     *
     * @stability stable
     */
    readonly targetInstanceCount: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#username HdinsightSparkCluster#username}.
     *
     * @stability stable
     */
    readonly username: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#virtual_network_id HdinsightSparkCluster#virtual_network_id}.
     *
     * @stability stable
     */
    readonly virtualNetworkId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#vm_size HdinsightSparkCluster#vm_size}.
     *
     * @stability stable
     */
    readonly vmSize: string;
    /**
     * autoscale block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#autoscale HdinsightSparkCluster#autoscale}
     *
     * @stability stable
     */
    readonly autoscale?: HdinsightSparkClusterRolesWorkerNodeAutoscale[];
}
/**
 * @stability stable
 */
export interface HdinsightSparkClusterRolesZookeeperNode {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#password HdinsightSparkCluster#password}.
     *
     * @stability stable
     */
    readonly password?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#ssh_keys HdinsightSparkCluster#ssh_keys}.
     *
     * @stability stable
     */
    readonly sshKeys?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#subnet_id HdinsightSparkCluster#subnet_id}.
     *
     * @stability stable
     */
    readonly subnetId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#username HdinsightSparkCluster#username}.
     *
     * @stability stable
     */
    readonly username: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#virtual_network_id HdinsightSparkCluster#virtual_network_id}.
     *
     * @stability stable
     */
    readonly virtualNetworkId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#vm_size HdinsightSparkCluster#vm_size}.
     *
     * @stability stable
     */
    readonly vmSize: string;
}
/**
 * @stability stable
 */
export interface HdinsightSparkClusterRoles {
    /**
     * head_node block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#head_node HdinsightSparkCluster#head_node}
     *
     * @stability stable
     */
    readonly headNode: HdinsightSparkClusterRolesHeadNode[];
    /**
     * worker_node block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#worker_node HdinsightSparkCluster#worker_node}
     *
     * @stability stable
     */
    readonly workerNode: HdinsightSparkClusterRolesWorkerNode[];
    /**
     * zookeeper_node block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#zookeeper_node HdinsightSparkCluster#zookeeper_node}
     *
     * @stability stable
     */
    readonly zookeeperNode: HdinsightSparkClusterRolesZookeeperNode[];
}
/**
 * @stability stable
 */
export interface HdinsightSparkClusterStorageAccount {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#is_default HdinsightSparkCluster#is_default}.
     *
     * @stability stable
     */
    readonly isDefault: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#storage_account_key HdinsightSparkCluster#storage_account_key}.
     *
     * @stability stable
     */
    readonly storageAccountKey: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#storage_container_id HdinsightSparkCluster#storage_container_id}.
     *
     * @stability stable
     */
    readonly storageContainerId: string;
}
/**
 * @stability stable
 */
export interface HdinsightSparkClusterStorageAccountGen2 {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#filesystem_id HdinsightSparkCluster#filesystem_id}.
     *
     * @stability stable
     */
    readonly filesystemId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#is_default HdinsightSparkCluster#is_default}.
     *
     * @stability stable
     */
    readonly isDefault: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#managed_identity_resource_id HdinsightSparkCluster#managed_identity_resource_id}.
     *
     * @stability stable
     */
    readonly managedIdentityResourceId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#storage_resource_id HdinsightSparkCluster#storage_resource_id}.
     *
     * @stability stable
     */
    readonly storageResourceId: string;
}
/**
 * @stability stable
 */
export interface HdinsightSparkClusterTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#create HdinsightSparkCluster#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#delete HdinsightSparkCluster#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#read HdinsightSparkCluster#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html#update HdinsightSparkCluster#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html azurerm_hdinsight_spark_cluster}.
 *
 * @stability stable
 */
export declare class HdinsightSparkCluster extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/hdinsight_spark_cluster.html azurerm_hdinsight_spark_cluster} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: HdinsightSparkClusterConfig);
    private _clusterVersion;
    /**
     * @stability stable
     */
    get clusterVersion(): string;
    /**
     * @stability stable
     */
    set clusterVersion(value: string);
    /**
     * @stability stable
     */
    get clusterVersionInput(): string;
    /**
     * @stability stable
     */
    get httpsEndpoint(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _location;
    /**
     * @stability stable
     */
    get location(): string;
    /**
     * @stability stable
     */
    set location(value: string);
    /**
     * @stability stable
     */
    get locationInput(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _resourceGroupName;
    /**
     * @stability stable
     */
    get resourceGroupName(): string;
    /**
     * @stability stable
     */
    set resourceGroupName(value: string);
    /**
     * @stability stable
     */
    get resourceGroupNameInput(): string;
    /**
     * @stability stable
     */
    get sshEndpoint(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tier;
    /**
     * @stability stable
     */
    get tier(): string;
    /**
     * @stability stable
     */
    set tier(value: string);
    /**
     * @stability stable
     */
    get tierInput(): string;
    private _tlsMinVersion?;
    /**
     * @stability stable
     */
    get tlsMinVersion(): string;
    /**
     * @stability stable
     */
    set tlsMinVersion(value: string);
    /**
     * @stability stable
     */
    resetTlsMinVersion(): void;
    /**
     * @stability stable
     */
    get tlsMinVersionInput(): string | undefined;
    private _componentVersion;
    /**
     * @stability stable
     */
    get componentVersion(): HdinsightSparkClusterComponentVersion[];
    /**
     * @stability stable
     */
    set componentVersion(value: HdinsightSparkClusterComponentVersion[]);
    /**
     * @stability stable
     */
    get componentVersionInput(): HdinsightSparkClusterComponentVersion[];
    private _gateway;
    /**
     * @stability stable
     */
    get gateway(): HdinsightSparkClusterGateway[];
    /**
     * @stability stable
     */
    set gateway(value: HdinsightSparkClusterGateway[]);
    /**
     * @stability stable
     */
    get gatewayInput(): HdinsightSparkClusterGateway[];
    private _metastores?;
    /**
     * @stability stable
     */
    get metastores(): HdinsightSparkClusterMetastores[];
    /**
     * @stability stable
     */
    set metastores(value: HdinsightSparkClusterMetastores[]);
    /**
     * @stability stable
     */
    resetMetastores(): void;
    /**
     * @stability stable
     */
    get metastoresInput(): HdinsightSparkClusterMetastores[] | undefined;
    private _monitor?;
    /**
     * @stability stable
     */
    get monitor(): HdinsightSparkClusterMonitor[];
    /**
     * @stability stable
     */
    set monitor(value: HdinsightSparkClusterMonitor[]);
    /**
     * @stability stable
     */
    resetMonitor(): void;
    /**
     * @stability stable
     */
    get monitorInput(): HdinsightSparkClusterMonitor[] | undefined;
    private _network?;
    /**
     * @stability stable
     */
    get network(): HdinsightSparkClusterNetwork[];
    /**
     * @stability stable
     */
    set network(value: HdinsightSparkClusterNetwork[]);
    /**
     * @stability stable
     */
    resetNetwork(): void;
    /**
     * @stability stable
     */
    get networkInput(): HdinsightSparkClusterNetwork[] | undefined;
    private _roles;
    /**
     * @stability stable
     */
    get roles(): HdinsightSparkClusterRoles[];
    /**
     * @stability stable
     */
    set roles(value: HdinsightSparkClusterRoles[]);
    /**
     * @stability stable
     */
    get rolesInput(): HdinsightSparkClusterRoles[];
    private _storageAccount?;
    /**
     * @stability stable
     */
    get storageAccount(): HdinsightSparkClusterStorageAccount[];
    /**
     * @stability stable
     */
    set storageAccount(value: HdinsightSparkClusterStorageAccount[]);
    /**
     * @stability stable
     */
    resetStorageAccount(): void;
    /**
     * @stability stable
     */
    get storageAccountInput(): HdinsightSparkClusterStorageAccount[] | undefined;
    private _storageAccountGen2?;
    /**
     * @stability stable
     */
    get storageAccountGen2(): HdinsightSparkClusterStorageAccountGen2[];
    /**
     * @stability stable
     */
    set storageAccountGen2(value: HdinsightSparkClusterStorageAccountGen2[]);
    /**
     * @stability stable
     */
    resetStorageAccountGen2(): void;
    /**
     * @stability stable
     */
    get storageAccountGen2Input(): HdinsightSparkClusterStorageAccountGen2[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): HdinsightSparkClusterTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: HdinsightSparkClusterTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): HdinsightSparkClusterTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
