import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface IotSecurityDeviceGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_device_group.html#iothub_id IotSecurityDeviceGroup#iothub_id}.
     *
     * @stability stable
     */
    readonly iothubId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_device_group.html#name IotSecurityDeviceGroup#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * allow_rule block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_device_group.html#allow_rule IotSecurityDeviceGroup#allow_rule}
     *
     * @stability stable
     */
    readonly allowRule?: IotSecurityDeviceGroupAllowRule[];
    /**
     * range_rule block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_device_group.html#range_rule IotSecurityDeviceGroup#range_rule}
     *
     * @stability stable
     */
    readonly rangeRule?: IotSecurityDeviceGroupRangeRule[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_device_group.html#timeouts IotSecurityDeviceGroup#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: IotSecurityDeviceGroupTimeouts;
}
/**
 * @stability stable
 */
export interface IotSecurityDeviceGroupAllowRule {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_device_group.html#connection_to_ip_not_allowed IotSecurityDeviceGroup#connection_to_ip_not_allowed}.
     *
     * @stability stable
     */
    readonly connectionToIpNotAllowed?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_device_group.html#local_user_not_allowed IotSecurityDeviceGroup#local_user_not_allowed}.
     *
     * @stability stable
     */
    readonly localUserNotAllowed?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_device_group.html#process_not_allowed IotSecurityDeviceGroup#process_not_allowed}.
     *
     * @stability stable
     */
    readonly processNotAllowed?: string[];
}
/**
 * @stability stable
 */
export interface IotSecurityDeviceGroupRangeRule {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_device_group.html#duration IotSecurityDeviceGroup#duration}.
     *
     * @stability stable
     */
    readonly duration: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_device_group.html#max IotSecurityDeviceGroup#max}.
     *
     * @stability stable
     */
    readonly max: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_device_group.html#min IotSecurityDeviceGroup#min}.
     *
     * @stability stable
     */
    readonly min: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_device_group.html#type IotSecurityDeviceGroup#type}.
     *
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface IotSecurityDeviceGroupTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_device_group.html#create IotSecurityDeviceGroup#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_device_group.html#delete IotSecurityDeviceGroup#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_device_group.html#read IotSecurityDeviceGroup#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_device_group.html#update IotSecurityDeviceGroup#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_device_group.html azurerm_iot_security_device_group}.
 *
 * @stability stable
 */
export declare class IotSecurityDeviceGroup extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_device_group.html azurerm_iot_security_device_group} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: IotSecurityDeviceGroupConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _iothubId;
    /**
     * @stability stable
     */
    get iothubId(): string;
    /**
     * @stability stable
     */
    set iothubId(value: string);
    /**
     * @stability stable
     */
    get iothubIdInput(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _allowRule?;
    /**
     * @stability stable
     */
    get allowRule(): IotSecurityDeviceGroupAllowRule[];
    /**
     * @stability stable
     */
    set allowRule(value: IotSecurityDeviceGroupAllowRule[]);
    /**
     * @stability stable
     */
    resetAllowRule(): void;
    /**
     * @stability stable
     */
    get allowRuleInput(): IotSecurityDeviceGroupAllowRule[] | undefined;
    private _rangeRule?;
    /**
     * @stability stable
     */
    get rangeRule(): IotSecurityDeviceGroupRangeRule[];
    /**
     * @stability stable
     */
    set rangeRule(value: IotSecurityDeviceGroupRangeRule[]);
    /**
     * @stability stable
     */
    resetRangeRule(): void;
    /**
     * @stability stable
     */
    get rangeRuleInput(): IotSecurityDeviceGroupRangeRule[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): IotSecurityDeviceGroupTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: IotSecurityDeviceGroupTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): IotSecurityDeviceGroupTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
