import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface IotTimeSeriesInsightsEventSourceIothubConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_time_series_insights_event_source_iothub.html#consumer_group_name IotTimeSeriesInsightsEventSourceIothub#consumer_group_name}.
     *
     * @stability stable
     */
    readonly consumerGroupName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_time_series_insights_event_source_iothub.html#environment_id IotTimeSeriesInsightsEventSourceIothub#environment_id}.
     *
     * @stability stable
     */
    readonly environmentId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_time_series_insights_event_source_iothub.html#event_source_resource_id IotTimeSeriesInsightsEventSourceIothub#event_source_resource_id}.
     *
     * @stability stable
     */
    readonly eventSourceResourceId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_time_series_insights_event_source_iothub.html#iothub_name IotTimeSeriesInsightsEventSourceIothub#iothub_name}.
     *
     * @stability stable
     */
    readonly iothubName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_time_series_insights_event_source_iothub.html#location IotTimeSeriesInsightsEventSourceIothub#location}.
     *
     * @stability stable
     */
    readonly location: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_time_series_insights_event_source_iothub.html#name IotTimeSeriesInsightsEventSourceIothub#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_time_series_insights_event_source_iothub.html#shared_access_key IotTimeSeriesInsightsEventSourceIothub#shared_access_key}.
     *
     * @stability stable
     */
    readonly sharedAccessKey: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_time_series_insights_event_source_iothub.html#shared_access_key_name IotTimeSeriesInsightsEventSourceIothub#shared_access_key_name}.
     *
     * @stability stable
     */
    readonly sharedAccessKeyName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_time_series_insights_event_source_iothub.html#tags IotTimeSeriesInsightsEventSourceIothub#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_time_series_insights_event_source_iothub.html#timestamp_property_name IotTimeSeriesInsightsEventSourceIothub#timestamp_property_name}.
     *
     * @stability stable
     */
    readonly timestampPropertyName?: string;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_time_series_insights_event_source_iothub.html#timeouts IotTimeSeriesInsightsEventSourceIothub#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: IotTimeSeriesInsightsEventSourceIothubTimeouts;
}
/**
 * @stability stable
 */
export interface IotTimeSeriesInsightsEventSourceIothubTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_time_series_insights_event_source_iothub.html#create IotTimeSeriesInsightsEventSourceIothub#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_time_series_insights_event_source_iothub.html#delete IotTimeSeriesInsightsEventSourceIothub#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_time_series_insights_event_source_iothub.html#read IotTimeSeriesInsightsEventSourceIothub#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_time_series_insights_event_source_iothub.html#update IotTimeSeriesInsightsEventSourceIothub#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/iot_time_series_insights_event_source_iothub.html azurerm_iot_time_series_insights_event_source_iothub}.
 *
 * @stability stable
 */
export declare class IotTimeSeriesInsightsEventSourceIothub extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/iot_time_series_insights_event_source_iothub.html azurerm_iot_time_series_insights_event_source_iothub} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: IotTimeSeriesInsightsEventSourceIothubConfig);
    private _consumerGroupName;
    /**
     * @stability stable
     */
    get consumerGroupName(): string;
    /**
     * @stability stable
     */
    set consumerGroupName(value: string);
    /**
     * @stability stable
     */
    get consumerGroupNameInput(): string;
    private _environmentId;
    /**
     * @stability stable
     */
    get environmentId(): string;
    /**
     * @stability stable
     */
    set environmentId(value: string);
    /**
     * @stability stable
     */
    get environmentIdInput(): string;
    private _eventSourceResourceId;
    /**
     * @stability stable
     */
    get eventSourceResourceId(): string;
    /**
     * @stability stable
     */
    set eventSourceResourceId(value: string);
    /**
     * @stability stable
     */
    get eventSourceResourceIdInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _iothubName;
    /**
     * @stability stable
     */
    get iothubName(): string;
    /**
     * @stability stable
     */
    set iothubName(value: string);
    /**
     * @stability stable
     */
    get iothubNameInput(): string;
    private _location;
    /**
     * @stability stable
     */
    get location(): string;
    /**
     * @stability stable
     */
    set location(value: string);
    /**
     * @stability stable
     */
    get locationInput(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _sharedAccessKey;
    /**
     * @stability stable
     */
    get sharedAccessKey(): string;
    /**
     * @stability stable
     */
    set sharedAccessKey(value: string);
    /**
     * @stability stable
     */
    get sharedAccessKeyInput(): string;
    private _sharedAccessKeyName;
    /**
     * @stability stable
     */
    get sharedAccessKeyName(): string;
    /**
     * @stability stable
     */
    set sharedAccessKeyName(value: string);
    /**
     * @stability stable
     */
    get sharedAccessKeyNameInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _timestampPropertyName?;
    /**
     * @stability stable
     */
    get timestampPropertyName(): string;
    /**
     * @stability stable
     */
    set timestampPropertyName(value: string);
    /**
     * @stability stable
     */
    resetTimestampPropertyName(): void;
    /**
     * @stability stable
     */
    get timestampPropertyNameInput(): string | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): IotTimeSeriesInsightsEventSourceIothubTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: IotTimeSeriesInsightsEventSourceIothubTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): IotTimeSeriesInsightsEventSourceIothubTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
