import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface KubernetesClusterConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#api_server_authorized_ip_ranges KubernetesCluster#api_server_authorized_ip_ranges}.
     *
     * @stability stable
     */
    readonly apiServerAuthorizedIpRanges?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#automatic_channel_upgrade KubernetesCluster#automatic_channel_upgrade}.
     *
     * @stability stable
     */
    readonly automaticChannelUpgrade?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#disk_encryption_set_id KubernetesCluster#disk_encryption_set_id}.
     *
     * @stability stable
     */
    readonly diskEncryptionSetId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#dns_prefix KubernetesCluster#dns_prefix}.
     *
     * @stability stable
     */
    readonly dnsPrefix?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#dns_prefix_private_cluster KubernetesCluster#dns_prefix_private_cluster}.
     *
     * @stability stable
     */
    readonly dnsPrefixPrivateCluster?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#enable_pod_security_policy KubernetesCluster#enable_pod_security_policy}.
     *
     * @stability stable
     */
    readonly enablePodSecurityPolicy?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#kubernetes_version KubernetesCluster#kubernetes_version}.
     *
     * @stability stable
     */
    readonly kubernetesVersion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#location KubernetesCluster#location}.
     *
     * @stability stable
     */
    readonly location: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#name KubernetesCluster#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#node_resource_group KubernetesCluster#node_resource_group}.
     *
     * @stability stable
     */
    readonly nodeResourceGroup?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#private_cluster_enabled KubernetesCluster#private_cluster_enabled}.
     *
     * @stability stable
     */
    readonly privateClusterEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#private_dns_zone_id KubernetesCluster#private_dns_zone_id}.
     *
     * @stability stable
     */
    readonly privateDnsZoneId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#private_link_enabled KubernetesCluster#private_link_enabled}.
     *
     * @stability stable
     */
    readonly privateLinkEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#resource_group_name KubernetesCluster#resource_group_name}.
     *
     * @stability stable
     */
    readonly resourceGroupName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#sku_tier KubernetesCluster#sku_tier}.
     *
     * @stability stable
     */
    readonly skuTier?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#tags KubernetesCluster#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * addon_profile block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#addon_profile KubernetesCluster#addon_profile}
     *
     * @stability stable
     */
    readonly addonProfile?: KubernetesClusterAddonProfile[];
    /**
     * auto_scaler_profile block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#auto_scaler_profile KubernetesCluster#auto_scaler_profile}
     *
     * @stability stable
     */
    readonly autoScalerProfile?: KubernetesClusterAutoScalerProfile[];
    /**
     * default_node_pool block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#default_node_pool KubernetesCluster#default_node_pool}
     *
     * @stability stable
     */
    readonly defaultNodePool: KubernetesClusterDefaultNodePool[];
    /**
     * identity block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#identity KubernetesCluster#identity}
     *
     * @stability stable
     */
    readonly identity?: KubernetesClusterIdentity[];
    /**
     * kubelet_identity block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#kubelet_identity KubernetesCluster#kubelet_identity}
     *
     * @stability stable
     */
    readonly kubeletIdentity?: KubernetesClusterKubeletIdentity[];
    /**
     * linux_profile block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#linux_profile KubernetesCluster#linux_profile}
     *
     * @stability stable
     */
    readonly linuxProfile?: KubernetesClusterLinuxProfile[];
    /**
     * network_profile block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#network_profile KubernetesCluster#network_profile}
     *
     * @stability stable
     */
    readonly networkProfile?: KubernetesClusterNetworkProfile[];
    /**
     * role_based_access_control block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#role_based_access_control KubernetesCluster#role_based_access_control}
     *
     * @stability stable
     */
    readonly roleBasedAccessControl?: KubernetesClusterRoleBasedAccessControl[];
    /**
     * service_principal block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#service_principal KubernetesCluster#service_principal}
     *
     * @stability stable
     */
    readonly servicePrincipal?: KubernetesClusterServicePrincipal[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#timeouts KubernetesCluster#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: KubernetesClusterTimeouts;
    /**
     * windows_profile block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#windows_profile KubernetesCluster#windows_profile}
     *
     * @stability stable
     */
    readonly windowsProfile?: KubernetesClusterWindowsProfile[];
}
/**
 * @stability stable
 */
export declare class KubernetesClusterKubeAdminConfig extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get clientCertificate(): string;
    /**
     * @stability stable
     */
    get clientKey(): string;
    /**
     * @stability stable
     */
    get clusterCaCertificate(): string;
    /**
     * @stability stable
     */
    get host(): string;
    /**
     * @stability stable
     */
    get password(): string;
    /**
     * @stability stable
     */
    get username(): string;
}
/**
 * @stability stable
 */
export declare class KubernetesClusterKubeConfig extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get clientCertificate(): string;
    /**
     * @stability stable
     */
    get clientKey(): string;
    /**
     * @stability stable
     */
    get clusterCaCertificate(): string;
    /**
     * @stability stable
     */
    get host(): string;
    /**
     * @stability stable
     */
    get password(): string;
    /**
     * @stability stable
     */
    get username(): string;
}
/**
 * @stability stable
 */
export interface KubernetesClusterAddonProfileAciConnectorLinux {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#enabled KubernetesCluster#enabled}.
     *
     * @stability stable
     */
    readonly enabled: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#subnet_name KubernetesCluster#subnet_name}.
     *
     * @stability stable
     */
    readonly subnetName?: string;
}
/**
 * @stability stable
 */
export interface KubernetesClusterAddonProfileAzurePolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#enabled KubernetesCluster#enabled}.
     *
     * @stability stable
     */
    readonly enabled: boolean;
}
/**
 * @stability stable
 */
export interface KubernetesClusterAddonProfileHttpApplicationRouting {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#enabled KubernetesCluster#enabled}.
     *
     * @stability stable
     */
    readonly enabled: boolean;
}
/**
 * @stability stable
 */
export interface KubernetesClusterAddonProfileIngressApplicationGateway {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#enabled KubernetesCluster#enabled}.
     *
     * @stability stable
     */
    readonly enabled: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#gateway_id KubernetesCluster#gateway_id}.
     *
     * @stability stable
     */
    readonly gatewayId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#gateway_name KubernetesCluster#gateway_name}.
     *
     * @stability stable
     */
    readonly gatewayName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#subnet_cidr KubernetesCluster#subnet_cidr}.
     *
     * @stability stable
     */
    readonly subnetCidr?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#subnet_id KubernetesCluster#subnet_id}.
     *
     * @stability stable
     */
    readonly subnetId?: string;
}
/**
 * @stability stable
 */
export interface KubernetesClusterAddonProfileKubeDashboard {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#enabled KubernetesCluster#enabled}.
     *
     * @stability stable
     */
    readonly enabled: boolean;
}
/**
 * @stability stable
 */
export interface KubernetesClusterAddonProfileOmsAgent {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#enabled KubernetesCluster#enabled}.
     *
     * @stability stable
     */
    readonly enabled: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#log_analytics_workspace_id KubernetesCluster#log_analytics_workspace_id}.
     *
     * @stability stable
     */
    readonly logAnalyticsWorkspaceId?: string;
}
/**
 * @stability stable
 */
export interface KubernetesClusterAddonProfile {
    /**
     * aci_connector_linux block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#aci_connector_linux KubernetesCluster#aci_connector_linux}
     *
     * @stability stable
     */
    readonly aciConnectorLinux?: KubernetesClusterAddonProfileAciConnectorLinux[];
    /**
     * azure_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#azure_policy KubernetesCluster#azure_policy}
     *
     * @stability stable
     */
    readonly azurePolicy?: KubernetesClusterAddonProfileAzurePolicy[];
    /**
     * http_application_routing block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#http_application_routing KubernetesCluster#http_application_routing}
     *
     * @stability stable
     */
    readonly httpApplicationRouting?: KubernetesClusterAddonProfileHttpApplicationRouting[];
    /**
     * ingress_application_gateway block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#ingress_application_gateway KubernetesCluster#ingress_application_gateway}
     *
     * @stability stable
     */
    readonly ingressApplicationGateway?: KubernetesClusterAddonProfileIngressApplicationGateway[];
    /**
     * kube_dashboard block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#kube_dashboard KubernetesCluster#kube_dashboard}
     *
     * @stability stable
     */
    readonly kubeDashboard?: KubernetesClusterAddonProfileKubeDashboard[];
    /**
     * oms_agent block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#oms_agent KubernetesCluster#oms_agent}
     *
     * @stability stable
     */
    readonly omsAgent?: KubernetesClusterAddonProfileOmsAgent[];
}
/**
 * @stability stable
 */
export interface KubernetesClusterAutoScalerProfile {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#balance_similar_node_groups KubernetesCluster#balance_similar_node_groups}.
     *
     * @stability stable
     */
    readonly balanceSimilarNodeGroups?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#empty_bulk_delete_max KubernetesCluster#empty_bulk_delete_max}.
     *
     * @stability stable
     */
    readonly emptyBulkDeleteMax?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#expander KubernetesCluster#expander}.
     *
     * @stability stable
     */
    readonly expander?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#max_graceful_termination_sec KubernetesCluster#max_graceful_termination_sec}.
     *
     * @stability stable
     */
    readonly maxGracefulTerminationSec?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#max_node_provisioning_time KubernetesCluster#max_node_provisioning_time}.
     *
     * @stability stable
     */
    readonly maxNodeProvisioningTime?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#max_unready_nodes KubernetesCluster#max_unready_nodes}.
     *
     * @stability stable
     */
    readonly maxUnreadyNodes?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#max_unready_percentage KubernetesCluster#max_unready_percentage}.
     *
     * @stability stable
     */
    readonly maxUnreadyPercentage?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#new_pod_scale_up_delay KubernetesCluster#new_pod_scale_up_delay}.
     *
     * @stability stable
     */
    readonly newPodScaleUpDelay?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#scale_down_delay_after_add KubernetesCluster#scale_down_delay_after_add}.
     *
     * @stability stable
     */
    readonly scaleDownDelayAfterAdd?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#scale_down_delay_after_delete KubernetesCluster#scale_down_delay_after_delete}.
     *
     * @stability stable
     */
    readonly scaleDownDelayAfterDelete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#scale_down_delay_after_failure KubernetesCluster#scale_down_delay_after_failure}.
     *
     * @stability stable
     */
    readonly scaleDownDelayAfterFailure?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#scale_down_unneeded KubernetesCluster#scale_down_unneeded}.
     *
     * @stability stable
     */
    readonly scaleDownUnneeded?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#scale_down_unready KubernetesCluster#scale_down_unready}.
     *
     * @stability stable
     */
    readonly scaleDownUnready?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#scale_down_utilization_threshold KubernetesCluster#scale_down_utilization_threshold}.
     *
     * @stability stable
     */
    readonly scaleDownUtilizationThreshold?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#scan_interval KubernetesCluster#scan_interval}.
     *
     * @stability stable
     */
    readonly scanInterval?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#skip_nodes_with_local_storage KubernetesCluster#skip_nodes_with_local_storage}.
     *
     * @stability stable
     */
    readonly skipNodesWithLocalStorage?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#skip_nodes_with_system_pods KubernetesCluster#skip_nodes_with_system_pods}.
     *
     * @stability stable
     */
    readonly skipNodesWithSystemPods?: boolean;
}
/**
 * @stability stable
 */
export interface KubernetesClusterDefaultNodePoolKubeletConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#allowed_unsafe_sysctls KubernetesCluster#allowed_unsafe_sysctls}.
     *
     * @stability stable
     */
    readonly allowedUnsafeSysctls?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#container_log_max_line KubernetesCluster#container_log_max_line}.
     *
     * @stability stable
     */
    readonly containerLogMaxLine?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#container_log_max_size_mb KubernetesCluster#container_log_max_size_mb}.
     *
     * @stability stable
     */
    readonly containerLogMaxSizeMb?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#cpu_cfs_quota_enabled KubernetesCluster#cpu_cfs_quota_enabled}.
     *
     * @stability stable
     */
    readonly cpuCfsQuotaEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#cpu_cfs_quota_period KubernetesCluster#cpu_cfs_quota_period}.
     *
     * @stability stable
     */
    readonly cpuCfsQuotaPeriod?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#cpu_manager_policy KubernetesCluster#cpu_manager_policy}.
     *
     * @stability stable
     */
    readonly cpuManagerPolicy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#image_gc_high_threshold KubernetesCluster#image_gc_high_threshold}.
     *
     * @stability stable
     */
    readonly imageGcHighThreshold?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#image_gc_low_threshold KubernetesCluster#image_gc_low_threshold}.
     *
     * @stability stable
     */
    readonly imageGcLowThreshold?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#pod_max_pid KubernetesCluster#pod_max_pid}.
     *
     * @stability stable
     */
    readonly podMaxPid?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#topology_manager_policy KubernetesCluster#topology_manager_policy}.
     *
     * @stability stable
     */
    readonly topologyManagerPolicy?: string;
}
/**
 * @stability stable
 */
export interface KubernetesClusterDefaultNodePoolLinuxOsConfigSysctlConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#fs_aio_max_nr KubernetesCluster#fs_aio_max_nr}.
     *
     * @stability stable
     */
    readonly fsAioMaxNr?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#fs_file_max KubernetesCluster#fs_file_max}.
     *
     * @stability stable
     */
    readonly fsFileMax?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#fs_inotify_max_user_watches KubernetesCluster#fs_inotify_max_user_watches}.
     *
     * @stability stable
     */
    readonly fsInotifyMaxUserWatches?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#fs_nr_open KubernetesCluster#fs_nr_open}.
     *
     * @stability stable
     */
    readonly fsNrOpen?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#kernel_threads_max KubernetesCluster#kernel_threads_max}.
     *
     * @stability stable
     */
    readonly kernelThreadsMax?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#net_core_netdev_max_backlog KubernetesCluster#net_core_netdev_max_backlog}.
     *
     * @stability stable
     */
    readonly netCoreNetdevMaxBacklog?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#net_core_optmem_max KubernetesCluster#net_core_optmem_max}.
     *
     * @stability stable
     */
    readonly netCoreOptmemMax?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#net_core_rmem_default KubernetesCluster#net_core_rmem_default}.
     *
     * @stability stable
     */
    readonly netCoreRmemDefault?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#net_core_rmem_max KubernetesCluster#net_core_rmem_max}.
     *
     * @stability stable
     */
    readonly netCoreRmemMax?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#net_core_somaxconn KubernetesCluster#net_core_somaxconn}.
     *
     * @stability stable
     */
    readonly netCoreSomaxconn?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#net_core_wmem_default KubernetesCluster#net_core_wmem_default}.
     *
     * @stability stable
     */
    readonly netCoreWmemDefault?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#net_core_wmem_max KubernetesCluster#net_core_wmem_max}.
     *
     * @stability stable
     */
    readonly netCoreWmemMax?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#net_ipv4_ip_local_port_range_max KubernetesCluster#net_ipv4_ip_local_port_range_max}.
     *
     * @stability stable
     */
    readonly netIpv4IpLocalPortRangeMax?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#net_ipv4_ip_local_port_range_min KubernetesCluster#net_ipv4_ip_local_port_range_min}.
     *
     * @stability stable
     */
    readonly netIpv4IpLocalPortRangeMin?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#net_ipv4_neigh_default_gc_thresh1 KubernetesCluster#net_ipv4_neigh_default_gc_thresh1}.
     *
     * @stability stable
     */
    readonly netIpv4NeighDefaultGcThresh1?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#net_ipv4_neigh_default_gc_thresh2 KubernetesCluster#net_ipv4_neigh_default_gc_thresh2}.
     *
     * @stability stable
     */
    readonly netIpv4NeighDefaultGcThresh2?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#net_ipv4_neigh_default_gc_thresh3 KubernetesCluster#net_ipv4_neigh_default_gc_thresh3}.
     *
     * @stability stable
     */
    readonly netIpv4NeighDefaultGcThresh3?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#net_ipv4_tcp_fin_timeout KubernetesCluster#net_ipv4_tcp_fin_timeout}.
     *
     * @stability stable
     */
    readonly netIpv4TcpFinTimeout?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#net_ipv4_tcp_keepalive_intvl KubernetesCluster#net_ipv4_tcp_keepalive_intvl}.
     *
     * @stability stable
     */
    readonly netIpv4TcpKeepaliveIntvl?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#net_ipv4_tcp_keepalive_probes KubernetesCluster#net_ipv4_tcp_keepalive_probes}.
     *
     * @stability stable
     */
    readonly netIpv4TcpKeepaliveProbes?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#net_ipv4_tcp_keepalive_time KubernetesCluster#net_ipv4_tcp_keepalive_time}.
     *
     * @stability stable
     */
    readonly netIpv4TcpKeepaliveTime?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#net_ipv4_tcp_max_syn_backlog KubernetesCluster#net_ipv4_tcp_max_syn_backlog}.
     *
     * @stability stable
     */
    readonly netIpv4TcpMaxSynBacklog?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#net_ipv4_tcp_max_tw_buckets KubernetesCluster#net_ipv4_tcp_max_tw_buckets}.
     *
     * @stability stable
     */
    readonly netIpv4TcpMaxTwBuckets?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#net_ipv4_tcp_tw_reuse KubernetesCluster#net_ipv4_tcp_tw_reuse}.
     *
     * @stability stable
     */
    readonly netIpv4TcpTwReuse?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#net_netfilter_nf_conntrack_buckets KubernetesCluster#net_netfilter_nf_conntrack_buckets}.
     *
     * @stability stable
     */
    readonly netNetfilterNfConntrackBuckets?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#net_netfilter_nf_conntrack_max KubernetesCluster#net_netfilter_nf_conntrack_max}.
     *
     * @stability stable
     */
    readonly netNetfilterNfConntrackMax?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#vm_max_map_count KubernetesCluster#vm_max_map_count}.
     *
     * @stability stable
     */
    readonly vmMaxMapCount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#vm_swappiness KubernetesCluster#vm_swappiness}.
     *
     * @stability stable
     */
    readonly vmSwappiness?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#vm_vfs_cache_pressure KubernetesCluster#vm_vfs_cache_pressure}.
     *
     * @stability stable
     */
    readonly vmVfsCachePressure?: number;
}
/**
 * @stability stable
 */
export interface KubernetesClusterDefaultNodePoolLinuxOsConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#swap_file_size_mb KubernetesCluster#swap_file_size_mb}.
     *
     * @stability stable
     */
    readonly swapFileSizeMb?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#transparent_huge_page_defrag KubernetesCluster#transparent_huge_page_defrag}.
     *
     * @stability stable
     */
    readonly transparentHugePageDefrag?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#transparent_huge_page_enabled KubernetesCluster#transparent_huge_page_enabled}.
     *
     * @stability stable
     */
    readonly transparentHugePageEnabled?: string;
    /**
     * sysctl_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#sysctl_config KubernetesCluster#sysctl_config}
     *
     * @stability stable
     */
    readonly sysctlConfig?: KubernetesClusterDefaultNodePoolLinuxOsConfigSysctlConfig[];
}
/**
 * @stability stable
 */
export interface KubernetesClusterDefaultNodePoolUpgradeSettings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#max_surge KubernetesCluster#max_surge}.
     *
     * @stability stable
     */
    readonly maxSurge: string;
}
/**
 * @stability stable
 */
export interface KubernetesClusterDefaultNodePool {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#availability_zones KubernetesCluster#availability_zones}.
     *
     * @stability stable
     */
    readonly availabilityZones?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#enable_auto_scaling KubernetesCluster#enable_auto_scaling}.
     *
     * @stability stable
     */
    readonly enableAutoScaling?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#enable_host_encryption KubernetesCluster#enable_host_encryption}.
     *
     * @stability stable
     */
    readonly enableHostEncryption?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#enable_node_public_ip KubernetesCluster#enable_node_public_ip}.
     *
     * @stability stable
     */
    readonly enableNodePublicIp?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#max_count KubernetesCluster#max_count}.
     *
     * @stability stable
     */
    readonly maxCount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#max_pods KubernetesCluster#max_pods}.
     *
     * @stability stable
     */
    readonly maxPods?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#min_count KubernetesCluster#min_count}.
     *
     * @stability stable
     */
    readonly minCount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#name KubernetesCluster#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#node_count KubernetesCluster#node_count}.
     *
     * @stability stable
     */
    readonly nodeCount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#node_labels KubernetesCluster#node_labels}.
     *
     * @stability stable
     */
    readonly nodeLabels?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#node_public_ip_prefix_id KubernetesCluster#node_public_ip_prefix_id}.
     *
     * @stability stable
     */
    readonly nodePublicIpPrefixId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#node_taints KubernetesCluster#node_taints}.
     *
     * @stability stable
     */
    readonly nodeTaints?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#only_critical_addons_enabled KubernetesCluster#only_critical_addons_enabled}.
     *
     * @stability stable
     */
    readonly onlyCriticalAddonsEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#orchestrator_version KubernetesCluster#orchestrator_version}.
     *
     * @stability stable
     */
    readonly orchestratorVersion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#os_disk_size_gb KubernetesCluster#os_disk_size_gb}.
     *
     * @stability stable
     */
    readonly osDiskSizeGb?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#os_disk_type KubernetesCluster#os_disk_type}.
     *
     * @stability stable
     */
    readonly osDiskType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#proximity_placement_group_id KubernetesCluster#proximity_placement_group_id}.
     *
     * @stability stable
     */
    readonly proximityPlacementGroupId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#tags KubernetesCluster#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#type KubernetesCluster#type}.
     *
     * @stability stable
     */
    readonly type?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#vm_size KubernetesCluster#vm_size}.
     *
     * @stability stable
     */
    readonly vmSize: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#vnet_subnet_id KubernetesCluster#vnet_subnet_id}.
     *
     * @stability stable
     */
    readonly vnetSubnetId?: string;
    /**
     * kubelet_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#kubelet_config KubernetesCluster#kubelet_config}
     *
     * @stability stable
     */
    readonly kubeletConfig?: KubernetesClusterDefaultNodePoolKubeletConfig[];
    /**
     * linux_os_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#linux_os_config KubernetesCluster#linux_os_config}
     *
     * @stability stable
     */
    readonly linuxOsConfig?: KubernetesClusterDefaultNodePoolLinuxOsConfig[];
    /**
     * upgrade_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#upgrade_settings KubernetesCluster#upgrade_settings}
     *
     * @stability stable
     */
    readonly upgradeSettings?: KubernetesClusterDefaultNodePoolUpgradeSettings[];
}
/**
 * @stability stable
 */
export interface KubernetesClusterIdentity {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#type KubernetesCluster#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#user_assigned_identity_id KubernetesCluster#user_assigned_identity_id}.
     *
     * @stability stable
     */
    readonly userAssignedIdentityId?: string;
}
/**
 * @stability stable
 */
export interface KubernetesClusterKubeletIdentity {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#client_id KubernetesCluster#client_id}.
     *
     * @stability stable
     */
    readonly clientId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#object_id KubernetesCluster#object_id}.
     *
     * @stability stable
     */
    readonly objectId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#user_assigned_identity_id KubernetesCluster#user_assigned_identity_id}.
     *
     * @stability stable
     */
    readonly userAssignedIdentityId?: string;
}
/**
 * @stability stable
 */
export interface KubernetesClusterLinuxProfileSshKey {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#key_data KubernetesCluster#key_data}.
     *
     * @stability stable
     */
    readonly keyData: string;
}
/**
 * @stability stable
 */
export interface KubernetesClusterLinuxProfile {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#admin_username KubernetesCluster#admin_username}.
     *
     * @stability stable
     */
    readonly adminUsername: string;
    /**
     * ssh_key block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#ssh_key KubernetesCluster#ssh_key}
     *
     * @stability stable
     */
    readonly sshKey: KubernetesClusterLinuxProfileSshKey[];
}
/**
 * @stability stable
 */
export interface KubernetesClusterNetworkProfileLoadBalancerProfile {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#idle_timeout_in_minutes KubernetesCluster#idle_timeout_in_minutes}.
     *
     * @stability stable
     */
    readonly idleTimeoutInMinutes?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#managed_outbound_ip_count KubernetesCluster#managed_outbound_ip_count}.
     *
     * @stability stable
     */
    readonly managedOutboundIpCount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#outbound_ip_address_ids KubernetesCluster#outbound_ip_address_ids}.
     *
     * @stability stable
     */
    readonly outboundIpAddressIds?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#outbound_ip_prefix_ids KubernetesCluster#outbound_ip_prefix_ids}.
     *
     * @stability stable
     */
    readonly outboundIpPrefixIds?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#outbound_ports_allocated KubernetesCluster#outbound_ports_allocated}.
     *
     * @stability stable
     */
    readonly outboundPortsAllocated?: number;
}
/**
 * @stability stable
 */
export interface KubernetesClusterNetworkProfile {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#dns_service_ip KubernetesCluster#dns_service_ip}.
     *
     * @stability stable
     */
    readonly dnsServiceIp?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#docker_bridge_cidr KubernetesCluster#docker_bridge_cidr}.
     *
     * @stability stable
     */
    readonly dockerBridgeCidr?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#load_balancer_sku KubernetesCluster#load_balancer_sku}.
     *
     * @stability stable
     */
    readonly loadBalancerSku?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#network_mode KubernetesCluster#network_mode}.
     *
     * @stability stable
     */
    readonly networkMode?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#network_plugin KubernetesCluster#network_plugin}.
     *
     * @stability stable
     */
    readonly networkPlugin: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#network_policy KubernetesCluster#network_policy}.
     *
     * @stability stable
     */
    readonly networkPolicy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#outbound_type KubernetesCluster#outbound_type}.
     *
     * @stability stable
     */
    readonly outboundType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#pod_cidr KubernetesCluster#pod_cidr}.
     *
     * @stability stable
     */
    readonly podCidr?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#service_cidr KubernetesCluster#service_cidr}.
     *
     * @stability stable
     */
    readonly serviceCidr?: string;
    /**
     * load_balancer_profile block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#load_balancer_profile KubernetesCluster#load_balancer_profile}
     *
     * @stability stable
     */
    readonly loadBalancerProfile?: KubernetesClusterNetworkProfileLoadBalancerProfile[];
}
/**
 * @stability stable
 */
export interface KubernetesClusterRoleBasedAccessControlAzureActiveDirectory {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#admin_group_object_ids KubernetesCluster#admin_group_object_ids}.
     *
     * @stability stable
     */
    readonly adminGroupObjectIds?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#azure_rbac_enabled KubernetesCluster#azure_rbac_enabled}.
     *
     * @stability stable
     */
    readonly azureRbacEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#client_app_id KubernetesCluster#client_app_id}.
     *
     * @stability stable
     */
    readonly clientAppId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#managed KubernetesCluster#managed}.
     *
     * @stability stable
     */
    readonly managed?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#server_app_id KubernetesCluster#server_app_id}.
     *
     * @stability stable
     */
    readonly serverAppId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#server_app_secret KubernetesCluster#server_app_secret}.
     *
     * @stability stable
     */
    readonly serverAppSecret?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#tenant_id KubernetesCluster#tenant_id}.
     *
     * @stability stable
     */
    readonly tenantId?: string;
}
/**
 * @stability stable
 */
export interface KubernetesClusterRoleBasedAccessControl {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#enabled KubernetesCluster#enabled}.
     *
     * @stability stable
     */
    readonly enabled: boolean;
    /**
     * azure_active_directory block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#azure_active_directory KubernetesCluster#azure_active_directory}
     *
     * @stability stable
     */
    readonly azureActiveDirectory?: KubernetesClusterRoleBasedAccessControlAzureActiveDirectory[];
}
/**
 * @stability stable
 */
export interface KubernetesClusterServicePrincipal {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#client_id KubernetesCluster#client_id}.
     *
     * @stability stable
     */
    readonly clientId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#client_secret KubernetesCluster#client_secret}.
     *
     * @stability stable
     */
    readonly clientSecret: string;
}
/**
 * @stability stable
 */
export interface KubernetesClusterTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#create KubernetesCluster#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#delete KubernetesCluster#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#read KubernetesCluster#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#update KubernetesCluster#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export interface KubernetesClusterWindowsProfile {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#admin_password KubernetesCluster#admin_password}.
     *
     * @stability stable
     */
    readonly adminPassword?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html#admin_username KubernetesCluster#admin_username}.
     *
     * @stability stable
     */
    readonly adminUsername: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html azurerm_kubernetes_cluster}.
 *
 * @stability stable
 */
export declare class KubernetesCluster extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/kubernetes_cluster.html azurerm_kubernetes_cluster} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: KubernetesClusterConfig);
    private _apiServerAuthorizedIpRanges?;
    /**
     * @stability stable
     */
    get apiServerAuthorizedIpRanges(): string[];
    /**
     * @stability stable
     */
    set apiServerAuthorizedIpRanges(value: string[]);
    /**
     * @stability stable
     */
    resetApiServerAuthorizedIpRanges(): void;
    /**
     * @stability stable
     */
    get apiServerAuthorizedIpRangesInput(): string[] | undefined;
    private _automaticChannelUpgrade?;
    /**
     * @stability stable
     */
    get automaticChannelUpgrade(): string;
    /**
     * @stability stable
     */
    set automaticChannelUpgrade(value: string);
    /**
     * @stability stable
     */
    resetAutomaticChannelUpgrade(): void;
    /**
     * @stability stable
     */
    get automaticChannelUpgradeInput(): string | undefined;
    private _diskEncryptionSetId?;
    /**
     * @stability stable
     */
    get diskEncryptionSetId(): string;
    /**
     * @stability stable
     */
    set diskEncryptionSetId(value: string);
    /**
     * @stability stable
     */
    resetDiskEncryptionSetId(): void;
    /**
     * @stability stable
     */
    get diskEncryptionSetIdInput(): string | undefined;
    private _dnsPrefix?;
    /**
     * @stability stable
     */
    get dnsPrefix(): string;
    /**
     * @stability stable
     */
    set dnsPrefix(value: string);
    /**
     * @stability stable
     */
    resetDnsPrefix(): void;
    /**
     * @stability stable
     */
    get dnsPrefixInput(): string | undefined;
    private _dnsPrefixPrivateCluster?;
    /**
     * @stability stable
     */
    get dnsPrefixPrivateCluster(): string;
    /**
     * @stability stable
     */
    set dnsPrefixPrivateCluster(value: string);
    /**
     * @stability stable
     */
    resetDnsPrefixPrivateCluster(): void;
    /**
     * @stability stable
     */
    get dnsPrefixPrivateClusterInput(): string | undefined;
    private _enablePodSecurityPolicy?;
    /**
     * @stability stable
     */
    get enablePodSecurityPolicy(): boolean;
    /**
     * @stability stable
     */
    set enablePodSecurityPolicy(value: boolean);
    /**
     * @stability stable
     */
    resetEnablePodSecurityPolicy(): void;
    /**
     * @stability stable
     */
    get enablePodSecurityPolicyInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get fqdn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    kubeAdminConfig(index: string): KubernetesClusterKubeAdminConfig;
    /**
     * @stability stable
     */
    get kubeAdminConfigRaw(): string;
    /**
     * @stability stable
     */
    kubeConfig(index: string): KubernetesClusterKubeConfig;
    /**
     * @stability stable
     */
    get kubeConfigRaw(): string;
    private _kubernetesVersion?;
    /**
     * @stability stable
     */
    get kubernetesVersion(): string;
    /**
     * @stability stable
     */
    set kubernetesVersion(value: string);
    /**
     * @stability stable
     */
    resetKubernetesVersion(): void;
    /**
     * @stability stable
     */
    get kubernetesVersionInput(): string | undefined;
    private _location;
    /**
     * @stability stable
     */
    get location(): string;
    /**
     * @stability stable
     */
    set location(value: string);
    /**
     * @stability stable
     */
    get locationInput(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _nodeResourceGroup?;
    /**
     * @stability stable
     */
    get nodeResourceGroup(): string;
    /**
     * @stability stable
     */
    set nodeResourceGroup(value: string);
    /**
     * @stability stable
     */
    resetNodeResourceGroup(): void;
    /**
     * @stability stable
     */
    get nodeResourceGroupInput(): string | undefined;
    private _privateClusterEnabled?;
    /**
     * @stability stable
     */
    get privateClusterEnabled(): boolean;
    /**
     * @stability stable
     */
    set privateClusterEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetPrivateClusterEnabled(): void;
    /**
     * @stability stable
     */
    get privateClusterEnabledInput(): boolean | undefined;
    private _privateDnsZoneId?;
    /**
     * @stability stable
     */
    get privateDnsZoneId(): string;
    /**
     * @stability stable
     */
    set privateDnsZoneId(value: string);
    /**
     * @stability stable
     */
    resetPrivateDnsZoneId(): void;
    /**
     * @stability stable
     */
    get privateDnsZoneIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get privateFqdn(): string;
    private _privateLinkEnabled?;
    /**
     * @stability stable
     */
    get privateLinkEnabled(): boolean;
    /**
     * @stability stable
     */
    set privateLinkEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetPrivateLinkEnabled(): void;
    /**
     * @stability stable
     */
    get privateLinkEnabledInput(): boolean | undefined;
    private _resourceGroupName;
    /**
     * @stability stable
     */
    get resourceGroupName(): string;
    /**
     * @stability stable
     */
    set resourceGroupName(value: string);
    /**
     * @stability stable
     */
    get resourceGroupNameInput(): string;
    private _skuTier?;
    /**
     * @stability stable
     */
    get skuTier(): string;
    /**
     * @stability stable
     */
    set skuTier(value: string);
    /**
     * @stability stable
     */
    resetSkuTier(): void;
    /**
     * @stability stable
     */
    get skuTierInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _addonProfile?;
    /**
     * @stability stable
     */
    get addonProfile(): KubernetesClusterAddonProfile[];
    /**
     * @stability stable
     */
    set addonProfile(value: KubernetesClusterAddonProfile[]);
    /**
     * @stability stable
     */
    resetAddonProfile(): void;
    /**
     * @stability stable
     */
    get addonProfileInput(): KubernetesClusterAddonProfile[] | undefined;
    private _autoScalerProfile?;
    /**
     * @stability stable
     */
    get autoScalerProfile(): KubernetesClusterAutoScalerProfile[];
    /**
     * @stability stable
     */
    set autoScalerProfile(value: KubernetesClusterAutoScalerProfile[]);
    /**
     * @stability stable
     */
    resetAutoScalerProfile(): void;
    /**
     * @stability stable
     */
    get autoScalerProfileInput(): KubernetesClusterAutoScalerProfile[] | undefined;
    private _defaultNodePool;
    /**
     * @stability stable
     */
    get defaultNodePool(): KubernetesClusterDefaultNodePool[];
    /**
     * @stability stable
     */
    set defaultNodePool(value: KubernetesClusterDefaultNodePool[]);
    /**
     * @stability stable
     */
    get defaultNodePoolInput(): KubernetesClusterDefaultNodePool[];
    private _identity?;
    /**
     * @stability stable
     */
    get identity(): KubernetesClusterIdentity[];
    /**
     * @stability stable
     */
    set identity(value: KubernetesClusterIdentity[]);
    /**
     * @stability stable
     */
    resetIdentity(): void;
    /**
     * @stability stable
     */
    get identityInput(): KubernetesClusterIdentity[] | undefined;
    private _kubeletIdentity?;
    /**
     * @stability stable
     */
    get kubeletIdentity(): KubernetesClusterKubeletIdentity[];
    /**
     * @stability stable
     */
    set kubeletIdentity(value: KubernetesClusterKubeletIdentity[]);
    /**
     * @stability stable
     */
    resetKubeletIdentity(): void;
    /**
     * @stability stable
     */
    get kubeletIdentityInput(): KubernetesClusterKubeletIdentity[] | undefined;
    private _linuxProfile?;
    /**
     * @stability stable
     */
    get linuxProfile(): KubernetesClusterLinuxProfile[];
    /**
     * @stability stable
     */
    set linuxProfile(value: KubernetesClusterLinuxProfile[]);
    /**
     * @stability stable
     */
    resetLinuxProfile(): void;
    /**
     * @stability stable
     */
    get linuxProfileInput(): KubernetesClusterLinuxProfile[] | undefined;
    private _networkProfile?;
    /**
     * @stability stable
     */
    get networkProfile(): KubernetesClusterNetworkProfile[];
    /**
     * @stability stable
     */
    set networkProfile(value: KubernetesClusterNetworkProfile[]);
    /**
     * @stability stable
     */
    resetNetworkProfile(): void;
    /**
     * @stability stable
     */
    get networkProfileInput(): KubernetesClusterNetworkProfile[] | undefined;
    private _roleBasedAccessControl?;
    /**
     * @stability stable
     */
    get roleBasedAccessControl(): KubernetesClusterRoleBasedAccessControl[];
    /**
     * @stability stable
     */
    set roleBasedAccessControl(value: KubernetesClusterRoleBasedAccessControl[]);
    /**
     * @stability stable
     */
    resetRoleBasedAccessControl(): void;
    /**
     * @stability stable
     */
    get roleBasedAccessControlInput(): KubernetesClusterRoleBasedAccessControl[] | undefined;
    private _servicePrincipal?;
    /**
     * @stability stable
     */
    get servicePrincipal(): KubernetesClusterServicePrincipal[];
    /**
     * @stability stable
     */
    set servicePrincipal(value: KubernetesClusterServicePrincipal[]);
    /**
     * @stability stable
     */
    resetServicePrincipal(): void;
    /**
     * @stability stable
     */
    get servicePrincipalInput(): KubernetesClusterServicePrincipal[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): KubernetesClusterTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: KubernetesClusterTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): KubernetesClusterTimeouts | undefined;
    private _windowsProfile?;
    /**
     * @stability stable
     */
    get windowsProfile(): KubernetesClusterWindowsProfile[];
    /**
     * @stability stable
     */
    set windowsProfile(value: KubernetesClusterWindowsProfile[]);
    /**
     * @stability stable
     */
    resetWindowsProfile(): void;
    /**
     * @stability stable
     */
    get windowsProfileInput(): KubernetesClusterWindowsProfile[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
