import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface MediaStreamingEndpointConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_endpoint.html#auto_start_enabled MediaStreamingEndpoint#auto_start_enabled}.
     *
     * @stability stable
     */
    readonly autoStartEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_endpoint.html#cdn_enabled MediaStreamingEndpoint#cdn_enabled}.
     *
     * @stability stable
     */
    readonly cdnEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_endpoint.html#cdn_profile MediaStreamingEndpoint#cdn_profile}.
     *
     * @stability stable
     */
    readonly cdnProfile?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_endpoint.html#cdn_provider MediaStreamingEndpoint#cdn_provider}.
     *
     * @stability stable
     */
    readonly cdnProvider?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_endpoint.html#custom_host_names MediaStreamingEndpoint#custom_host_names}.
     *
     * @stability stable
     */
    readonly customHostNames?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_endpoint.html#description MediaStreamingEndpoint#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_endpoint.html#location MediaStreamingEndpoint#location}.
     *
     * @stability stable
     */
    readonly location: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_endpoint.html#max_cache_age_seconds MediaStreamingEndpoint#max_cache_age_seconds}.
     *
     * @stability stable
     */
    readonly maxCacheAgeSeconds?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_endpoint.html#media_services_account_name MediaStreamingEndpoint#media_services_account_name}.
     *
     * @stability stable
     */
    readonly mediaServicesAccountName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_endpoint.html#name MediaStreamingEndpoint#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_endpoint.html#resource_group_name MediaStreamingEndpoint#resource_group_name}.
     *
     * @stability stable
     */
    readonly resourceGroupName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_endpoint.html#scale_units MediaStreamingEndpoint#scale_units}.
     *
     * @stability stable
     */
    readonly scaleUnits: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_endpoint.html#tags MediaStreamingEndpoint#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * access_control block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_endpoint.html#access_control MediaStreamingEndpoint#access_control}
     *
     * @stability stable
     */
    readonly accessControl?: MediaStreamingEndpointAccessControl[];
    /**
     * cross_site_access_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_endpoint.html#cross_site_access_policy MediaStreamingEndpoint#cross_site_access_policy}
     *
     * @stability stable
     */
    readonly crossSiteAccessPolicy?: MediaStreamingEndpointCrossSiteAccessPolicy[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_endpoint.html#timeouts MediaStreamingEndpoint#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: MediaStreamingEndpointTimeouts;
}
/**
 * @stability stable
 */
export interface MediaStreamingEndpointAccessControlAkamaiSignatureHeaderAuthenticationKey {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_endpoint.html#base64_key MediaStreamingEndpoint#base64_key}.
     *
     * @stability stable
     */
    readonly base64Key?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_endpoint.html#expiration MediaStreamingEndpoint#expiration}.
     *
     * @stability stable
     */
    readonly expiration?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_endpoint.html#identifier MediaStreamingEndpoint#identifier}.
     *
     * @stability stable
     */
    readonly identifier?: string;
}
/**
 * @stability stable
 */
export interface MediaStreamingEndpointAccessControlIpAllow {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_endpoint.html#address MediaStreamingEndpoint#address}.
     *
     * @stability stable
     */
    readonly address?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_endpoint.html#name MediaStreamingEndpoint#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_endpoint.html#subnet_prefix_length MediaStreamingEndpoint#subnet_prefix_length}.
     *
     * @stability stable
     */
    readonly subnetPrefixLength?: number;
}
/**
 * @stability stable
 */
export interface MediaStreamingEndpointAccessControl {
    /**
     * akamai_signature_header_authentication_key block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_endpoint.html#akamai_signature_header_authentication_key MediaStreamingEndpoint#akamai_signature_header_authentication_key}
     *
     * @stability stable
     */
    readonly akamaiSignatureHeaderAuthenticationKey?: MediaStreamingEndpointAccessControlAkamaiSignatureHeaderAuthenticationKey[];
    /**
     * ip_allow block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_endpoint.html#ip_allow MediaStreamingEndpoint#ip_allow}
     *
     * @stability stable
     */
    readonly ipAllow?: MediaStreamingEndpointAccessControlIpAllow[];
}
/**
 * @stability stable
 */
export interface MediaStreamingEndpointCrossSiteAccessPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_endpoint.html#client_access_policy MediaStreamingEndpoint#client_access_policy}.
     *
     * @stability stable
     */
    readonly clientAccessPolicy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_endpoint.html#cross_domain_policy MediaStreamingEndpoint#cross_domain_policy}.
     *
     * @stability stable
     */
    readonly crossDomainPolicy?: string;
}
/**
 * @stability stable
 */
export interface MediaStreamingEndpointTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_endpoint.html#create MediaStreamingEndpoint#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_endpoint.html#delete MediaStreamingEndpoint#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_endpoint.html#read MediaStreamingEndpoint#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_endpoint.html#update MediaStreamingEndpoint#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_endpoint.html azurerm_media_streaming_endpoint}.
 *
 * @stability stable
 */
export declare class MediaStreamingEndpoint extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_endpoint.html azurerm_media_streaming_endpoint} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: MediaStreamingEndpointConfig);
    private _autoStartEnabled?;
    /**
     * @stability stable
     */
    get autoStartEnabled(): boolean;
    /**
     * @stability stable
     */
    set autoStartEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetAutoStartEnabled(): void;
    /**
     * @stability stable
     */
    get autoStartEnabledInput(): boolean | undefined;
    private _cdnEnabled?;
    /**
     * @stability stable
     */
    get cdnEnabled(): boolean;
    /**
     * @stability stable
     */
    set cdnEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetCdnEnabled(): void;
    /**
     * @stability stable
     */
    get cdnEnabledInput(): boolean | undefined;
    private _cdnProfile?;
    /**
     * @stability stable
     */
    get cdnProfile(): string;
    /**
     * @stability stable
     */
    set cdnProfile(value: string);
    /**
     * @stability stable
     */
    resetCdnProfile(): void;
    /**
     * @stability stable
     */
    get cdnProfileInput(): string | undefined;
    private _cdnProvider?;
    /**
     * @stability stable
     */
    get cdnProvider(): string;
    /**
     * @stability stable
     */
    set cdnProvider(value: string);
    /**
     * @stability stable
     */
    resetCdnProvider(): void;
    /**
     * @stability stable
     */
    get cdnProviderInput(): string | undefined;
    private _customHostNames?;
    /**
     * @stability stable
     */
    get customHostNames(): string[];
    /**
     * @stability stable
     */
    set customHostNames(value: string[]);
    /**
     * @stability stable
     */
    resetCustomHostNames(): void;
    /**
     * @stability stable
     */
    get customHostNamesInput(): string[] | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get hostName(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _location;
    /**
     * @stability stable
     */
    get location(): string;
    /**
     * @stability stable
     */
    set location(value: string);
    /**
     * @stability stable
     */
    get locationInput(): string;
    private _maxCacheAgeSeconds?;
    /**
     * @stability stable
     */
    get maxCacheAgeSeconds(): number;
    /**
     * @stability stable
     */
    set maxCacheAgeSeconds(value: number);
    /**
     * @stability stable
     */
    resetMaxCacheAgeSeconds(): void;
    /**
     * @stability stable
     */
    get maxCacheAgeSecondsInput(): number | undefined;
    private _mediaServicesAccountName;
    /**
     * @stability stable
     */
    get mediaServicesAccountName(): string;
    /**
     * @stability stable
     */
    set mediaServicesAccountName(value: string);
    /**
     * @stability stable
     */
    get mediaServicesAccountNameInput(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _resourceGroupName;
    /**
     * @stability stable
     */
    get resourceGroupName(): string;
    /**
     * @stability stable
     */
    set resourceGroupName(value: string);
    /**
     * @stability stable
     */
    get resourceGroupNameInput(): string;
    private _scaleUnits;
    /**
     * @stability stable
     */
    get scaleUnits(): number;
    /**
     * @stability stable
     */
    set scaleUnits(value: number);
    /**
     * @stability stable
     */
    get scaleUnitsInput(): number;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _accessControl?;
    /**
     * @stability stable
     */
    get accessControl(): MediaStreamingEndpointAccessControl[];
    /**
     * @stability stable
     */
    set accessControl(value: MediaStreamingEndpointAccessControl[]);
    /**
     * @stability stable
     */
    resetAccessControl(): void;
    /**
     * @stability stable
     */
    get accessControlInput(): MediaStreamingEndpointAccessControl[] | undefined;
    private _crossSiteAccessPolicy?;
    /**
     * @stability stable
     */
    get crossSiteAccessPolicy(): MediaStreamingEndpointCrossSiteAccessPolicy[];
    /**
     * @stability stable
     */
    set crossSiteAccessPolicy(value: MediaStreamingEndpointCrossSiteAccessPolicy[]);
    /**
     * @stability stable
     */
    resetCrossSiteAccessPolicy(): void;
    /**
     * @stability stable
     */
    get crossSiteAccessPolicyInput(): MediaStreamingEndpointCrossSiteAccessPolicy[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): MediaStreamingEndpointTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: MediaStreamingEndpointTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): MediaStreamingEndpointTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
