import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface MediaStreamingPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_policy.html#default_content_key_policy_name MediaStreamingPolicy#default_content_key_policy_name}.
     *
     * @stability stable
     */
    readonly defaultContentKeyPolicyName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_policy.html#media_services_account_name MediaStreamingPolicy#media_services_account_name}.
     *
     * @stability stable
     */
    readonly mediaServicesAccountName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_policy.html#name MediaStreamingPolicy#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_policy.html#resource_group_name MediaStreamingPolicy#resource_group_name}.
     *
     * @stability stable
     */
    readonly resourceGroupName: string;
    /**
     * common_encryption_cbcs block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_policy.html#common_encryption_cbcs MediaStreamingPolicy#common_encryption_cbcs}
     *
     * @stability stable
     */
    readonly commonEncryptionCbcs?: MediaStreamingPolicyCommonEncryptionCbcs[];
    /**
     * common_encryption_cenc block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_policy.html#common_encryption_cenc MediaStreamingPolicy#common_encryption_cenc}
     *
     * @stability stable
     */
    readonly commonEncryptionCenc?: MediaStreamingPolicyCommonEncryptionCenc[];
    /**
     * no_encryption_enabled_protocols block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_policy.html#no_encryption_enabled_protocols MediaStreamingPolicy#no_encryption_enabled_protocols}
     *
     * @stability stable
     */
    readonly noEncryptionEnabledProtocols?: MediaStreamingPolicyNoEncryptionEnabledProtocols[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_policy.html#timeouts MediaStreamingPolicy#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: MediaStreamingPolicyTimeouts;
}
/**
 * @stability stable
 */
export interface MediaStreamingPolicyCommonEncryptionCbcsDefaultContentKey {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_policy.html#label MediaStreamingPolicy#label}.
     *
     * @stability stable
     */
    readonly label?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_policy.html#policy_name MediaStreamingPolicy#policy_name}.
     *
     * @stability stable
     */
    readonly policyName?: string;
}
/**
 * @stability stable
 */
export interface MediaStreamingPolicyCommonEncryptionCbcsDrmFairplay {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_policy.html#allow_persistent_license MediaStreamingPolicy#allow_persistent_license}.
     *
     * @stability stable
     */
    readonly allowPersistentLicense?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_policy.html#custom_license_acquisition_url_template MediaStreamingPolicy#custom_license_acquisition_url_template}.
     *
     * @stability stable
     */
    readonly customLicenseAcquisitionUrlTemplate?: string;
}
/**
 * @stability stable
 */
export interface MediaStreamingPolicyCommonEncryptionCbcsEnabledProtocols {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_policy.html#dash MediaStreamingPolicy#dash}.
     *
     * @stability stable
     */
    readonly dash?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_policy.html#download MediaStreamingPolicy#download}.
     *
     * @stability stable
     */
    readonly download?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_policy.html#hls MediaStreamingPolicy#hls}.
     *
     * @stability stable
     */
    readonly hls?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_policy.html#smooth_streaming MediaStreamingPolicy#smooth_streaming}.
     *
     * @stability stable
     */
    readonly smoothStreaming?: boolean;
}
/**
 * @stability stable
 */
export interface MediaStreamingPolicyCommonEncryptionCbcs {
    /**
     * default_content_key block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_policy.html#default_content_key MediaStreamingPolicy#default_content_key}
     *
     * @stability stable
     */
    readonly defaultContentKey?: MediaStreamingPolicyCommonEncryptionCbcsDefaultContentKey[];
    /**
     * drm_fairplay block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_policy.html#drm_fairplay MediaStreamingPolicy#drm_fairplay}
     *
     * @stability stable
     */
    readonly drmFairplay?: MediaStreamingPolicyCommonEncryptionCbcsDrmFairplay[];
    /**
     * enabled_protocols block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_policy.html#enabled_protocols MediaStreamingPolicy#enabled_protocols}
     *
     * @stability stable
     */
    readonly enabledProtocols?: MediaStreamingPolicyCommonEncryptionCbcsEnabledProtocols[];
}
/**
 * @stability stable
 */
export interface MediaStreamingPolicyCommonEncryptionCencDefaultContentKey {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_policy.html#label MediaStreamingPolicy#label}.
     *
     * @stability stable
     */
    readonly label?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_policy.html#policy_name MediaStreamingPolicy#policy_name}.
     *
     * @stability stable
     */
    readonly policyName?: string;
}
/**
 * @stability stable
 */
export interface MediaStreamingPolicyCommonEncryptionCencDrmPlayready {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_policy.html#custom_attributes MediaStreamingPolicy#custom_attributes}.
     *
     * @stability stable
     */
    readonly customAttributes?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_policy.html#custom_license_acquisition_url_template MediaStreamingPolicy#custom_license_acquisition_url_template}.
     *
     * @stability stable
     */
    readonly customLicenseAcquisitionUrlTemplate?: string;
}
/**
 * @stability stable
 */
export interface MediaStreamingPolicyCommonEncryptionCencEnabledProtocols {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_policy.html#dash MediaStreamingPolicy#dash}.
     *
     * @stability stable
     */
    readonly dash?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_policy.html#download MediaStreamingPolicy#download}.
     *
     * @stability stable
     */
    readonly download?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_policy.html#hls MediaStreamingPolicy#hls}.
     *
     * @stability stable
     */
    readonly hls?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_policy.html#smooth_streaming MediaStreamingPolicy#smooth_streaming}.
     *
     * @stability stable
     */
    readonly smoothStreaming?: boolean;
}
/**
 * @stability stable
 */
export interface MediaStreamingPolicyCommonEncryptionCenc {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_policy.html#drm_widevine_custom_license_acquisition_url_template MediaStreamingPolicy#drm_widevine_custom_license_acquisition_url_template}.
     *
     * @stability stable
     */
    readonly drmWidevineCustomLicenseAcquisitionUrlTemplate?: string;
    /**
     * default_content_key block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_policy.html#default_content_key MediaStreamingPolicy#default_content_key}
     *
     * @stability stable
     */
    readonly defaultContentKey?: MediaStreamingPolicyCommonEncryptionCencDefaultContentKey[];
    /**
     * drm_playready block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_policy.html#drm_playready MediaStreamingPolicy#drm_playready}
     *
     * @stability stable
     */
    readonly drmPlayready?: MediaStreamingPolicyCommonEncryptionCencDrmPlayready[];
    /**
     * enabled_protocols block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_policy.html#enabled_protocols MediaStreamingPolicy#enabled_protocols}
     *
     * @stability stable
     */
    readonly enabledProtocols?: MediaStreamingPolicyCommonEncryptionCencEnabledProtocols[];
}
/**
 * @stability stable
 */
export interface MediaStreamingPolicyNoEncryptionEnabledProtocols {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_policy.html#dash MediaStreamingPolicy#dash}.
     *
     * @stability stable
     */
    readonly dash?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_policy.html#download MediaStreamingPolicy#download}.
     *
     * @stability stable
     */
    readonly download?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_policy.html#hls MediaStreamingPolicy#hls}.
     *
     * @stability stable
     */
    readonly hls?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_policy.html#smooth_streaming MediaStreamingPolicy#smooth_streaming}.
     *
     * @stability stable
     */
    readonly smoothStreaming?: boolean;
}
/**
 * @stability stable
 */
export interface MediaStreamingPolicyTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_policy.html#create MediaStreamingPolicy#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_policy.html#delete MediaStreamingPolicy#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_policy.html#read MediaStreamingPolicy#read}.
     *
     * @stability stable
     */
    readonly read?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_policy.html azurerm_media_streaming_policy}.
 *
 * @stability stable
 */
export declare class MediaStreamingPolicy extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/media_streaming_policy.html azurerm_media_streaming_policy} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: MediaStreamingPolicyConfig);
    private _defaultContentKeyPolicyName?;
    /**
     * @stability stable
     */
    get defaultContentKeyPolicyName(): string;
    /**
     * @stability stable
     */
    set defaultContentKeyPolicyName(value: string);
    /**
     * @stability stable
     */
    resetDefaultContentKeyPolicyName(): void;
    /**
     * @stability stable
     */
    get defaultContentKeyPolicyNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _mediaServicesAccountName;
    /**
     * @stability stable
     */
    get mediaServicesAccountName(): string;
    /**
     * @stability stable
     */
    set mediaServicesAccountName(value: string);
    /**
     * @stability stable
     */
    get mediaServicesAccountNameInput(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _resourceGroupName;
    /**
     * @stability stable
     */
    get resourceGroupName(): string;
    /**
     * @stability stable
     */
    set resourceGroupName(value: string);
    /**
     * @stability stable
     */
    get resourceGroupNameInput(): string;
    private _commonEncryptionCbcs?;
    /**
     * @stability stable
     */
    get commonEncryptionCbcs(): MediaStreamingPolicyCommonEncryptionCbcs[];
    /**
     * @stability stable
     */
    set commonEncryptionCbcs(value: MediaStreamingPolicyCommonEncryptionCbcs[]);
    /**
     * @stability stable
     */
    resetCommonEncryptionCbcs(): void;
    /**
     * @stability stable
     */
    get commonEncryptionCbcsInput(): MediaStreamingPolicyCommonEncryptionCbcs[] | undefined;
    private _commonEncryptionCenc?;
    /**
     * @stability stable
     */
    get commonEncryptionCenc(): MediaStreamingPolicyCommonEncryptionCenc[];
    /**
     * @stability stable
     */
    set commonEncryptionCenc(value: MediaStreamingPolicyCommonEncryptionCenc[]);
    /**
     * @stability stable
     */
    resetCommonEncryptionCenc(): void;
    /**
     * @stability stable
     */
    get commonEncryptionCencInput(): MediaStreamingPolicyCommonEncryptionCenc[] | undefined;
    private _noEncryptionEnabledProtocols?;
    /**
     * @stability stable
     */
    get noEncryptionEnabledProtocols(): MediaStreamingPolicyNoEncryptionEnabledProtocols[];
    /**
     * @stability stable
     */
    set noEncryptionEnabledProtocols(value: MediaStreamingPolicyNoEncryptionEnabledProtocols[]);
    /**
     * @stability stable
     */
    resetNoEncryptionEnabledProtocols(): void;
    /**
     * @stability stable
     */
    get noEncryptionEnabledProtocolsInput(): MediaStreamingPolicyNoEncryptionEnabledProtocols[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): MediaStreamingPolicyTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: MediaStreamingPolicyTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): MediaStreamingPolicyTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
