import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface MssqlVirtualMachineConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#r_services_enabled MssqlVirtualMachine#r_services_enabled}.
     *
     * @stability stable
     */
    readonly rServicesEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#sql_connectivity_port MssqlVirtualMachine#sql_connectivity_port}.
     *
     * @stability stable
     */
    readonly sqlConnectivityPort?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#sql_connectivity_type MssqlVirtualMachine#sql_connectivity_type}.
     *
     * @stability stable
     */
    readonly sqlConnectivityType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#sql_connectivity_update_password MssqlVirtualMachine#sql_connectivity_update_password}.
     *
     * @stability stable
     */
    readonly sqlConnectivityUpdatePassword?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#sql_connectivity_update_username MssqlVirtualMachine#sql_connectivity_update_username}.
     *
     * @stability stable
     */
    readonly sqlConnectivityUpdateUsername?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#sql_license_type MssqlVirtualMachine#sql_license_type}.
     *
     * @stability stable
     */
    readonly sqlLicenseType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#tags MssqlVirtualMachine#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#virtual_machine_id MssqlVirtualMachine#virtual_machine_id}.
     *
     * @stability stable
     */
    readonly virtualMachineId: string;
    /**
     * auto_backup block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#auto_backup MssqlVirtualMachine#auto_backup}
     *
     * @stability stable
     */
    readonly autoBackup?: MssqlVirtualMachineAutoBackup[];
    /**
     * auto_patching block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#auto_patching MssqlVirtualMachine#auto_patching}
     *
     * @stability stable
     */
    readonly autoPatching?: MssqlVirtualMachineAutoPatching[];
    /**
     * key_vault_credential block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#key_vault_credential MssqlVirtualMachine#key_vault_credential}
     *
     * @stability stable
     */
    readonly keyVaultCredential?: MssqlVirtualMachineKeyVaultCredential[];
    /**
     * storage_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#storage_configuration MssqlVirtualMachine#storage_configuration}
     *
     * @stability stable
     */
    readonly storageConfiguration?: MssqlVirtualMachineStorageConfiguration[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#timeouts MssqlVirtualMachine#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: MssqlVirtualMachineTimeouts;
}
/**
 * @stability stable
 */
export interface MssqlVirtualMachineAutoBackupManualSchedule {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#full_backup_frequency MssqlVirtualMachine#full_backup_frequency}.
     *
     * @stability stable
     */
    readonly fullBackupFrequency: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#full_backup_start_hour MssqlVirtualMachine#full_backup_start_hour}.
     *
     * @stability stable
     */
    readonly fullBackupStartHour: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#full_backup_window_in_hours MssqlVirtualMachine#full_backup_window_in_hours}.
     *
     * @stability stable
     */
    readonly fullBackupWindowInHours: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#log_backup_frequency_in_minutes MssqlVirtualMachine#log_backup_frequency_in_minutes}.
     *
     * @stability stable
     */
    readonly logBackupFrequencyInMinutes: number;
}
/**
 * @stability stable
 */
export interface MssqlVirtualMachineAutoBackup {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#encryption_enabled MssqlVirtualMachine#encryption_enabled}.
     *
     * @stability stable
     */
    readonly encryptionEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#encryption_password MssqlVirtualMachine#encryption_password}.
     *
     * @stability stable
     */
    readonly encryptionPassword?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#retention_period_in_days MssqlVirtualMachine#retention_period_in_days}.
     *
     * @stability stable
     */
    readonly retentionPeriodInDays: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#storage_account_access_key MssqlVirtualMachine#storage_account_access_key}.
     *
     * @stability stable
     */
    readonly storageAccountAccessKey: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#storage_blob_endpoint MssqlVirtualMachine#storage_blob_endpoint}.
     *
     * @stability stable
     */
    readonly storageBlobEndpoint: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#system_databases_backup_enabled MssqlVirtualMachine#system_databases_backup_enabled}.
     *
     * @stability stable
     */
    readonly systemDatabasesBackupEnabled?: boolean;
    /**
     * manual_schedule block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#manual_schedule MssqlVirtualMachine#manual_schedule}
     *
     * @stability stable
     */
    readonly manualSchedule?: MssqlVirtualMachineAutoBackupManualSchedule[];
}
/**
 * @stability stable
 */
export interface MssqlVirtualMachineAutoPatching {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#day_of_week MssqlVirtualMachine#day_of_week}.
     *
     * @stability stable
     */
    readonly dayOfWeek: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#maintenance_window_duration_in_minutes MssqlVirtualMachine#maintenance_window_duration_in_minutes}.
     *
     * @stability stable
     */
    readonly maintenanceWindowDurationInMinutes: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#maintenance_window_starting_hour MssqlVirtualMachine#maintenance_window_starting_hour}.
     *
     * @stability stable
     */
    readonly maintenanceWindowStartingHour: number;
}
/**
 * @stability stable
 */
export interface MssqlVirtualMachineKeyVaultCredential {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#key_vault_url MssqlVirtualMachine#key_vault_url}.
     *
     * @stability stable
     */
    readonly keyVaultUrl: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#name MssqlVirtualMachine#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#service_principal_name MssqlVirtualMachine#service_principal_name}.
     *
     * @stability stable
     */
    readonly servicePrincipalName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#service_principal_secret MssqlVirtualMachine#service_principal_secret}.
     *
     * @stability stable
     */
    readonly servicePrincipalSecret: string;
}
/**
 * @stability stable
 */
export interface MssqlVirtualMachineStorageConfigurationDataSettings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#default_file_path MssqlVirtualMachine#default_file_path}.
     *
     * @stability stable
     */
    readonly defaultFilePath: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#luns MssqlVirtualMachine#luns}.
     *
     * @stability stable
     */
    readonly luns: number[];
}
/**
 * @stability stable
 */
export interface MssqlVirtualMachineStorageConfigurationLogSettings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#default_file_path MssqlVirtualMachine#default_file_path}.
     *
     * @stability stable
     */
    readonly defaultFilePath: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#luns MssqlVirtualMachine#luns}.
     *
     * @stability stable
     */
    readonly luns: number[];
}
/**
 * @stability stable
 */
export interface MssqlVirtualMachineStorageConfigurationTempDbSettings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#default_file_path MssqlVirtualMachine#default_file_path}.
     *
     * @stability stable
     */
    readonly defaultFilePath: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#luns MssqlVirtualMachine#luns}.
     *
     * @stability stable
     */
    readonly luns: number[];
}
/**
 * @stability stable
 */
export interface MssqlVirtualMachineStorageConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#disk_type MssqlVirtualMachine#disk_type}.
     *
     * @stability stable
     */
    readonly diskType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#storage_workload_type MssqlVirtualMachine#storage_workload_type}.
     *
     * @stability stable
     */
    readonly storageWorkloadType: string;
    /**
     * data_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#data_settings MssqlVirtualMachine#data_settings}
     *
     * @stability stable
     */
    readonly dataSettings?: MssqlVirtualMachineStorageConfigurationDataSettings[];
    /**
     * log_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#log_settings MssqlVirtualMachine#log_settings}
     *
     * @stability stable
     */
    readonly logSettings?: MssqlVirtualMachineStorageConfigurationLogSettings[];
    /**
     * temp_db_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#temp_db_settings MssqlVirtualMachine#temp_db_settings}
     *
     * @stability stable
     */
    readonly tempDbSettings?: MssqlVirtualMachineStorageConfigurationTempDbSettings[];
}
/**
 * @stability stable
 */
export interface MssqlVirtualMachineTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#create MssqlVirtualMachine#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#delete MssqlVirtualMachine#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#read MssqlVirtualMachine#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html#update MssqlVirtualMachine#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html azurerm_mssql_virtual_machine}.
 *
 * @stability stable
 */
export declare class MssqlVirtualMachine extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_virtual_machine.html azurerm_mssql_virtual_machine} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: MssqlVirtualMachineConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _rServicesEnabled?;
    /**
     * @stability stable
     */
    get rServicesEnabled(): boolean;
    /**
     * @stability stable
     */
    set rServicesEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetRServicesEnabled(): void;
    /**
     * @stability stable
     */
    get rServicesEnabledInput(): boolean | undefined;
    private _sqlConnectivityPort?;
    /**
     * @stability stable
     */
    get sqlConnectivityPort(): number;
    /**
     * @stability stable
     */
    set sqlConnectivityPort(value: number);
    /**
     * @stability stable
     */
    resetSqlConnectivityPort(): void;
    /**
     * @stability stable
     */
    get sqlConnectivityPortInput(): number | undefined;
    private _sqlConnectivityType?;
    /**
     * @stability stable
     */
    get sqlConnectivityType(): string;
    /**
     * @stability stable
     */
    set sqlConnectivityType(value: string);
    /**
     * @stability stable
     */
    resetSqlConnectivityType(): void;
    /**
     * @stability stable
     */
    get sqlConnectivityTypeInput(): string | undefined;
    private _sqlConnectivityUpdatePassword?;
    /**
     * @stability stable
     */
    get sqlConnectivityUpdatePassword(): string;
    /**
     * @stability stable
     */
    set sqlConnectivityUpdatePassword(value: string);
    /**
     * @stability stable
     */
    resetSqlConnectivityUpdatePassword(): void;
    /**
     * @stability stable
     */
    get sqlConnectivityUpdatePasswordInput(): string | undefined;
    private _sqlConnectivityUpdateUsername?;
    /**
     * @stability stable
     */
    get sqlConnectivityUpdateUsername(): string;
    /**
     * @stability stable
     */
    set sqlConnectivityUpdateUsername(value: string);
    /**
     * @stability stable
     */
    resetSqlConnectivityUpdateUsername(): void;
    /**
     * @stability stable
     */
    get sqlConnectivityUpdateUsernameInput(): string | undefined;
    private _sqlLicenseType;
    /**
     * @stability stable
     */
    get sqlLicenseType(): string;
    /**
     * @stability stable
     */
    set sqlLicenseType(value: string);
    /**
     * @stability stable
     */
    get sqlLicenseTypeInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _virtualMachineId;
    /**
     * @stability stable
     */
    get virtualMachineId(): string;
    /**
     * @stability stable
     */
    set virtualMachineId(value: string);
    /**
     * @stability stable
     */
    get virtualMachineIdInput(): string;
    private _autoBackup?;
    /**
     * @stability stable
     */
    get autoBackup(): MssqlVirtualMachineAutoBackup[];
    /**
     * @stability stable
     */
    set autoBackup(value: MssqlVirtualMachineAutoBackup[]);
    /**
     * @stability stable
     */
    resetAutoBackup(): void;
    /**
     * @stability stable
     */
    get autoBackupInput(): MssqlVirtualMachineAutoBackup[] | undefined;
    private _autoPatching?;
    /**
     * @stability stable
     */
    get autoPatching(): MssqlVirtualMachineAutoPatching[];
    /**
     * @stability stable
     */
    set autoPatching(value: MssqlVirtualMachineAutoPatching[]);
    /**
     * @stability stable
     */
    resetAutoPatching(): void;
    /**
     * @stability stable
     */
    get autoPatchingInput(): MssqlVirtualMachineAutoPatching[] | undefined;
    private _keyVaultCredential?;
    /**
     * @stability stable
     */
    get keyVaultCredential(): MssqlVirtualMachineKeyVaultCredential[];
    /**
     * @stability stable
     */
    set keyVaultCredential(value: MssqlVirtualMachineKeyVaultCredential[]);
    /**
     * @stability stable
     */
    resetKeyVaultCredential(): void;
    /**
     * @stability stable
     */
    get keyVaultCredentialInput(): MssqlVirtualMachineKeyVaultCredential[] | undefined;
    private _storageConfiguration?;
    /**
     * @stability stable
     */
    get storageConfiguration(): MssqlVirtualMachineStorageConfiguration[];
    /**
     * @stability stable
     */
    set storageConfiguration(value: MssqlVirtualMachineStorageConfiguration[]);
    /**
     * @stability stable
     */
    resetStorageConfiguration(): void;
    /**
     * @stability stable
     */
    get storageConfigurationInput(): MssqlVirtualMachineStorageConfiguration[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): MssqlVirtualMachineTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: MssqlVirtualMachineTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): MssqlVirtualMachineTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
