import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface NetworkConnectionMonitorConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#auto_start NetworkConnectionMonitor#auto_start}.
     *
     * @stability stable
     */
    readonly autoStart?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#interval_in_seconds NetworkConnectionMonitor#interval_in_seconds}.
     *
     * @stability stable
     */
    readonly intervalInSeconds?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#location NetworkConnectionMonitor#location}.
     *
     * @stability stable
     */
    readonly location: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#name NetworkConnectionMonitor#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#network_watcher_id NetworkConnectionMonitor#network_watcher_id}.
     *
     * @stability stable
     */
    readonly networkWatcherId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#notes NetworkConnectionMonitor#notes}.
     *
     * @stability stable
     */
    readonly notes?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#output_workspace_resource_ids NetworkConnectionMonitor#output_workspace_resource_ids}.
     *
     * @stability stable
     */
    readonly outputWorkspaceResourceIds?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#tags NetworkConnectionMonitor#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * destination block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#destination NetworkConnectionMonitor#destination}
     *
     * @stability stable
     */
    readonly destination?: NetworkConnectionMonitorDestination[];
    /**
     * endpoint block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#endpoint NetworkConnectionMonitor#endpoint}
     *
     * @stability stable
     */
    readonly endpoint: NetworkConnectionMonitorEndpoint[];
    /**
     * source block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#source NetworkConnectionMonitor#source}
     *
     * @stability stable
     */
    readonly source?: NetworkConnectionMonitorSource[];
    /**
     * test_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#test_configuration NetworkConnectionMonitor#test_configuration}
     *
     * @stability stable
     */
    readonly testConfiguration: NetworkConnectionMonitorTestConfiguration[];
    /**
     * test_group block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#test_group NetworkConnectionMonitor#test_group}
     *
     * @stability stable
     */
    readonly testGroup: NetworkConnectionMonitorTestGroup[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#timeouts NetworkConnectionMonitor#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: NetworkConnectionMonitorTimeouts;
}
/**
 * @stability stable
 */
export interface NetworkConnectionMonitorDestination {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#address NetworkConnectionMonitor#address}.
     *
     * @stability stable
     */
    readonly address?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#port NetworkConnectionMonitor#port}.
     *
     * @stability stable
     */
    readonly port?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#virtual_machine_id NetworkConnectionMonitor#virtual_machine_id}.
     *
     * @stability stable
     */
    readonly virtualMachineId?: string;
}
/**
 * @stability stable
 */
export interface NetworkConnectionMonitorEndpointFilterItem {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#address NetworkConnectionMonitor#address}.
     *
     * @stability stable
     */
    readonly address?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#type NetworkConnectionMonitor#type}.
     *
     * @stability stable
     */
    readonly type?: string;
}
/**
 * @stability stable
 */
export interface NetworkConnectionMonitorEndpointFilter {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#type NetworkConnectionMonitor#type}.
     *
     * @stability stable
     */
    readonly type?: string;
    /**
     * item block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#item NetworkConnectionMonitor#item}
     *
     * @stability stable
     */
    readonly item?: NetworkConnectionMonitorEndpointFilterItem[];
}
/**
 * @stability stable
 */
export interface NetworkConnectionMonitorEndpoint {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#address NetworkConnectionMonitor#address}.
     *
     * @stability stable
     */
    readonly address?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#coverage_level NetworkConnectionMonitor#coverage_level}.
     *
     * @stability stable
     */
    readonly coverageLevel?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#excluded_ip_addresses NetworkConnectionMonitor#excluded_ip_addresses}.
     *
     * @stability stable
     */
    readonly excludedIpAddresses?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#included_ip_addresses NetworkConnectionMonitor#included_ip_addresses}.
     *
     * @stability stable
     */
    readonly includedIpAddresses?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#name NetworkConnectionMonitor#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#target_resource_id NetworkConnectionMonitor#target_resource_id}.
     *
     * @stability stable
     */
    readonly targetResourceId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#target_resource_type NetworkConnectionMonitor#target_resource_type}.
     *
     * @stability stable
     */
    readonly targetResourceType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#virtual_machine_id NetworkConnectionMonitor#virtual_machine_id}.
     *
     * @stability stable
     */
    readonly virtualMachineId?: string;
    /**
     * filter block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#filter NetworkConnectionMonitor#filter}
     *
     * @stability stable
     */
    readonly filter?: NetworkConnectionMonitorEndpointFilter[];
}
/**
 * @stability stable
 */
export interface NetworkConnectionMonitorSource {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#port NetworkConnectionMonitor#port}.
     *
     * @stability stable
     */
    readonly port?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#virtual_machine_id NetworkConnectionMonitor#virtual_machine_id}.
     *
     * @stability stable
     */
    readonly virtualMachineId?: string;
}
/**
 * @stability stable
 */
export interface NetworkConnectionMonitorTestConfigurationHttpConfigurationRequestHeader {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#name NetworkConnectionMonitor#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#value NetworkConnectionMonitor#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
/**
 * @stability stable
 */
export interface NetworkConnectionMonitorTestConfigurationHttpConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#method NetworkConnectionMonitor#method}.
     *
     * @stability stable
     */
    readonly method?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#path NetworkConnectionMonitor#path}.
     *
     * @stability stable
     */
    readonly path?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#port NetworkConnectionMonitor#port}.
     *
     * @stability stable
     */
    readonly port?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#prefer_https NetworkConnectionMonitor#prefer_https}.
     *
     * @stability stable
     */
    readonly preferHttps?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#valid_status_code_ranges NetworkConnectionMonitor#valid_status_code_ranges}.
     *
     * @stability stable
     */
    readonly validStatusCodeRanges?: string[];
    /**
     * request_header block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#request_header NetworkConnectionMonitor#request_header}
     *
     * @stability stable
     */
    readonly requestHeader?: NetworkConnectionMonitorTestConfigurationHttpConfigurationRequestHeader[];
}
/**
 * @stability stable
 */
export interface NetworkConnectionMonitorTestConfigurationIcmpConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#trace_route_enabled NetworkConnectionMonitor#trace_route_enabled}.
     *
     * @stability stable
     */
    readonly traceRouteEnabled?: boolean;
}
/**
 * @stability stable
 */
export interface NetworkConnectionMonitorTestConfigurationSuccessThreshold {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#checks_failed_percent NetworkConnectionMonitor#checks_failed_percent}.
     *
     * @stability stable
     */
    readonly checksFailedPercent?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#round_trip_time_ms NetworkConnectionMonitor#round_trip_time_ms}.
     *
     * @stability stable
     */
    readonly roundTripTimeMs?: number;
}
/**
 * @stability stable
 */
export interface NetworkConnectionMonitorTestConfigurationTcpConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#port NetworkConnectionMonitor#port}.
     *
     * @stability stable
     */
    readonly port: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#trace_route_enabled NetworkConnectionMonitor#trace_route_enabled}.
     *
     * @stability stable
     */
    readonly traceRouteEnabled?: boolean;
}
/**
 * @stability stable
 */
export interface NetworkConnectionMonitorTestConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#name NetworkConnectionMonitor#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#preferred_ip_version NetworkConnectionMonitor#preferred_ip_version}.
     *
     * @stability stable
     */
    readonly preferredIpVersion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#protocol NetworkConnectionMonitor#protocol}.
     *
     * @stability stable
     */
    readonly protocol: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#test_frequency_in_seconds NetworkConnectionMonitor#test_frequency_in_seconds}.
     *
     * @stability stable
     */
    readonly testFrequencyInSeconds?: number;
    /**
     * http_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#http_configuration NetworkConnectionMonitor#http_configuration}
     *
     * @stability stable
     */
    readonly httpConfiguration?: NetworkConnectionMonitorTestConfigurationHttpConfiguration[];
    /**
     * icmp_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#icmp_configuration NetworkConnectionMonitor#icmp_configuration}
     *
     * @stability stable
     */
    readonly icmpConfiguration?: NetworkConnectionMonitorTestConfigurationIcmpConfiguration[];
    /**
     * success_threshold block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#success_threshold NetworkConnectionMonitor#success_threshold}
     *
     * @stability stable
     */
    readonly successThreshold?: NetworkConnectionMonitorTestConfigurationSuccessThreshold[];
    /**
     * tcp_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#tcp_configuration NetworkConnectionMonitor#tcp_configuration}
     *
     * @stability stable
     */
    readonly tcpConfiguration?: NetworkConnectionMonitorTestConfigurationTcpConfiguration[];
}
/**
 * @stability stable
 */
export interface NetworkConnectionMonitorTestGroup {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#destination_endpoints NetworkConnectionMonitor#destination_endpoints}.
     *
     * @stability stable
     */
    readonly destinationEndpoints: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#enabled NetworkConnectionMonitor#enabled}.
     *
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#name NetworkConnectionMonitor#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#source_endpoints NetworkConnectionMonitor#source_endpoints}.
     *
     * @stability stable
     */
    readonly sourceEndpoints: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#test_configuration_names NetworkConnectionMonitor#test_configuration_names}.
     *
     * @stability stable
     */
    readonly testConfigurationNames: string[];
}
/**
 * @stability stable
 */
export interface NetworkConnectionMonitorTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#create NetworkConnectionMonitor#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#delete NetworkConnectionMonitor#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#read NetworkConnectionMonitor#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html#update NetworkConnectionMonitor#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html azurerm_network_connection_monitor}.
 *
 * @stability stable
 */
export declare class NetworkConnectionMonitor extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/network_connection_monitor.html azurerm_network_connection_monitor} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: NetworkConnectionMonitorConfig);
    private _autoStart?;
    /**
     * @stability stable
     */
    get autoStart(): boolean;
    /**
     * @stability stable
     */
    set autoStart(value: boolean);
    /**
     * @stability stable
     */
    resetAutoStart(): void;
    /**
     * @stability stable
     */
    get autoStartInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _intervalInSeconds?;
    /**
     * @stability stable
     */
    get intervalInSeconds(): number;
    /**
     * @stability stable
     */
    set intervalInSeconds(value: number);
    /**
     * @stability stable
     */
    resetIntervalInSeconds(): void;
    /**
     * @stability stable
     */
    get intervalInSecondsInput(): number | undefined;
    private _location;
    /**
     * @stability stable
     */
    get location(): string;
    /**
     * @stability stable
     */
    set location(value: string);
    /**
     * @stability stable
     */
    get locationInput(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _networkWatcherId;
    /**
     * @stability stable
     */
    get networkWatcherId(): string;
    /**
     * @stability stable
     */
    set networkWatcherId(value: string);
    /**
     * @stability stable
     */
    get networkWatcherIdInput(): string;
    private _notes?;
    /**
     * @stability stable
     */
    get notes(): string;
    /**
     * @stability stable
     */
    set notes(value: string);
    /**
     * @stability stable
     */
    resetNotes(): void;
    /**
     * @stability stable
     */
    get notesInput(): string | undefined;
    private _outputWorkspaceResourceIds?;
    /**
     * @stability stable
     */
    get outputWorkspaceResourceIds(): string[];
    /**
     * @stability stable
     */
    set outputWorkspaceResourceIds(value: string[]);
    /**
     * @stability stable
     */
    resetOutputWorkspaceResourceIds(): void;
    /**
     * @stability stable
     */
    get outputWorkspaceResourceIdsInput(): string[] | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _destination?;
    /**
     * @stability stable
     */
    get destination(): NetworkConnectionMonitorDestination[];
    /**
     * @stability stable
     */
    set destination(value: NetworkConnectionMonitorDestination[]);
    /**
     * @stability stable
     */
    resetDestination(): void;
    /**
     * @stability stable
     */
    get destinationInput(): NetworkConnectionMonitorDestination[] | undefined;
    private _endpoint;
    /**
     * @stability stable
     */
    get endpoint(): NetworkConnectionMonitorEndpoint[];
    /**
     * @stability stable
     */
    set endpoint(value: NetworkConnectionMonitorEndpoint[]);
    /**
     * @stability stable
     */
    get endpointInput(): NetworkConnectionMonitorEndpoint[];
    private _source?;
    /**
     * @stability stable
     */
    get source(): NetworkConnectionMonitorSource[];
    /**
     * @stability stable
     */
    set source(value: NetworkConnectionMonitorSource[]);
    /**
     * @stability stable
     */
    resetSource(): void;
    /**
     * @stability stable
     */
    get sourceInput(): NetworkConnectionMonitorSource[] | undefined;
    private _testConfiguration;
    /**
     * @stability stable
     */
    get testConfiguration(): NetworkConnectionMonitorTestConfiguration[];
    /**
     * @stability stable
     */
    set testConfiguration(value: NetworkConnectionMonitorTestConfiguration[]);
    /**
     * @stability stable
     */
    get testConfigurationInput(): NetworkConnectionMonitorTestConfiguration[];
    private _testGroup;
    /**
     * @stability stable
     */
    get testGroup(): NetworkConnectionMonitorTestGroup[];
    /**
     * @stability stable
     */
    set testGroup(value: NetworkConnectionMonitorTestGroup[]);
    /**
     * @stability stable
     */
    get testGroupInput(): NetworkConnectionMonitorTestGroup[];
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): NetworkConnectionMonitorTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: NetworkConnectionMonitorTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): NetworkConnectionMonitorTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
