import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface PolicyRemediationConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/policy_remediation.html#location_filters PolicyRemediation#location_filters}.
     *
     * @stability stable
     */
    readonly locationFilters?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/policy_remediation.html#name PolicyRemediation#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/policy_remediation.html#policy_assignment_id PolicyRemediation#policy_assignment_id}.
     *
     * @stability stable
     */
    readonly policyAssignmentId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/policy_remediation.html#policy_definition_reference_id PolicyRemediation#policy_definition_reference_id}.
     *
     * @stability stable
     */
    readonly policyDefinitionReferenceId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/policy_remediation.html#resource_discovery_mode PolicyRemediation#resource_discovery_mode}.
     *
     * @stability stable
     */
    readonly resourceDiscoveryMode?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/policy_remediation.html#scope PolicyRemediation#scope}.
     *
     * @stability stable
     */
    readonly scope: string;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/policy_remediation.html#timeouts PolicyRemediation#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: PolicyRemediationTimeouts;
}
/**
 * @stability stable
 */
export interface PolicyRemediationTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/policy_remediation.html#create PolicyRemediation#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/policy_remediation.html#delete PolicyRemediation#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/policy_remediation.html#read PolicyRemediation#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/policy_remediation.html#update PolicyRemediation#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/policy_remediation.html azurerm_policy_remediation}.
 *
 * @stability stable
 */
export declare class PolicyRemediation extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/policy_remediation.html azurerm_policy_remediation} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: PolicyRemediationConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _locationFilters?;
    /**
     * @stability stable
     */
    get locationFilters(): string[];
    /**
     * @stability stable
     */
    set locationFilters(value: string[]);
    /**
     * @stability stable
     */
    resetLocationFilters(): void;
    /**
     * @stability stable
     */
    get locationFiltersInput(): string[] | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _policyAssignmentId;
    /**
     * @stability stable
     */
    get policyAssignmentId(): string;
    /**
     * @stability stable
     */
    set policyAssignmentId(value: string);
    /**
     * @stability stable
     */
    get policyAssignmentIdInput(): string;
    private _policyDefinitionReferenceId?;
    /**
     * @stability stable
     */
    get policyDefinitionReferenceId(): string;
    /**
     * @stability stable
     */
    set policyDefinitionReferenceId(value: string);
    /**
     * @stability stable
     */
    resetPolicyDefinitionReferenceId(): void;
    /**
     * @stability stable
     */
    get policyDefinitionReferenceIdInput(): string | undefined;
    private _resourceDiscoveryMode?;
    /**
     * @stability stable
     */
    get resourceDiscoveryMode(): string;
    /**
     * @stability stable
     */
    set resourceDiscoveryMode(value: string);
    /**
     * @stability stable
     */
    resetResourceDiscoveryMode(): void;
    /**
     * @stability stable
     */
    get resourceDiscoveryModeInput(): string | undefined;
    private _scope;
    /**
     * @stability stable
     */
    get scope(): string;
    /**
     * @stability stable
     */
    set scope(value: string);
    /**
     * @stability stable
     */
    get scopeInput(): string;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): PolicyRemediationTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: PolicyRemediationTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): PolicyRemediationTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
