import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SentinelAlertRuleScheduledConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/sentinel_alert_rule_scheduled.html#alert_rule_template_guid SentinelAlertRuleScheduled#alert_rule_template_guid}.
     *
     * @stability stable
     */
    readonly alertRuleTemplateGuid?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/sentinel_alert_rule_scheduled.html#description SentinelAlertRuleScheduled#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/sentinel_alert_rule_scheduled.html#display_name SentinelAlertRuleScheduled#display_name}.
     *
     * @stability stable
     */
    readonly displayName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/sentinel_alert_rule_scheduled.html#enabled SentinelAlertRuleScheduled#enabled}.
     *
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/sentinel_alert_rule_scheduled.html#log_analytics_workspace_id SentinelAlertRuleScheduled#log_analytics_workspace_id}.
     *
     * @stability stable
     */
    readonly logAnalyticsWorkspaceId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/sentinel_alert_rule_scheduled.html#name SentinelAlertRuleScheduled#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/sentinel_alert_rule_scheduled.html#query SentinelAlertRuleScheduled#query}.
     *
     * @stability stable
     */
    readonly query: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/sentinel_alert_rule_scheduled.html#query_frequency SentinelAlertRuleScheduled#query_frequency}.
     *
     * @stability stable
     */
    readonly queryFrequency?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/sentinel_alert_rule_scheduled.html#query_period SentinelAlertRuleScheduled#query_period}.
     *
     * @stability stable
     */
    readonly queryPeriod?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/sentinel_alert_rule_scheduled.html#severity SentinelAlertRuleScheduled#severity}.
     *
     * @stability stable
     */
    readonly severity: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/sentinel_alert_rule_scheduled.html#suppression_duration SentinelAlertRuleScheduled#suppression_duration}.
     *
     * @stability stable
     */
    readonly suppressionDuration?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/sentinel_alert_rule_scheduled.html#suppression_enabled SentinelAlertRuleScheduled#suppression_enabled}.
     *
     * @stability stable
     */
    readonly suppressionEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/sentinel_alert_rule_scheduled.html#tactics SentinelAlertRuleScheduled#tactics}.
     *
     * @stability stable
     */
    readonly tactics?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/sentinel_alert_rule_scheduled.html#trigger_operator SentinelAlertRuleScheduled#trigger_operator}.
     *
     * @stability stable
     */
    readonly triggerOperator?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/sentinel_alert_rule_scheduled.html#trigger_threshold SentinelAlertRuleScheduled#trigger_threshold}.
     *
     * @stability stable
     */
    readonly triggerThreshold?: number;
    /**
     * event_grouping block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/sentinel_alert_rule_scheduled.html#event_grouping SentinelAlertRuleScheduled#event_grouping}
     *
     * @stability stable
     */
    readonly eventGrouping?: SentinelAlertRuleScheduledEventGrouping[];
    /**
     * incident_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/sentinel_alert_rule_scheduled.html#incident_configuration SentinelAlertRuleScheduled#incident_configuration}
     *
     * @stability stable
     */
    readonly incidentConfiguration?: SentinelAlertRuleScheduledIncidentConfiguration[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/sentinel_alert_rule_scheduled.html#timeouts SentinelAlertRuleScheduled#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: SentinelAlertRuleScheduledTimeouts;
}
/**
 * @stability stable
 */
export interface SentinelAlertRuleScheduledEventGrouping {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/sentinel_alert_rule_scheduled.html#aggregation_method SentinelAlertRuleScheduled#aggregation_method}.
     *
     * @stability stable
     */
    readonly aggregationMethod: string;
}
/**
 * @stability stable
 */
export interface SentinelAlertRuleScheduledIncidentConfigurationGrouping {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/sentinel_alert_rule_scheduled.html#enabled SentinelAlertRuleScheduled#enabled}.
     *
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/sentinel_alert_rule_scheduled.html#entity_matching_method SentinelAlertRuleScheduled#entity_matching_method}.
     *
     * @stability stable
     */
    readonly entityMatchingMethod?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/sentinel_alert_rule_scheduled.html#group_by SentinelAlertRuleScheduled#group_by}.
     *
     * @stability stable
     */
    readonly groupBy?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/sentinel_alert_rule_scheduled.html#lookback_duration SentinelAlertRuleScheduled#lookback_duration}.
     *
     * @stability stable
     */
    readonly lookbackDuration?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/sentinel_alert_rule_scheduled.html#reopen_closed_incidents SentinelAlertRuleScheduled#reopen_closed_incidents}.
     *
     * @stability stable
     */
    readonly reopenClosedIncidents?: boolean;
}
/**
 * @stability stable
 */
export interface SentinelAlertRuleScheduledIncidentConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/sentinel_alert_rule_scheduled.html#create_incident SentinelAlertRuleScheduled#create_incident}.
     *
     * @stability stable
     */
    readonly createIncident: boolean;
    /**
     * grouping block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/sentinel_alert_rule_scheduled.html#grouping SentinelAlertRuleScheduled#grouping}
     *
     * @stability stable
     */
    readonly grouping: SentinelAlertRuleScheduledIncidentConfigurationGrouping[];
}
/**
 * @stability stable
 */
export interface SentinelAlertRuleScheduledTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/sentinel_alert_rule_scheduled.html#create SentinelAlertRuleScheduled#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/sentinel_alert_rule_scheduled.html#delete SentinelAlertRuleScheduled#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/sentinel_alert_rule_scheduled.html#read SentinelAlertRuleScheduled#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/sentinel_alert_rule_scheduled.html#update SentinelAlertRuleScheduled#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/sentinel_alert_rule_scheduled.html azurerm_sentinel_alert_rule_scheduled}.
 *
 * @stability stable
 */
export declare class SentinelAlertRuleScheduled extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/sentinel_alert_rule_scheduled.html azurerm_sentinel_alert_rule_scheduled} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SentinelAlertRuleScheduledConfig);
    private _alertRuleTemplateGuid?;
    /**
     * @stability stable
     */
    get alertRuleTemplateGuid(): string;
    /**
     * @stability stable
     */
    set alertRuleTemplateGuid(value: string);
    /**
     * @stability stable
     */
    resetAlertRuleTemplateGuid(): void;
    /**
     * @stability stable
     */
    get alertRuleTemplateGuidInput(): string | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _displayName;
    /**
     * @stability stable
     */
    get displayName(): string;
    /**
     * @stability stable
     */
    set displayName(value: string);
    /**
     * @stability stable
     */
    get displayNameInput(): string;
    private _enabled?;
    /**
     * @stability stable
     */
    get enabled(): boolean;
    /**
     * @stability stable
     */
    set enabled(value: boolean);
    /**
     * @stability stable
     */
    resetEnabled(): void;
    /**
     * @stability stable
     */
    get enabledInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _logAnalyticsWorkspaceId;
    /**
     * @stability stable
     */
    get logAnalyticsWorkspaceId(): string;
    /**
     * @stability stable
     */
    set logAnalyticsWorkspaceId(value: string);
    /**
     * @stability stable
     */
    get logAnalyticsWorkspaceIdInput(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _query;
    /**
     * @stability stable
     */
    get query(): string;
    /**
     * @stability stable
     */
    set query(value: string);
    /**
     * @stability stable
     */
    get queryInput(): string;
    private _queryFrequency?;
    /**
     * @stability stable
     */
    get queryFrequency(): string;
    /**
     * @stability stable
     */
    set queryFrequency(value: string);
    /**
     * @stability stable
     */
    resetQueryFrequency(): void;
    /**
     * @stability stable
     */
    get queryFrequencyInput(): string | undefined;
    private _queryPeriod?;
    /**
     * @stability stable
     */
    get queryPeriod(): string;
    /**
     * @stability stable
     */
    set queryPeriod(value: string);
    /**
     * @stability stable
     */
    resetQueryPeriod(): void;
    /**
     * @stability stable
     */
    get queryPeriodInput(): string | undefined;
    private _severity;
    /**
     * @stability stable
     */
    get severity(): string;
    /**
     * @stability stable
     */
    set severity(value: string);
    /**
     * @stability stable
     */
    get severityInput(): string;
    private _suppressionDuration?;
    /**
     * @stability stable
     */
    get suppressionDuration(): string;
    /**
     * @stability stable
     */
    set suppressionDuration(value: string);
    /**
     * @stability stable
     */
    resetSuppressionDuration(): void;
    /**
     * @stability stable
     */
    get suppressionDurationInput(): string | undefined;
    private _suppressionEnabled?;
    /**
     * @stability stable
     */
    get suppressionEnabled(): boolean;
    /**
     * @stability stable
     */
    set suppressionEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetSuppressionEnabled(): void;
    /**
     * @stability stable
     */
    get suppressionEnabledInput(): boolean | undefined;
    private _tactics?;
    /**
     * @stability stable
     */
    get tactics(): string[];
    /**
     * @stability stable
     */
    set tactics(value: string[]);
    /**
     * @stability stable
     */
    resetTactics(): void;
    /**
     * @stability stable
     */
    get tacticsInput(): string[] | undefined;
    private _triggerOperator?;
    /**
     * @stability stable
     */
    get triggerOperator(): string;
    /**
     * @stability stable
     */
    set triggerOperator(value: string);
    /**
     * @stability stable
     */
    resetTriggerOperator(): void;
    /**
     * @stability stable
     */
    get triggerOperatorInput(): string | undefined;
    private _triggerThreshold?;
    /**
     * @stability stable
     */
    get triggerThreshold(): number;
    /**
     * @stability stable
     */
    set triggerThreshold(value: number);
    /**
     * @stability stable
     */
    resetTriggerThreshold(): void;
    /**
     * @stability stable
     */
    get triggerThresholdInput(): number | undefined;
    private _eventGrouping?;
    /**
     * @stability stable
     */
    get eventGrouping(): SentinelAlertRuleScheduledEventGrouping[];
    /**
     * @stability stable
     */
    set eventGrouping(value: SentinelAlertRuleScheduledEventGrouping[]);
    /**
     * @stability stable
     */
    resetEventGrouping(): void;
    /**
     * @stability stable
     */
    get eventGroupingInput(): SentinelAlertRuleScheduledEventGrouping[] | undefined;
    private _incidentConfiguration?;
    /**
     * @stability stable
     */
    get incidentConfiguration(): SentinelAlertRuleScheduledIncidentConfiguration[];
    /**
     * @stability stable
     */
    set incidentConfiguration(value: SentinelAlertRuleScheduledIncidentConfiguration[]);
    /**
     * @stability stable
     */
    resetIncidentConfiguration(): void;
    /**
     * @stability stable
     */
    get incidentConfigurationInput(): SentinelAlertRuleScheduledIncidentConfiguration[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): SentinelAlertRuleScheduledTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: SentinelAlertRuleScheduledTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): SentinelAlertRuleScheduledTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
