import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ServicebusQueueConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/servicebus_queue.html#auto_delete_on_idle ServicebusQueue#auto_delete_on_idle}.
     *
     * @stability stable
     */
    readonly autoDeleteOnIdle?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/servicebus_queue.html#dead_lettering_on_message_expiration ServicebusQueue#dead_lettering_on_message_expiration}.
     *
     * @stability stable
     */
    readonly deadLetteringOnMessageExpiration?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/servicebus_queue.html#default_message_ttl ServicebusQueue#default_message_ttl}.
     *
     * @stability stable
     */
    readonly defaultMessageTtl?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/servicebus_queue.html#duplicate_detection_history_time_window ServicebusQueue#duplicate_detection_history_time_window}.
     *
     * @stability stable
     */
    readonly duplicateDetectionHistoryTimeWindow?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/servicebus_queue.html#enable_batched_operations ServicebusQueue#enable_batched_operations}.
     *
     * @stability stable
     */
    readonly enableBatchedOperations?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/servicebus_queue.html#enable_express ServicebusQueue#enable_express}.
     *
     * @stability stable
     */
    readonly enableExpress?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/servicebus_queue.html#enable_partitioning ServicebusQueue#enable_partitioning}.
     *
     * @stability stable
     */
    readonly enablePartitioning?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/servicebus_queue.html#forward_dead_lettered_messages_to ServicebusQueue#forward_dead_lettered_messages_to}.
     *
     * @stability stable
     */
    readonly forwardDeadLetteredMessagesTo?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/servicebus_queue.html#forward_to ServicebusQueue#forward_to}.
     *
     * @stability stable
     */
    readonly forwardTo?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/servicebus_queue.html#lock_duration ServicebusQueue#lock_duration}.
     *
     * @stability stable
     */
    readonly lockDuration?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/servicebus_queue.html#max_delivery_count ServicebusQueue#max_delivery_count}.
     *
     * @stability stable
     */
    readonly maxDeliveryCount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/servicebus_queue.html#max_size_in_megabytes ServicebusQueue#max_size_in_megabytes}.
     *
     * @stability stable
     */
    readonly maxSizeInMegabytes?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/servicebus_queue.html#name ServicebusQueue#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/servicebus_queue.html#namespace_name ServicebusQueue#namespace_name}.
     *
     * @stability stable
     */
    readonly namespaceName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/servicebus_queue.html#requires_duplicate_detection ServicebusQueue#requires_duplicate_detection}.
     *
     * @stability stable
     */
    readonly requiresDuplicateDetection?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/servicebus_queue.html#requires_session ServicebusQueue#requires_session}.
     *
     * @stability stable
     */
    readonly requiresSession?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/servicebus_queue.html#resource_group_name ServicebusQueue#resource_group_name}.
     *
     * @stability stable
     */
    readonly resourceGroupName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/servicebus_queue.html#status ServicebusQueue#status}.
     *
     * @stability stable
     */
    readonly status?: string;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/servicebus_queue.html#timeouts ServicebusQueue#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: ServicebusQueueTimeouts;
}
/**
 * @stability stable
 */
export interface ServicebusQueueTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/servicebus_queue.html#create ServicebusQueue#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/servicebus_queue.html#delete ServicebusQueue#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/servicebus_queue.html#read ServicebusQueue#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/servicebus_queue.html#update ServicebusQueue#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/servicebus_queue.html azurerm_servicebus_queue}.
 *
 * @stability stable
 */
export declare class ServicebusQueue extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/servicebus_queue.html azurerm_servicebus_queue} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ServicebusQueueConfig);
    private _autoDeleteOnIdle?;
    /**
     * @stability stable
     */
    get autoDeleteOnIdle(): string;
    /**
     * @stability stable
     */
    set autoDeleteOnIdle(value: string);
    /**
     * @stability stable
     */
    resetAutoDeleteOnIdle(): void;
    /**
     * @stability stable
     */
    get autoDeleteOnIdleInput(): string | undefined;
    private _deadLetteringOnMessageExpiration?;
    /**
     * @stability stable
     */
    get deadLetteringOnMessageExpiration(): boolean;
    /**
     * @stability stable
     */
    set deadLetteringOnMessageExpiration(value: boolean);
    /**
     * @stability stable
     */
    resetDeadLetteringOnMessageExpiration(): void;
    /**
     * @stability stable
     */
    get deadLetteringOnMessageExpirationInput(): boolean | undefined;
    private _defaultMessageTtl?;
    /**
     * @stability stable
     */
    get defaultMessageTtl(): string;
    /**
     * @stability stable
     */
    set defaultMessageTtl(value: string);
    /**
     * @stability stable
     */
    resetDefaultMessageTtl(): void;
    /**
     * @stability stable
     */
    get defaultMessageTtlInput(): string | undefined;
    private _duplicateDetectionHistoryTimeWindow?;
    /**
     * @stability stable
     */
    get duplicateDetectionHistoryTimeWindow(): string;
    /**
     * @stability stable
     */
    set duplicateDetectionHistoryTimeWindow(value: string);
    /**
     * @stability stable
     */
    resetDuplicateDetectionHistoryTimeWindow(): void;
    /**
     * @stability stable
     */
    get duplicateDetectionHistoryTimeWindowInput(): string | undefined;
    private _enableBatchedOperations?;
    /**
     * @stability stable
     */
    get enableBatchedOperations(): boolean;
    /**
     * @stability stable
     */
    set enableBatchedOperations(value: boolean);
    /**
     * @stability stable
     */
    resetEnableBatchedOperations(): void;
    /**
     * @stability stable
     */
    get enableBatchedOperationsInput(): boolean | undefined;
    private _enableExpress?;
    /**
     * @stability stable
     */
    get enableExpress(): boolean;
    /**
     * @stability stable
     */
    set enableExpress(value: boolean);
    /**
     * @stability stable
     */
    resetEnableExpress(): void;
    /**
     * @stability stable
     */
    get enableExpressInput(): boolean | undefined;
    private _enablePartitioning?;
    /**
     * @stability stable
     */
    get enablePartitioning(): boolean;
    /**
     * @stability stable
     */
    set enablePartitioning(value: boolean);
    /**
     * @stability stable
     */
    resetEnablePartitioning(): void;
    /**
     * @stability stable
     */
    get enablePartitioningInput(): boolean | undefined;
    private _forwardDeadLetteredMessagesTo?;
    /**
     * @stability stable
     */
    get forwardDeadLetteredMessagesTo(): string;
    /**
     * @stability stable
     */
    set forwardDeadLetteredMessagesTo(value: string);
    /**
     * @stability stable
     */
    resetForwardDeadLetteredMessagesTo(): void;
    /**
     * @stability stable
     */
    get forwardDeadLetteredMessagesToInput(): string | undefined;
    private _forwardTo?;
    /**
     * @stability stable
     */
    get forwardTo(): string;
    /**
     * @stability stable
     */
    set forwardTo(value: string);
    /**
     * @stability stable
     */
    resetForwardTo(): void;
    /**
     * @stability stable
     */
    get forwardToInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _lockDuration?;
    /**
     * @stability stable
     */
    get lockDuration(): string;
    /**
     * @stability stable
     */
    set lockDuration(value: string);
    /**
     * @stability stable
     */
    resetLockDuration(): void;
    /**
     * @stability stable
     */
    get lockDurationInput(): string | undefined;
    private _maxDeliveryCount?;
    /**
     * @stability stable
     */
    get maxDeliveryCount(): number;
    /**
     * @stability stable
     */
    set maxDeliveryCount(value: number);
    /**
     * @stability stable
     */
    resetMaxDeliveryCount(): void;
    /**
     * @stability stable
     */
    get maxDeliveryCountInput(): number | undefined;
    private _maxSizeInMegabytes?;
    /**
     * @stability stable
     */
    get maxSizeInMegabytes(): number;
    /**
     * @stability stable
     */
    set maxSizeInMegabytes(value: number);
    /**
     * @stability stable
     */
    resetMaxSizeInMegabytes(): void;
    /**
     * @stability stable
     */
    get maxSizeInMegabytesInput(): number | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _namespaceName;
    /**
     * @stability stable
     */
    get namespaceName(): string;
    /**
     * @stability stable
     */
    set namespaceName(value: string);
    /**
     * @stability stable
     */
    get namespaceNameInput(): string;
    private _requiresDuplicateDetection?;
    /**
     * @stability stable
     */
    get requiresDuplicateDetection(): boolean;
    /**
     * @stability stable
     */
    set requiresDuplicateDetection(value: boolean);
    /**
     * @stability stable
     */
    resetRequiresDuplicateDetection(): void;
    /**
     * @stability stable
     */
    get requiresDuplicateDetectionInput(): boolean | undefined;
    private _requiresSession?;
    /**
     * @stability stable
     */
    get requiresSession(): boolean;
    /**
     * @stability stable
     */
    set requiresSession(value: boolean);
    /**
     * @stability stable
     */
    resetRequiresSession(): void;
    /**
     * @stability stable
     */
    get requiresSessionInput(): boolean | undefined;
    private _resourceGroupName;
    /**
     * @stability stable
     */
    get resourceGroupName(): string;
    /**
     * @stability stable
     */
    set resourceGroupName(value: string);
    /**
     * @stability stable
     */
    get resourceGroupNameInput(): string;
    private _status?;
    /**
     * @stability stable
     */
    get status(): string;
    /**
     * @stability stable
     */
    set status(value: string);
    /**
     * @stability stable
     */
    resetStatus(): void;
    /**
     * @stability stable
     */
    get statusInput(): string | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): ServicebusQueueTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: ServicebusQueueTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): ServicebusQueueTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
