import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface StorageAccountConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#access_tier StorageAccount#access_tier}.
     *
     * @stability stable
     */
    readonly accessTier?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#account_kind StorageAccount#account_kind}.
     *
     * @stability stable
     */
    readonly accountKind?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#account_replication_type StorageAccount#account_replication_type}.
     *
     * @stability stable
     */
    readonly accountReplicationType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#account_tier StorageAccount#account_tier}.
     *
     * @stability stable
     */
    readonly accountTier: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#allow_blob_public_access StorageAccount#allow_blob_public_access}.
     *
     * @stability stable
     */
    readonly allowBlobPublicAccess?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#enable_https_traffic_only StorageAccount#enable_https_traffic_only}.
     *
     * @stability stable
     */
    readonly enableHttpsTrafficOnly?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#is_hns_enabled StorageAccount#is_hns_enabled}.
     *
     * @stability stable
     */
    readonly isHnsEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#large_file_share_enabled StorageAccount#large_file_share_enabled}.
     *
     * @stability stable
     */
    readonly largeFileShareEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#location StorageAccount#location}.
     *
     * @stability stable
     */
    readonly location: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#min_tls_version StorageAccount#min_tls_version}.
     *
     * @stability stable
     */
    readonly minTlsVersion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#name StorageAccount#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#nfsv3_enabled StorageAccount#nfsv3_enabled}.
     *
     * @stability stable
     */
    readonly nfsv3Enabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#resource_group_name StorageAccount#resource_group_name}.
     *
     * @stability stable
     */
    readonly resourceGroupName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#tags StorageAccount#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * azure_files_authentication block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#azure_files_authentication StorageAccount#azure_files_authentication}
     *
     * @stability stable
     */
    readonly azureFilesAuthentication?: StorageAccountAzureFilesAuthentication[];
    /**
     * blob_properties block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#blob_properties StorageAccount#blob_properties}
     *
     * @stability stable
     */
    readonly blobProperties?: StorageAccountBlobProperties[];
    /**
     * custom_domain block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#custom_domain StorageAccount#custom_domain}
     *
     * @stability stable
     */
    readonly customDomain?: StorageAccountCustomDomain[];
    /**
     * identity block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#identity StorageAccount#identity}
     *
     * @stability stable
     */
    readonly identity?: StorageAccountIdentity[];
    /**
     * network_rules block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#network_rules StorageAccount#network_rules}
     *
     * @stability stable
     */
    readonly networkRules?: StorageAccountNetworkRules[];
    /**
     * queue_properties block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#queue_properties StorageAccount#queue_properties}
     *
     * @stability stable
     */
    readonly queueProperties?: StorageAccountQueueProperties[];
    /**
     * routing block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#routing StorageAccount#routing}
     *
     * @stability stable
     */
    readonly routing?: StorageAccountRouting[];
    /**
     * share_properties block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#share_properties StorageAccount#share_properties}
     *
     * @stability stable
     */
    readonly shareProperties?: StorageAccountShareProperties[];
    /**
     * static_website block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#static_website StorageAccount#static_website}
     *
     * @stability stable
     */
    readonly staticWebsite?: StorageAccountStaticWebsite[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#timeouts StorageAccount#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: StorageAccountTimeouts;
}
/**
 * @stability stable
 */
export interface StorageAccountAzureFilesAuthenticationActiveDirectory {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#domain_guid StorageAccount#domain_guid}.
     *
     * @stability stable
     */
    readonly domainGuid: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#domain_name StorageAccount#domain_name}.
     *
     * @stability stable
     */
    readonly domainName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#domain_sid StorageAccount#domain_sid}.
     *
     * @stability stable
     */
    readonly domainSid: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#forest_name StorageAccount#forest_name}.
     *
     * @stability stable
     */
    readonly forestName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#netbios_domain_name StorageAccount#netbios_domain_name}.
     *
     * @stability stable
     */
    readonly netbiosDomainName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#storage_sid StorageAccount#storage_sid}.
     *
     * @stability stable
     */
    readonly storageSid: string;
}
/**
 * @stability stable
 */
export interface StorageAccountAzureFilesAuthentication {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#directory_type StorageAccount#directory_type}.
     *
     * @stability stable
     */
    readonly directoryType: string;
    /**
     * active_directory block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#active_directory StorageAccount#active_directory}
     *
     * @stability stable
     */
    readonly activeDirectory?: StorageAccountAzureFilesAuthenticationActiveDirectory[];
}
/**
 * @stability stable
 */
export interface StorageAccountBlobPropertiesContainerDeleteRetentionPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#days StorageAccount#days}.
     *
     * @stability stable
     */
    readonly days?: number;
}
/**
 * @stability stable
 */
export interface StorageAccountBlobPropertiesCorsRule {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#allowed_headers StorageAccount#allowed_headers}.
     *
     * @stability stable
     */
    readonly allowedHeaders: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#allowed_methods StorageAccount#allowed_methods}.
     *
     * @stability stable
     */
    readonly allowedMethods: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#allowed_origins StorageAccount#allowed_origins}.
     *
     * @stability stable
     */
    readonly allowedOrigins: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#exposed_headers StorageAccount#exposed_headers}.
     *
     * @stability stable
     */
    readonly exposedHeaders: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#max_age_in_seconds StorageAccount#max_age_in_seconds}.
     *
     * @stability stable
     */
    readonly maxAgeInSeconds: number;
}
/**
 * @stability stable
 */
export interface StorageAccountBlobPropertiesDeleteRetentionPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#days StorageAccount#days}.
     *
     * @stability stable
     */
    readonly days?: number;
}
/**
 * @stability stable
 */
export interface StorageAccountBlobProperties {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#change_feed_enabled StorageAccount#change_feed_enabled}.
     *
     * @stability stable
     */
    readonly changeFeedEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#default_service_version StorageAccount#default_service_version}.
     *
     * @stability stable
     */
    readonly defaultServiceVersion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#last_access_time_enabled StorageAccount#last_access_time_enabled}.
     *
     * @stability stable
     */
    readonly lastAccessTimeEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#versioning_enabled StorageAccount#versioning_enabled}.
     *
     * @stability stable
     */
    readonly versioningEnabled?: boolean;
    /**
     * container_delete_retention_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#container_delete_retention_policy StorageAccount#container_delete_retention_policy}
     *
     * @stability stable
     */
    readonly containerDeleteRetentionPolicy?: StorageAccountBlobPropertiesContainerDeleteRetentionPolicy[];
    /**
     * cors_rule block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#cors_rule StorageAccount#cors_rule}
     *
     * @stability stable
     */
    readonly corsRule?: StorageAccountBlobPropertiesCorsRule[];
    /**
     * delete_retention_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#delete_retention_policy StorageAccount#delete_retention_policy}
     *
     * @stability stable
     */
    readonly deleteRetentionPolicy?: StorageAccountBlobPropertiesDeleteRetentionPolicy[];
}
/**
 * @stability stable
 */
export interface StorageAccountCustomDomain {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#name StorageAccount#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#use_subdomain StorageAccount#use_subdomain}.
     *
     * @stability stable
     */
    readonly useSubdomain?: boolean;
}
/**
 * @stability stable
 */
export interface StorageAccountIdentity {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#identity_ids StorageAccount#identity_ids}.
     *
     * @stability stable
     */
    readonly identityIds?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#type StorageAccount#type}.
     *
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface StorageAccountNetworkRulesPrivateLinkAccess {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#endpoint_resource_id StorageAccount#endpoint_resource_id}.
     *
     * @stability stable
     */
    readonly endpointResourceId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#endpoint_tenant_id StorageAccount#endpoint_tenant_id}.
     *
     * @stability stable
     */
    readonly endpointTenantId?: string;
}
/**
 * @stability stable
 */
export interface StorageAccountNetworkRules {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#bypass StorageAccount#bypass}.
     *
     * @stability stable
     */
    readonly bypass?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#default_action StorageAccount#default_action}.
     *
     * @stability stable
     */
    readonly defaultAction: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#ip_rules StorageAccount#ip_rules}.
     *
     * @stability stable
     */
    readonly ipRules?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#virtual_network_subnet_ids StorageAccount#virtual_network_subnet_ids}.
     *
     * @stability stable
     */
    readonly virtualNetworkSubnetIds?: string[];
    /**
     * private_link_access block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#private_link_access StorageAccount#private_link_access}
     *
     * @stability stable
     */
    readonly privateLinkAccess?: StorageAccountNetworkRulesPrivateLinkAccess[];
}
/**
 * @stability stable
 */
export interface StorageAccountQueuePropertiesCorsRule {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#allowed_headers StorageAccount#allowed_headers}.
     *
     * @stability stable
     */
    readonly allowedHeaders: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#allowed_methods StorageAccount#allowed_methods}.
     *
     * @stability stable
     */
    readonly allowedMethods: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#allowed_origins StorageAccount#allowed_origins}.
     *
     * @stability stable
     */
    readonly allowedOrigins: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#exposed_headers StorageAccount#exposed_headers}.
     *
     * @stability stable
     */
    readonly exposedHeaders: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#max_age_in_seconds StorageAccount#max_age_in_seconds}.
     *
     * @stability stable
     */
    readonly maxAgeInSeconds: number;
}
/**
 * @stability stable
 */
export interface StorageAccountQueuePropertiesHourMetrics {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#enabled StorageAccount#enabled}.
     *
     * @stability stable
     */
    readonly enabled: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#include_apis StorageAccount#include_apis}.
     *
     * @stability stable
     */
    readonly includeApis?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#retention_policy_days StorageAccount#retention_policy_days}.
     *
     * @stability stable
     */
    readonly retentionPolicyDays?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#version StorageAccount#version}.
     *
     * @stability stable
     */
    readonly version: string;
}
/**
 * @stability stable
 */
export interface StorageAccountQueuePropertiesLogging {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#delete StorageAccount#delete}.
     *
     * @stability stable
     */
    readonly delete: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#read StorageAccount#read}.
     *
     * @stability stable
     */
    readonly read: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#retention_policy_days StorageAccount#retention_policy_days}.
     *
     * @stability stable
     */
    readonly retentionPolicyDays?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#version StorageAccount#version}.
     *
     * @stability stable
     */
    readonly version: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#write StorageAccount#write}.
     *
     * @stability stable
     */
    readonly write: boolean;
}
/**
 * @stability stable
 */
export interface StorageAccountQueuePropertiesMinuteMetrics {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#enabled StorageAccount#enabled}.
     *
     * @stability stable
     */
    readonly enabled: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#include_apis StorageAccount#include_apis}.
     *
     * @stability stable
     */
    readonly includeApis?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#retention_policy_days StorageAccount#retention_policy_days}.
     *
     * @stability stable
     */
    readonly retentionPolicyDays?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#version StorageAccount#version}.
     *
     * @stability stable
     */
    readonly version: string;
}
/**
 * @stability stable
 */
export interface StorageAccountQueueProperties {
    /**
     * cors_rule block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#cors_rule StorageAccount#cors_rule}
     *
     * @stability stable
     */
    readonly corsRule?: StorageAccountQueuePropertiesCorsRule[];
    /**
     * hour_metrics block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#hour_metrics StorageAccount#hour_metrics}
     *
     * @stability stable
     */
    readonly hourMetrics?: StorageAccountQueuePropertiesHourMetrics[];
    /**
     * logging block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#logging StorageAccount#logging}
     *
     * @stability stable
     */
    readonly logging?: StorageAccountQueuePropertiesLogging[];
    /**
     * minute_metrics block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#minute_metrics StorageAccount#minute_metrics}
     *
     * @stability stable
     */
    readonly minuteMetrics?: StorageAccountQueuePropertiesMinuteMetrics[];
}
/**
 * @stability stable
 */
export interface StorageAccountRouting {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#choice StorageAccount#choice}.
     *
     * @stability stable
     */
    readonly choice?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#publish_internet_endpoints StorageAccount#publish_internet_endpoints}.
     *
     * @stability stable
     */
    readonly publishInternetEndpoints?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#publish_microsoft_endpoints StorageAccount#publish_microsoft_endpoints}.
     *
     * @stability stable
     */
    readonly publishMicrosoftEndpoints?: boolean;
}
/**
 * @stability stable
 */
export interface StorageAccountSharePropertiesCorsRule {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#allowed_headers StorageAccount#allowed_headers}.
     *
     * @stability stable
     */
    readonly allowedHeaders: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#allowed_methods StorageAccount#allowed_methods}.
     *
     * @stability stable
     */
    readonly allowedMethods: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#allowed_origins StorageAccount#allowed_origins}.
     *
     * @stability stable
     */
    readonly allowedOrigins: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#exposed_headers StorageAccount#exposed_headers}.
     *
     * @stability stable
     */
    readonly exposedHeaders: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#max_age_in_seconds StorageAccount#max_age_in_seconds}.
     *
     * @stability stable
     */
    readonly maxAgeInSeconds: number;
}
/**
 * @stability stable
 */
export interface StorageAccountSharePropertiesRetentionPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#days StorageAccount#days}.
     *
     * @stability stable
     */
    readonly days?: number;
}
/**
 * @stability stable
 */
export interface StorageAccountSharePropertiesSmb {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#authentication_types StorageAccount#authentication_types}.
     *
     * @stability stable
     */
    readonly authenticationTypes?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#channel_encryption_type StorageAccount#channel_encryption_type}.
     *
     * @stability stable
     */
    readonly channelEncryptionType?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#kerberos_ticket_encryption_type StorageAccount#kerberos_ticket_encryption_type}.
     *
     * @stability stable
     */
    readonly kerberosTicketEncryptionType?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#versions StorageAccount#versions}.
     *
     * @stability stable
     */
    readonly versions?: string[];
}
/**
 * @stability stable
 */
export interface StorageAccountShareProperties {
    /**
     * cors_rule block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#cors_rule StorageAccount#cors_rule}
     *
     * @stability stable
     */
    readonly corsRule?: StorageAccountSharePropertiesCorsRule[];
    /**
     * retention_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#retention_policy StorageAccount#retention_policy}
     *
     * @stability stable
     */
    readonly retentionPolicy?: StorageAccountSharePropertiesRetentionPolicy[];
    /**
     * smb block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#smb StorageAccount#smb}
     *
     * @stability stable
     */
    readonly smb?: StorageAccountSharePropertiesSmb[];
}
/**
 * @stability stable
 */
export interface StorageAccountStaticWebsite {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#error_404_document StorageAccount#error_404_document}.
     *
     * @stability stable
     */
    readonly error404Document?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#index_document StorageAccount#index_document}.
     *
     * @stability stable
     */
    readonly indexDocument?: string;
}
/**
 * @stability stable
 */
export interface StorageAccountTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#create StorageAccount#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#delete StorageAccount#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#read StorageAccount#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html#update StorageAccount#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html azurerm_storage_account}.
 *
 * @stability stable
 */
export declare class StorageAccount extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/storage_account.html azurerm_storage_account} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: StorageAccountConfig);
    private _accessTier?;
    /**
     * @stability stable
     */
    get accessTier(): string;
    /**
     * @stability stable
     */
    set accessTier(value: string);
    /**
     * @stability stable
     */
    resetAccessTier(): void;
    /**
     * @stability stable
     */
    get accessTierInput(): string | undefined;
    private _accountKind?;
    /**
     * @stability stable
     */
    get accountKind(): string;
    /**
     * @stability stable
     */
    set accountKind(value: string);
    /**
     * @stability stable
     */
    resetAccountKind(): void;
    /**
     * @stability stable
     */
    get accountKindInput(): string | undefined;
    private _accountReplicationType;
    /**
     * @stability stable
     */
    get accountReplicationType(): string;
    /**
     * @stability stable
     */
    set accountReplicationType(value: string);
    /**
     * @stability stable
     */
    get accountReplicationTypeInput(): string;
    private _accountTier;
    /**
     * @stability stable
     */
    get accountTier(): string;
    /**
     * @stability stable
     */
    set accountTier(value: string);
    /**
     * @stability stable
     */
    get accountTierInput(): string;
    private _allowBlobPublicAccess?;
    /**
     * @stability stable
     */
    get allowBlobPublicAccess(): boolean;
    /**
     * @stability stable
     */
    set allowBlobPublicAccess(value: boolean);
    /**
     * @stability stable
     */
    resetAllowBlobPublicAccess(): void;
    /**
     * @stability stable
     */
    get allowBlobPublicAccessInput(): boolean | undefined;
    private _enableHttpsTrafficOnly?;
    /**
     * @stability stable
     */
    get enableHttpsTrafficOnly(): boolean;
    /**
     * @stability stable
     */
    set enableHttpsTrafficOnly(value: boolean);
    /**
     * @stability stable
     */
    resetEnableHttpsTrafficOnly(): void;
    /**
     * @stability stable
     */
    get enableHttpsTrafficOnlyInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _isHnsEnabled?;
    /**
     * @stability stable
     */
    get isHnsEnabled(): boolean;
    /**
     * @stability stable
     */
    set isHnsEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetIsHnsEnabled(): void;
    /**
     * @stability stable
     */
    get isHnsEnabledInput(): boolean | undefined;
    private _largeFileShareEnabled?;
    /**
     * @stability stable
     */
    get largeFileShareEnabled(): boolean;
    /**
     * @stability stable
     */
    set largeFileShareEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetLargeFileShareEnabled(): void;
    /**
     * @stability stable
     */
    get largeFileShareEnabledInput(): boolean | undefined;
    private _location;
    /**
     * @stability stable
     */
    get location(): string;
    /**
     * @stability stable
     */
    set location(value: string);
    /**
     * @stability stable
     */
    get locationInput(): string;
    private _minTlsVersion?;
    /**
     * @stability stable
     */
    get minTlsVersion(): string;
    /**
     * @stability stable
     */
    set minTlsVersion(value: string);
    /**
     * @stability stable
     */
    resetMinTlsVersion(): void;
    /**
     * @stability stable
     */
    get minTlsVersionInput(): string | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _nfsv3Enabled?;
    /**
     * @stability stable
     */
    get nfsv3Enabled(): boolean;
    /**
     * @stability stable
     */
    set nfsv3Enabled(value: boolean);
    /**
     * @stability stable
     */
    resetNfsv3Enabled(): void;
    /**
     * @stability stable
     */
    get nfsv3EnabledInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get primaryAccessKey(): string;
    /**
     * @stability stable
     */
    get primaryBlobConnectionString(): string;
    /**
     * @stability stable
     */
    get primaryBlobEndpoint(): string;
    /**
     * @stability stable
     */
    get primaryBlobHost(): string;
    /**
     * @stability stable
     */
    get primaryConnectionString(): string;
    /**
     * @stability stable
     */
    get primaryDfsEndpoint(): string;
    /**
     * @stability stable
     */
    get primaryDfsHost(): string;
    /**
     * @stability stable
     */
    get primaryFileEndpoint(): string;
    /**
     * @stability stable
     */
    get primaryFileHost(): string;
    /**
     * @stability stable
     */
    get primaryLocation(): string;
    /**
     * @stability stable
     */
    get primaryQueueEndpoint(): string;
    /**
     * @stability stable
     */
    get primaryQueueHost(): string;
    /**
     * @stability stable
     */
    get primaryTableEndpoint(): string;
    /**
     * @stability stable
     */
    get primaryTableHost(): string;
    /**
     * @stability stable
     */
    get primaryWebEndpoint(): string;
    /**
     * @stability stable
     */
    get primaryWebHost(): string;
    private _resourceGroupName;
    /**
     * @stability stable
     */
    get resourceGroupName(): string;
    /**
     * @stability stable
     */
    set resourceGroupName(value: string);
    /**
     * @stability stable
     */
    get resourceGroupNameInput(): string;
    /**
     * @stability stable
     */
    get secondaryAccessKey(): string;
    /**
     * @stability stable
     */
    get secondaryBlobConnectionString(): string;
    /**
     * @stability stable
     */
    get secondaryBlobEndpoint(): string;
    /**
     * @stability stable
     */
    get secondaryBlobHost(): string;
    /**
     * @stability stable
     */
    get secondaryConnectionString(): string;
    /**
     * @stability stable
     */
    get secondaryDfsEndpoint(): string;
    /**
     * @stability stable
     */
    get secondaryDfsHost(): string;
    /**
     * @stability stable
     */
    get secondaryFileEndpoint(): string;
    /**
     * @stability stable
     */
    get secondaryFileHost(): string;
    /**
     * @stability stable
     */
    get secondaryLocation(): string;
    /**
     * @stability stable
     */
    get secondaryQueueEndpoint(): string;
    /**
     * @stability stable
     */
    get secondaryQueueHost(): string;
    /**
     * @stability stable
     */
    get secondaryTableEndpoint(): string;
    /**
     * @stability stable
     */
    get secondaryTableHost(): string;
    /**
     * @stability stable
     */
    get secondaryWebEndpoint(): string;
    /**
     * @stability stable
     */
    get secondaryWebHost(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _azureFilesAuthentication?;
    /**
     * @stability stable
     */
    get azureFilesAuthentication(): StorageAccountAzureFilesAuthentication[];
    /**
     * @stability stable
     */
    set azureFilesAuthentication(value: StorageAccountAzureFilesAuthentication[]);
    /**
     * @stability stable
     */
    resetAzureFilesAuthentication(): void;
    /**
     * @stability stable
     */
    get azureFilesAuthenticationInput(): StorageAccountAzureFilesAuthentication[] | undefined;
    private _blobProperties?;
    /**
     * @stability stable
     */
    get blobProperties(): StorageAccountBlobProperties[];
    /**
     * @stability stable
     */
    set blobProperties(value: StorageAccountBlobProperties[]);
    /**
     * @stability stable
     */
    resetBlobProperties(): void;
    /**
     * @stability stable
     */
    get blobPropertiesInput(): StorageAccountBlobProperties[] | undefined;
    private _customDomain?;
    /**
     * @stability stable
     */
    get customDomain(): StorageAccountCustomDomain[];
    /**
     * @stability stable
     */
    set customDomain(value: StorageAccountCustomDomain[]);
    /**
     * @stability stable
     */
    resetCustomDomain(): void;
    /**
     * @stability stable
     */
    get customDomainInput(): StorageAccountCustomDomain[] | undefined;
    private _identity?;
    /**
     * @stability stable
     */
    get identity(): StorageAccountIdentity[];
    /**
     * @stability stable
     */
    set identity(value: StorageAccountIdentity[]);
    /**
     * @stability stable
     */
    resetIdentity(): void;
    /**
     * @stability stable
     */
    get identityInput(): StorageAccountIdentity[] | undefined;
    private _networkRules?;
    /**
     * @stability stable
     */
    get networkRules(): StorageAccountNetworkRules[];
    /**
     * @stability stable
     */
    set networkRules(value: StorageAccountNetworkRules[]);
    /**
     * @stability stable
     */
    resetNetworkRules(): void;
    /**
     * @stability stable
     */
    get networkRulesInput(): StorageAccountNetworkRules[] | undefined;
    private _queueProperties?;
    /**
     * @stability stable
     */
    get queueProperties(): StorageAccountQueueProperties[];
    /**
     * @stability stable
     */
    set queueProperties(value: StorageAccountQueueProperties[]);
    /**
     * @stability stable
     */
    resetQueueProperties(): void;
    /**
     * @stability stable
     */
    get queuePropertiesInput(): StorageAccountQueueProperties[] | undefined;
    private _routing?;
    /**
     * @stability stable
     */
    get routing(): StorageAccountRouting[];
    /**
     * @stability stable
     */
    set routing(value: StorageAccountRouting[]);
    /**
     * @stability stable
     */
    resetRouting(): void;
    /**
     * @stability stable
     */
    get routingInput(): StorageAccountRouting[] | undefined;
    private _shareProperties?;
    /**
     * @stability stable
     */
    get shareProperties(): StorageAccountShareProperties[];
    /**
     * @stability stable
     */
    set shareProperties(value: StorageAccountShareProperties[]);
    /**
     * @stability stable
     */
    resetShareProperties(): void;
    /**
     * @stability stable
     */
    get sharePropertiesInput(): StorageAccountShareProperties[] | undefined;
    private _staticWebsite?;
    /**
     * @stability stable
     */
    get staticWebsite(): StorageAccountStaticWebsite[];
    /**
     * @stability stable
     */
    set staticWebsite(value: StorageAccountStaticWebsite[]);
    /**
     * @stability stable
     */
    resetStaticWebsite(): void;
    /**
     * @stability stable
     */
    get staticWebsiteInput(): StorageAccountStaticWebsite[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): StorageAccountTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: StorageAccountTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): StorageAccountTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
