import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface StorageManagementPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#storage_account_id StorageManagementPolicy#storage_account_id}.
     *
     * @stability stable
     */
    readonly storageAccountId: string;
    /**
     * rule block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#rule StorageManagementPolicy#rule}
     *
     * @stability stable
     */
    readonly rule?: StorageManagementPolicyRule[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#timeouts StorageManagementPolicy#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: StorageManagementPolicyTimeouts;
}
/**
 * @stability stable
 */
export interface StorageManagementPolicyRuleActionsBaseBlob {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#delete_after_days_since_modification_greater_than StorageManagementPolicy#delete_after_days_since_modification_greater_than}.
     *
     * @stability stable
     */
    readonly deleteAfterDaysSinceModificationGreaterThan?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#tier_to_archive_after_days_since_modification_greater_than StorageManagementPolicy#tier_to_archive_after_days_since_modification_greater_than}.
     *
     * @stability stable
     */
    readonly tierToArchiveAfterDaysSinceModificationGreaterThan?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#tier_to_cool_after_days_since_modification_greater_than StorageManagementPolicy#tier_to_cool_after_days_since_modification_greater_than}.
     *
     * @stability stable
     */
    readonly tierToCoolAfterDaysSinceModificationGreaterThan?: number;
}
/**
 * @stability stable
 */
export interface StorageManagementPolicyRuleActionsSnapshot {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#change_tier_to_archive_after_days_since_creation StorageManagementPolicy#change_tier_to_archive_after_days_since_creation}.
     *
     * @stability stable
     */
    readonly changeTierToArchiveAfterDaysSinceCreation?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#change_tier_to_cool_after_days_since_creation StorageManagementPolicy#change_tier_to_cool_after_days_since_creation}.
     *
     * @stability stable
     */
    readonly changeTierToCoolAfterDaysSinceCreation?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#delete_after_days_since_creation_greater_than StorageManagementPolicy#delete_after_days_since_creation_greater_than}.
     *
     * @stability stable
     */
    readonly deleteAfterDaysSinceCreationGreaterThan?: number;
}
/**
 * @stability stable
 */
export interface StorageManagementPolicyRuleActionsVersion {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#change_tier_to_archive_after_days_since_creation StorageManagementPolicy#change_tier_to_archive_after_days_since_creation}.
     *
     * @stability stable
     */
    readonly changeTierToArchiveAfterDaysSinceCreation?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#change_tier_to_cool_after_days_since_creation StorageManagementPolicy#change_tier_to_cool_after_days_since_creation}.
     *
     * @stability stable
     */
    readonly changeTierToCoolAfterDaysSinceCreation?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#delete_after_days_since_creation StorageManagementPolicy#delete_after_days_since_creation}.
     *
     * @stability stable
     */
    readonly deleteAfterDaysSinceCreation?: number;
}
/**
 * @stability stable
 */
export interface StorageManagementPolicyRuleActions {
    /**
     * base_blob block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#base_blob StorageManagementPolicy#base_blob}
     *
     * @stability stable
     */
    readonly baseBlob?: StorageManagementPolicyRuleActionsBaseBlob[];
    /**
     * snapshot block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#snapshot StorageManagementPolicy#snapshot}
     *
     * @stability stable
     */
    readonly snapshot?: StorageManagementPolicyRuleActionsSnapshot[];
    /**
     * version block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#version StorageManagementPolicy#version}
     *
     * @stability stable
     */
    readonly version?: StorageManagementPolicyRuleActionsVersion[];
}
/**
 * @stability stable
 */
export interface StorageManagementPolicyRuleFiltersMatchBlobIndexTag {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#name StorageManagementPolicy#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#operation StorageManagementPolicy#operation}.
     *
     * @stability stable
     */
    readonly operation?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#value StorageManagementPolicy#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
/**
 * @stability stable
 */
export interface StorageManagementPolicyRuleFilters {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#blob_types StorageManagementPolicy#blob_types}.
     *
     * @stability stable
     */
    readonly blobTypes?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#prefix_match StorageManagementPolicy#prefix_match}.
     *
     * @stability stable
     */
    readonly prefixMatch?: string[];
    /**
     * match_blob_index_tag block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#match_blob_index_tag StorageManagementPolicy#match_blob_index_tag}
     *
     * @stability stable
     */
    readonly matchBlobIndexTag?: StorageManagementPolicyRuleFiltersMatchBlobIndexTag[];
}
/**
 * @stability stable
 */
export interface StorageManagementPolicyRule {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#enabled StorageManagementPolicy#enabled}.
     *
     * @stability stable
     */
    readonly enabled: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#name StorageManagementPolicy#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * actions block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#actions StorageManagementPolicy#actions}
     *
     * @stability stable
     */
    readonly actions: StorageManagementPolicyRuleActions[];
    /**
     * filters block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#filters StorageManagementPolicy#filters}
     *
     * @stability stable
     */
    readonly filters?: StorageManagementPolicyRuleFilters[];
}
/**
 * @stability stable
 */
export interface StorageManagementPolicyTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#create StorageManagementPolicy#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#delete StorageManagementPolicy#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#read StorageManagementPolicy#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#update StorageManagementPolicy#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html azurerm_storage_management_policy}.
 *
 * @stability stable
 */
export declare class StorageManagementPolicy extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html azurerm_storage_management_policy} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: StorageManagementPolicyConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _storageAccountId;
    /**
     * @stability stable
     */
    get storageAccountId(): string;
    /**
     * @stability stable
     */
    set storageAccountId(value: string);
    /**
     * @stability stable
     */
    get storageAccountIdInput(): string;
    private _rule?;
    /**
     * @stability stable
     */
    get rule(): StorageManagementPolicyRule[];
    /**
     * @stability stable
     */
    set rule(value: StorageManagementPolicyRule[]);
    /**
     * @stability stable
     */
    resetRule(): void;
    /**
     * @stability stable
     */
    get ruleInput(): StorageManagementPolicyRule[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): StorageManagementPolicyTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: StorageManagementPolicyTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): StorageManagementPolicyTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
