import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SynapseSparkPoolConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_spark_pool.html#name SynapseSparkPool#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_spark_pool.html#node_count SynapseSparkPool#node_count}.
     *
     * @stability stable
     */
    readonly nodeCount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_spark_pool.html#node_size SynapseSparkPool#node_size}.
     *
     * @stability stable
     */
    readonly nodeSize: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_spark_pool.html#node_size_family SynapseSparkPool#node_size_family}.
     *
     * @stability stable
     */
    readonly nodeSizeFamily: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_spark_pool.html#spark_events_folder SynapseSparkPool#spark_events_folder}.
     *
     * @stability stable
     */
    readonly sparkEventsFolder?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_spark_pool.html#spark_log_folder SynapseSparkPool#spark_log_folder}.
     *
     * @stability stable
     */
    readonly sparkLogFolder?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_spark_pool.html#spark_version SynapseSparkPool#spark_version}.
     *
     * @stability stable
     */
    readonly sparkVersion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_spark_pool.html#synapse_workspace_id SynapseSparkPool#synapse_workspace_id}.
     *
     * @stability stable
     */
    readonly synapseWorkspaceId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_spark_pool.html#tags SynapseSparkPool#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * auto_pause block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_spark_pool.html#auto_pause SynapseSparkPool#auto_pause}
     *
     * @stability stable
     */
    readonly autoPause?: SynapseSparkPoolAutoPause[];
    /**
     * auto_scale block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_spark_pool.html#auto_scale SynapseSparkPool#auto_scale}
     *
     * @stability stable
     */
    readonly autoScale?: SynapseSparkPoolAutoScale[];
    /**
     * library_requirement block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_spark_pool.html#library_requirement SynapseSparkPool#library_requirement}
     *
     * @stability stable
     */
    readonly libraryRequirement?: SynapseSparkPoolLibraryRequirement[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_spark_pool.html#timeouts SynapseSparkPool#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: SynapseSparkPoolTimeouts;
}
/**
 * @stability stable
 */
export interface SynapseSparkPoolAutoPause {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_spark_pool.html#delay_in_minutes SynapseSparkPool#delay_in_minutes}.
     *
     * @stability stable
     */
    readonly delayInMinutes: number;
}
/**
 * @stability stable
 */
export interface SynapseSparkPoolAutoScale {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_spark_pool.html#max_node_count SynapseSparkPool#max_node_count}.
     *
     * @stability stable
     */
    readonly maxNodeCount: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_spark_pool.html#min_node_count SynapseSparkPool#min_node_count}.
     *
     * @stability stable
     */
    readonly minNodeCount: number;
}
/**
 * @stability stable
 */
export interface SynapseSparkPoolLibraryRequirement {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_spark_pool.html#content SynapseSparkPool#content}.
     *
     * @stability stable
     */
    readonly content: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_spark_pool.html#filename SynapseSparkPool#filename}.
     *
     * @stability stable
     */
    readonly filename: string;
}
/**
 * @stability stable
 */
export interface SynapseSparkPoolTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_spark_pool.html#create SynapseSparkPool#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_spark_pool.html#delete SynapseSparkPool#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_spark_pool.html#read SynapseSparkPool#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_spark_pool.html#update SynapseSparkPool#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_spark_pool.html azurerm_synapse_spark_pool}.
 *
 * @stability stable
 */
export declare class SynapseSparkPool extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_spark_pool.html azurerm_synapse_spark_pool} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SynapseSparkPoolConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _nodeCount?;
    /**
     * @stability stable
     */
    get nodeCount(): number;
    /**
     * @stability stable
     */
    set nodeCount(value: number);
    /**
     * @stability stable
     */
    resetNodeCount(): void;
    /**
     * @stability stable
     */
    get nodeCountInput(): number | undefined;
    private _nodeSize;
    /**
     * @stability stable
     */
    get nodeSize(): string;
    /**
     * @stability stable
     */
    set nodeSize(value: string);
    /**
     * @stability stable
     */
    get nodeSizeInput(): string;
    private _nodeSizeFamily;
    /**
     * @stability stable
     */
    get nodeSizeFamily(): string;
    /**
     * @stability stable
     */
    set nodeSizeFamily(value: string);
    /**
     * @stability stable
     */
    get nodeSizeFamilyInput(): string;
    private _sparkEventsFolder?;
    /**
     * @stability stable
     */
    get sparkEventsFolder(): string;
    /**
     * @stability stable
     */
    set sparkEventsFolder(value: string);
    /**
     * @stability stable
     */
    resetSparkEventsFolder(): void;
    /**
     * @stability stable
     */
    get sparkEventsFolderInput(): string | undefined;
    private _sparkLogFolder?;
    /**
     * @stability stable
     */
    get sparkLogFolder(): string;
    /**
     * @stability stable
     */
    set sparkLogFolder(value: string);
    /**
     * @stability stable
     */
    resetSparkLogFolder(): void;
    /**
     * @stability stable
     */
    get sparkLogFolderInput(): string | undefined;
    private _sparkVersion?;
    /**
     * @stability stable
     */
    get sparkVersion(): string;
    /**
     * @stability stable
     */
    set sparkVersion(value: string);
    /**
     * @stability stable
     */
    resetSparkVersion(): void;
    /**
     * @stability stable
     */
    get sparkVersionInput(): string | undefined;
    private _synapseWorkspaceId;
    /**
     * @stability stable
     */
    get synapseWorkspaceId(): string;
    /**
     * @stability stable
     */
    set synapseWorkspaceId(value: string);
    /**
     * @stability stable
     */
    get synapseWorkspaceIdInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _autoPause?;
    /**
     * @stability stable
     */
    get autoPause(): SynapseSparkPoolAutoPause[];
    /**
     * @stability stable
     */
    set autoPause(value: SynapseSparkPoolAutoPause[]);
    /**
     * @stability stable
     */
    resetAutoPause(): void;
    /**
     * @stability stable
     */
    get autoPauseInput(): SynapseSparkPoolAutoPause[] | undefined;
    private _autoScale?;
    /**
     * @stability stable
     */
    get autoScale(): SynapseSparkPoolAutoScale[];
    /**
     * @stability stable
     */
    set autoScale(value: SynapseSparkPoolAutoScale[]);
    /**
     * @stability stable
     */
    resetAutoScale(): void;
    /**
     * @stability stable
     */
    get autoScaleInput(): SynapseSparkPoolAutoScale[] | undefined;
    private _libraryRequirement?;
    /**
     * @stability stable
     */
    get libraryRequirement(): SynapseSparkPoolLibraryRequirement[];
    /**
     * @stability stable
     */
    set libraryRequirement(value: SynapseSparkPoolLibraryRequirement[]);
    /**
     * @stability stable
     */
    resetLibraryRequirement(): void;
    /**
     * @stability stable
     */
    get libraryRequirementInput(): SynapseSparkPoolLibraryRequirement[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): SynapseSparkPoolTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: SynapseSparkPoolTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): SynapseSparkPoolTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
