import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SynapseWorkspaceConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_workspace.html#aad_admin SynapseWorkspace#aad_admin}.
     *
     * @stability stable
     */
    readonly aadAdmin?: SynapseWorkspaceAadAdmin[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_workspace.html#customer_managed_key_versionless_id SynapseWorkspace#customer_managed_key_versionless_id}.
     *
     * @stability stable
     */
    readonly customerManagedKeyVersionlessId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_workspace.html#data_exfiltration_protection_enabled SynapseWorkspace#data_exfiltration_protection_enabled}.
     *
     * @stability stable
     */
    readonly dataExfiltrationProtectionEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_workspace.html#location SynapseWorkspace#location}.
     *
     * @stability stable
     */
    readonly location: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_workspace.html#managed_resource_group_name SynapseWorkspace#managed_resource_group_name}.
     *
     * @stability stable
     */
    readonly managedResourceGroupName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_workspace.html#managed_virtual_network_enabled SynapseWorkspace#managed_virtual_network_enabled}.
     *
     * @stability stable
     */
    readonly managedVirtualNetworkEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_workspace.html#name SynapseWorkspace#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_workspace.html#resource_group_name SynapseWorkspace#resource_group_name}.
     *
     * @stability stable
     */
    readonly resourceGroupName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_workspace.html#sql_administrator_login SynapseWorkspace#sql_administrator_login}.
     *
     * @stability stable
     */
    readonly sqlAdministratorLogin: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_workspace.html#sql_administrator_login_password SynapseWorkspace#sql_administrator_login_password}.
     *
     * @stability stable
     */
    readonly sqlAdministratorLoginPassword: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_workspace.html#sql_identity_control_enabled SynapseWorkspace#sql_identity_control_enabled}.
     *
     * @stability stable
     */
    readonly sqlIdentityControlEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_workspace.html#storage_data_lake_gen2_filesystem_id SynapseWorkspace#storage_data_lake_gen2_filesystem_id}.
     *
     * @stability stable
     */
    readonly storageDataLakeGen2FilesystemId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_workspace.html#tags SynapseWorkspace#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * azure_devops_repo block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_workspace.html#azure_devops_repo SynapseWorkspace#azure_devops_repo}
     *
     * @stability stable
     */
    readonly azureDevopsRepo?: SynapseWorkspaceAzureDevopsRepo[];
    /**
     * github_repo block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_workspace.html#github_repo SynapseWorkspace#github_repo}
     *
     * @stability stable
     */
    readonly githubRepo?: SynapseWorkspaceGithubRepo[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_workspace.html#timeouts SynapseWorkspace#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: SynapseWorkspaceTimeouts;
}
/**
 * @stability stable
 */
export interface SynapseWorkspaceAadAdmin {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_workspace.html#login SynapseWorkspace#login}.
     *
     * @stability stable
     */
    readonly login?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_workspace.html#object_id SynapseWorkspace#object_id}.
     *
     * @stability stable
     */
    readonly objectId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_workspace.html#tenant_id SynapseWorkspace#tenant_id}.
     *
     * @stability stable
     */
    readonly tenantId?: string;
}
/**
 * @stability stable
 */
export declare class SynapseWorkspaceIdentity extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get principalId(): string;
    /**
     * @stability stable
     */
    get tenantId(): string;
    /**
     * @stability stable
     */
    get type(): string;
}
/**
 * @stability stable
 */
export interface SynapseWorkspaceAzureDevopsRepo {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_workspace.html#account_name SynapseWorkspace#account_name}.
     *
     * @stability stable
     */
    readonly accountName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_workspace.html#branch_name SynapseWorkspace#branch_name}.
     *
     * @stability stable
     */
    readonly branchName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_workspace.html#project_name SynapseWorkspace#project_name}.
     *
     * @stability stable
     */
    readonly projectName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_workspace.html#repository_name SynapseWorkspace#repository_name}.
     *
     * @stability stable
     */
    readonly repositoryName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_workspace.html#root_folder SynapseWorkspace#root_folder}.
     *
     * @stability stable
     */
    readonly rootFolder: string;
}
/**
 * @stability stable
 */
export interface SynapseWorkspaceGithubRepo {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_workspace.html#account_name SynapseWorkspace#account_name}.
     *
     * @stability stable
     */
    readonly accountName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_workspace.html#branch_name SynapseWorkspace#branch_name}.
     *
     * @stability stable
     */
    readonly branchName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_workspace.html#git_url SynapseWorkspace#git_url}.
     *
     * @stability stable
     */
    readonly gitUrl?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_workspace.html#repository_name SynapseWorkspace#repository_name}.
     *
     * @stability stable
     */
    readonly repositoryName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_workspace.html#root_folder SynapseWorkspace#root_folder}.
     *
     * @stability stable
     */
    readonly rootFolder: string;
}
/**
 * @stability stable
 */
export interface SynapseWorkspaceTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_workspace.html#create SynapseWorkspace#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_workspace.html#delete SynapseWorkspace#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_workspace.html#read SynapseWorkspace#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_workspace.html#update SynapseWorkspace#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_workspace.html azurerm_synapse_workspace}.
 *
 * @stability stable
 */
export declare class SynapseWorkspace extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/synapse_workspace.html azurerm_synapse_workspace} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SynapseWorkspaceConfig);
    private _aadAdmin?;
    /**
     * @stability stable
     */
    get aadAdmin(): SynapseWorkspaceAadAdmin[];
    /**
     * @stability stable
     */
    set aadAdmin(value: SynapseWorkspaceAadAdmin[]);
    /**
     * @stability stable
     */
    resetAadAdmin(): void;
    /**
     * @stability stable
     */
    get aadAdminInput(): SynapseWorkspaceAadAdmin[] | undefined;
    /**
     * @stability stable
     */
    connectivityEndpoints(key: string): string;
    private _customerManagedKeyVersionlessId?;
    /**
     * @stability stable
     */
    get customerManagedKeyVersionlessId(): string;
    /**
     * @stability stable
     */
    set customerManagedKeyVersionlessId(value: string);
    /**
     * @stability stable
     */
    resetCustomerManagedKeyVersionlessId(): void;
    /**
     * @stability stable
     */
    get customerManagedKeyVersionlessIdInput(): string | undefined;
    private _dataExfiltrationProtectionEnabled?;
    /**
     * @stability stable
     */
    get dataExfiltrationProtectionEnabled(): boolean;
    /**
     * @stability stable
     */
    set dataExfiltrationProtectionEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetDataExfiltrationProtectionEnabled(): void;
    /**
     * @stability stable
     */
    get dataExfiltrationProtectionEnabledInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    identity(index: string): SynapseWorkspaceIdentity;
    private _location;
    /**
     * @stability stable
     */
    get location(): string;
    /**
     * @stability stable
     */
    set location(value: string);
    /**
     * @stability stable
     */
    get locationInput(): string;
    private _managedResourceGroupName?;
    /**
     * @stability stable
     */
    get managedResourceGroupName(): string;
    /**
     * @stability stable
     */
    set managedResourceGroupName(value: string);
    /**
     * @stability stable
     */
    resetManagedResourceGroupName(): void;
    /**
     * @stability stable
     */
    get managedResourceGroupNameInput(): string | undefined;
    private _managedVirtualNetworkEnabled?;
    /**
     * @stability stable
     */
    get managedVirtualNetworkEnabled(): boolean;
    /**
     * @stability stable
     */
    set managedVirtualNetworkEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetManagedVirtualNetworkEnabled(): void;
    /**
     * @stability stable
     */
    get managedVirtualNetworkEnabledInput(): boolean | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _resourceGroupName;
    /**
     * @stability stable
     */
    get resourceGroupName(): string;
    /**
     * @stability stable
     */
    set resourceGroupName(value: string);
    /**
     * @stability stable
     */
    get resourceGroupNameInput(): string;
    private _sqlAdministratorLogin;
    /**
     * @stability stable
     */
    get sqlAdministratorLogin(): string;
    /**
     * @stability stable
     */
    set sqlAdministratorLogin(value: string);
    /**
     * @stability stable
     */
    get sqlAdministratorLoginInput(): string;
    private _sqlAdministratorLoginPassword;
    /**
     * @stability stable
     */
    get sqlAdministratorLoginPassword(): string;
    /**
     * @stability stable
     */
    set sqlAdministratorLoginPassword(value: string);
    /**
     * @stability stable
     */
    get sqlAdministratorLoginPasswordInput(): string;
    private _sqlIdentityControlEnabled?;
    /**
     * @stability stable
     */
    get sqlIdentityControlEnabled(): boolean;
    /**
     * @stability stable
     */
    set sqlIdentityControlEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetSqlIdentityControlEnabled(): void;
    /**
     * @stability stable
     */
    get sqlIdentityControlEnabledInput(): boolean | undefined;
    private _storageDataLakeGen2FilesystemId;
    /**
     * @stability stable
     */
    get storageDataLakeGen2FilesystemId(): string;
    /**
     * @stability stable
     */
    set storageDataLakeGen2FilesystemId(value: string);
    /**
     * @stability stable
     */
    get storageDataLakeGen2FilesystemIdInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _azureDevopsRepo?;
    /**
     * @stability stable
     */
    get azureDevopsRepo(): SynapseWorkspaceAzureDevopsRepo[];
    /**
     * @stability stable
     */
    set azureDevopsRepo(value: SynapseWorkspaceAzureDevopsRepo[]);
    /**
     * @stability stable
     */
    resetAzureDevopsRepo(): void;
    /**
     * @stability stable
     */
    get azureDevopsRepoInput(): SynapseWorkspaceAzureDevopsRepo[] | undefined;
    private _githubRepo?;
    /**
     * @stability stable
     */
    get githubRepo(): SynapseWorkspaceGithubRepo[];
    /**
     * @stability stable
     */
    set githubRepo(value: SynapseWorkspaceGithubRepo[]);
    /**
     * @stability stable
     */
    resetGithubRepo(): void;
    /**
     * @stability stable
     */
    get githubRepoInput(): SynapseWorkspaceGithubRepo[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): SynapseWorkspaceTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: SynapseWorkspaceTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): SynapseWorkspaceTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
