import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface TrafficManagerEndpointConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/traffic_manager_endpoint.html#endpoint_location TrafficManagerEndpoint#endpoint_location}.
     *
     * @stability stable
     */
    readonly endpointLocation?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/traffic_manager_endpoint.html#endpoint_status TrafficManagerEndpoint#endpoint_status}.
     *
     * @stability stable
     */
    readonly endpointStatus?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/traffic_manager_endpoint.html#geo_mappings TrafficManagerEndpoint#geo_mappings}.
     *
     * @stability stable
     */
    readonly geoMappings?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/traffic_manager_endpoint.html#min_child_endpoints TrafficManagerEndpoint#min_child_endpoints}.
     *
     * @stability stable
     */
    readonly minChildEndpoints?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/traffic_manager_endpoint.html#name TrafficManagerEndpoint#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/traffic_manager_endpoint.html#priority TrafficManagerEndpoint#priority}.
     *
     * @stability stable
     */
    readonly priority?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/traffic_manager_endpoint.html#profile_name TrafficManagerEndpoint#profile_name}.
     *
     * @stability stable
     */
    readonly profileName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/traffic_manager_endpoint.html#resource_group_name TrafficManagerEndpoint#resource_group_name}.
     *
     * @stability stable
     */
    readonly resourceGroupName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/traffic_manager_endpoint.html#target TrafficManagerEndpoint#target}.
     *
     * @stability stable
     */
    readonly target?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/traffic_manager_endpoint.html#target_resource_id TrafficManagerEndpoint#target_resource_id}.
     *
     * @stability stable
     */
    readonly targetResourceId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/traffic_manager_endpoint.html#type TrafficManagerEndpoint#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/traffic_manager_endpoint.html#weight TrafficManagerEndpoint#weight}.
     *
     * @stability stable
     */
    readonly weight?: number;
    /**
     * custom_header block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/traffic_manager_endpoint.html#custom_header TrafficManagerEndpoint#custom_header}
     *
     * @stability stable
     */
    readonly customHeader?: TrafficManagerEndpointCustomHeader[];
    /**
     * subnet block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/traffic_manager_endpoint.html#subnet TrafficManagerEndpoint#subnet}
     *
     * @stability stable
     */
    readonly subnet?: TrafficManagerEndpointSubnet[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/traffic_manager_endpoint.html#timeouts TrafficManagerEndpoint#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: TrafficManagerEndpointTimeouts;
}
/**
 * @stability stable
 */
export interface TrafficManagerEndpointCustomHeader {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/traffic_manager_endpoint.html#name TrafficManagerEndpoint#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/traffic_manager_endpoint.html#value TrafficManagerEndpoint#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
/**
 * @stability stable
 */
export interface TrafficManagerEndpointSubnet {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/traffic_manager_endpoint.html#first TrafficManagerEndpoint#first}.
     *
     * @stability stable
     */
    readonly first: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/traffic_manager_endpoint.html#last TrafficManagerEndpoint#last}.
     *
     * @stability stable
     */
    readonly last?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/traffic_manager_endpoint.html#scope TrafficManagerEndpoint#scope}.
     *
     * @stability stable
     */
    readonly scope?: number;
}
/**
 * @stability stable
 */
export interface TrafficManagerEndpointTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/traffic_manager_endpoint.html#create TrafficManagerEndpoint#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/traffic_manager_endpoint.html#delete TrafficManagerEndpoint#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/traffic_manager_endpoint.html#read TrafficManagerEndpoint#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/traffic_manager_endpoint.html#update TrafficManagerEndpoint#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/traffic_manager_endpoint.html azurerm_traffic_manager_endpoint}.
 *
 * @stability stable
 */
export declare class TrafficManagerEndpoint extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/traffic_manager_endpoint.html azurerm_traffic_manager_endpoint} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: TrafficManagerEndpointConfig);
    private _endpointLocation?;
    /**
     * @stability stable
     */
    get endpointLocation(): string;
    /**
     * @stability stable
     */
    set endpointLocation(value: string);
    /**
     * @stability stable
     */
    resetEndpointLocation(): void;
    /**
     * @stability stable
     */
    get endpointLocationInput(): string | undefined;
    /**
     * @stability stable
     */
    get endpointMonitorStatus(): string;
    private _endpointStatus?;
    /**
     * @stability stable
     */
    get endpointStatus(): string;
    /**
     * @stability stable
     */
    set endpointStatus(value: string);
    /**
     * @stability stable
     */
    resetEndpointStatus(): void;
    /**
     * @stability stable
     */
    get endpointStatusInput(): string | undefined;
    private _geoMappings?;
    /**
     * @stability stable
     */
    get geoMappings(): string[];
    /**
     * @stability stable
     */
    set geoMappings(value: string[]);
    /**
     * @stability stable
     */
    resetGeoMappings(): void;
    /**
     * @stability stable
     */
    get geoMappingsInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _minChildEndpoints?;
    /**
     * @stability stable
     */
    get minChildEndpoints(): number;
    /**
     * @stability stable
     */
    set minChildEndpoints(value: number);
    /**
     * @stability stable
     */
    resetMinChildEndpoints(): void;
    /**
     * @stability stable
     */
    get minChildEndpointsInput(): number | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _priority?;
    /**
     * @stability stable
     */
    get priority(): number;
    /**
     * @stability stable
     */
    set priority(value: number);
    /**
     * @stability stable
     */
    resetPriority(): void;
    /**
     * @stability stable
     */
    get priorityInput(): number | undefined;
    private _profileName;
    /**
     * @stability stable
     */
    get profileName(): string;
    /**
     * @stability stable
     */
    set profileName(value: string);
    /**
     * @stability stable
     */
    get profileNameInput(): string;
    private _resourceGroupName;
    /**
     * @stability stable
     */
    get resourceGroupName(): string;
    /**
     * @stability stable
     */
    set resourceGroupName(value: string);
    /**
     * @stability stable
     */
    get resourceGroupNameInput(): string;
    private _target?;
    /**
     * @stability stable
     */
    get target(): string;
    /**
     * @stability stable
     */
    set target(value: string);
    /**
     * @stability stable
     */
    resetTarget(): void;
    /**
     * @stability stable
     */
    get targetInput(): string | undefined;
    private _targetResourceId?;
    /**
     * @stability stable
     */
    get targetResourceId(): string;
    /**
     * @stability stable
     */
    set targetResourceId(value: string);
    /**
     * @stability stable
     */
    resetTargetResourceId(): void;
    /**
     * @stability stable
     */
    get targetResourceIdInput(): string | undefined;
    private _type;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    get typeInput(): string;
    private _weight?;
    /**
     * @stability stable
     */
    get weight(): number;
    /**
     * @stability stable
     */
    set weight(value: number);
    /**
     * @stability stable
     */
    resetWeight(): void;
    /**
     * @stability stable
     */
    get weightInput(): number | undefined;
    private _customHeader?;
    /**
     * @stability stable
     */
    get customHeader(): TrafficManagerEndpointCustomHeader[];
    /**
     * @stability stable
     */
    set customHeader(value: TrafficManagerEndpointCustomHeader[]);
    /**
     * @stability stable
     */
    resetCustomHeader(): void;
    /**
     * @stability stable
     */
    get customHeaderInput(): TrafficManagerEndpointCustomHeader[] | undefined;
    private _subnet?;
    /**
     * @stability stable
     */
    get subnet(): TrafficManagerEndpointSubnet[];
    /**
     * @stability stable
     */
    set subnet(value: TrafficManagerEndpointSubnet[]);
    /**
     * @stability stable
     */
    resetSubnet(): void;
    /**
     * @stability stable
     */
    get subnetInput(): TrafficManagerEndpointSubnet[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): TrafficManagerEndpointTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: TrafficManagerEndpointTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): TrafficManagerEndpointTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
