import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface VirtualMachineScaleSetConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#automatic_os_upgrade VirtualMachineScaleSet#automatic_os_upgrade}.
     *
     * @stability stable
     */
    readonly automaticOsUpgrade?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#eviction_policy VirtualMachineScaleSet#eviction_policy}.
     *
     * @stability stable
     */
    readonly evictionPolicy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#health_probe_id VirtualMachineScaleSet#health_probe_id}.
     *
     * @stability stable
     */
    readonly healthProbeId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#license_type VirtualMachineScaleSet#license_type}.
     *
     * @stability stable
     */
    readonly licenseType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#location VirtualMachineScaleSet#location}.
     *
     * @stability stable
     */
    readonly location: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#name VirtualMachineScaleSet#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#overprovision VirtualMachineScaleSet#overprovision}.
     *
     * @stability stable
     */
    readonly overprovision?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#priority VirtualMachineScaleSet#priority}.
     *
     * @stability stable
     */
    readonly priority?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#proximity_placement_group_id VirtualMachineScaleSet#proximity_placement_group_id}.
     *
     * @stability stable
     */
    readonly proximityPlacementGroupId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#resource_group_name VirtualMachineScaleSet#resource_group_name}.
     *
     * @stability stable
     */
    readonly resourceGroupName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#single_placement_group VirtualMachineScaleSet#single_placement_group}.
     *
     * @stability stable
     */
    readonly singlePlacementGroup?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#tags VirtualMachineScaleSet#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#upgrade_policy_mode VirtualMachineScaleSet#upgrade_policy_mode}.
     *
     * @stability stable
     */
    readonly upgradePolicyMode: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#zones VirtualMachineScaleSet#zones}.
     *
     * @stability stable
     */
    readonly zones?: string[];
    /**
     * boot_diagnostics block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#boot_diagnostics VirtualMachineScaleSet#boot_diagnostics}
     *
     * @stability stable
     */
    readonly bootDiagnostics?: VirtualMachineScaleSetBootDiagnostics[];
    /**
     * extension block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#extension VirtualMachineScaleSet#extension}
     *
     * @stability stable
     */
    readonly extension?: VirtualMachineScaleSetExtension[];
    /**
     * identity block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#identity VirtualMachineScaleSet#identity}
     *
     * @stability stable
     */
    readonly identity?: VirtualMachineScaleSetIdentity[];
    /**
     * network_profile block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#network_profile VirtualMachineScaleSet#network_profile}
     *
     * @stability stable
     */
    readonly networkProfile: VirtualMachineScaleSetNetworkProfile[];
    /**
     * os_profile block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#os_profile VirtualMachineScaleSet#os_profile}
     *
     * @stability stable
     */
    readonly osProfile: VirtualMachineScaleSetOsProfile[];
    /**
     * os_profile_linux_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#os_profile_linux_config VirtualMachineScaleSet#os_profile_linux_config}
     *
     * @stability stable
     */
    readonly osProfileLinuxConfig?: VirtualMachineScaleSetOsProfileLinuxConfig[];
    /**
     * os_profile_secrets block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#os_profile_secrets VirtualMachineScaleSet#os_profile_secrets}
     *
     * @stability stable
     */
    readonly osProfileSecrets?: VirtualMachineScaleSetOsProfileSecrets[];
    /**
     * os_profile_windows_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#os_profile_windows_config VirtualMachineScaleSet#os_profile_windows_config}
     *
     * @stability stable
     */
    readonly osProfileWindowsConfig?: VirtualMachineScaleSetOsProfileWindowsConfig[];
    /**
     * plan block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#plan VirtualMachineScaleSet#plan}
     *
     * @stability stable
     */
    readonly plan?: VirtualMachineScaleSetPlan[];
    /**
     * rolling_upgrade_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#rolling_upgrade_policy VirtualMachineScaleSet#rolling_upgrade_policy}
     *
     * @stability stable
     */
    readonly rollingUpgradePolicy?: VirtualMachineScaleSetRollingUpgradePolicy[];
    /**
     * sku block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#sku VirtualMachineScaleSet#sku}
     *
     * @stability stable
     */
    readonly sku: VirtualMachineScaleSetSku[];
    /**
     * storage_profile_data_disk block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#storage_profile_data_disk VirtualMachineScaleSet#storage_profile_data_disk}
     *
     * @stability stable
     */
    readonly storageProfileDataDisk?: VirtualMachineScaleSetStorageProfileDataDisk[];
    /**
     * storage_profile_image_reference block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#storage_profile_image_reference VirtualMachineScaleSet#storage_profile_image_reference}
     *
     * @stability stable
     */
    readonly storageProfileImageReference?: VirtualMachineScaleSetStorageProfileImageReference[];
    /**
     * storage_profile_os_disk block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#storage_profile_os_disk VirtualMachineScaleSet#storage_profile_os_disk}
     *
     * @stability stable
     */
    readonly storageProfileOsDisk: VirtualMachineScaleSetStorageProfileOsDisk[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#timeouts VirtualMachineScaleSet#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: VirtualMachineScaleSetTimeouts;
}
/**
 * @stability stable
 */
export interface VirtualMachineScaleSetBootDiagnostics {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#enabled VirtualMachineScaleSet#enabled}.
     *
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#storage_uri VirtualMachineScaleSet#storage_uri}.
     *
     * @stability stable
     */
    readonly storageUri: string;
}
/**
 * @stability stable
 */
export interface VirtualMachineScaleSetExtension {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#auto_upgrade_minor_version VirtualMachineScaleSet#auto_upgrade_minor_version}.
     *
     * @stability stable
     */
    readonly autoUpgradeMinorVersion?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#name VirtualMachineScaleSet#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#protected_settings VirtualMachineScaleSet#protected_settings}.
     *
     * @stability stable
     */
    readonly protectedSettings?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#provision_after_extensions VirtualMachineScaleSet#provision_after_extensions}.
     *
     * @stability stable
     */
    readonly provisionAfterExtensions?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#publisher VirtualMachineScaleSet#publisher}.
     *
     * @stability stable
     */
    readonly publisher: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#settings VirtualMachineScaleSet#settings}.
     *
     * @stability stable
     */
    readonly settings?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#type VirtualMachineScaleSet#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#type_handler_version VirtualMachineScaleSet#type_handler_version}.
     *
     * @stability stable
     */
    readonly typeHandlerVersion: string;
}
/**
 * @stability stable
 */
export interface VirtualMachineScaleSetIdentity {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#identity_ids VirtualMachineScaleSet#identity_ids}.
     *
     * @stability stable
     */
    readonly identityIds?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#type VirtualMachineScaleSet#type}.
     *
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface VirtualMachineScaleSetNetworkProfileDnsSettings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#dns_servers VirtualMachineScaleSet#dns_servers}.
     *
     * @stability stable
     */
    readonly dnsServers: string[];
}
/**
 * @stability stable
 */
export interface VirtualMachineScaleSetNetworkProfileIpConfigurationPublicIpAddressConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#domain_name_label VirtualMachineScaleSet#domain_name_label}.
     *
     * @stability stable
     */
    readonly domainNameLabel: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#idle_timeout VirtualMachineScaleSet#idle_timeout}.
     *
     * @stability stable
     */
    readonly idleTimeout: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#name VirtualMachineScaleSet#name}.
     *
     * @stability stable
     */
    readonly name: string;
}
/**
 * @stability stable
 */
export interface VirtualMachineScaleSetNetworkProfileIpConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#application_gateway_backend_address_pool_ids VirtualMachineScaleSet#application_gateway_backend_address_pool_ids}.
     *
     * @stability stable
     */
    readonly applicationGatewayBackendAddressPoolIds?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#application_security_group_ids VirtualMachineScaleSet#application_security_group_ids}.
     *
     * @stability stable
     */
    readonly applicationSecurityGroupIds?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#load_balancer_backend_address_pool_ids VirtualMachineScaleSet#load_balancer_backend_address_pool_ids}.
     *
     * @stability stable
     */
    readonly loadBalancerBackendAddressPoolIds?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#load_balancer_inbound_nat_rules_ids VirtualMachineScaleSet#load_balancer_inbound_nat_rules_ids}.
     *
     * @stability stable
     */
    readonly loadBalancerInboundNatRulesIds?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#name VirtualMachineScaleSet#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#primary VirtualMachineScaleSet#primary}.
     *
     * @stability stable
     */
    readonly primary: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#subnet_id VirtualMachineScaleSet#subnet_id}.
     *
     * @stability stable
     */
    readonly subnetId: string;
    /**
     * public_ip_address_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#public_ip_address_configuration VirtualMachineScaleSet#public_ip_address_configuration}
     *
     * @stability stable
     */
    readonly publicIpAddressConfiguration?: VirtualMachineScaleSetNetworkProfileIpConfigurationPublicIpAddressConfiguration[];
}
/**
 * @stability stable
 */
export interface VirtualMachineScaleSetNetworkProfile {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#accelerated_networking VirtualMachineScaleSet#accelerated_networking}.
     *
     * @stability stable
     */
    readonly acceleratedNetworking?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#ip_forwarding VirtualMachineScaleSet#ip_forwarding}.
     *
     * @stability stable
     */
    readonly ipForwarding?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#name VirtualMachineScaleSet#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#network_security_group_id VirtualMachineScaleSet#network_security_group_id}.
     *
     * @stability stable
     */
    readonly networkSecurityGroupId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#primary VirtualMachineScaleSet#primary}.
     *
     * @stability stable
     */
    readonly primary: boolean;
    /**
     * dns_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#dns_settings VirtualMachineScaleSet#dns_settings}
     *
     * @stability stable
     */
    readonly dnsSettings?: VirtualMachineScaleSetNetworkProfileDnsSettings[];
    /**
     * ip_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#ip_configuration VirtualMachineScaleSet#ip_configuration}
     *
     * @stability stable
     */
    readonly ipConfiguration: VirtualMachineScaleSetNetworkProfileIpConfiguration[];
}
/**
 * @stability stable
 */
export interface VirtualMachineScaleSetOsProfile {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#admin_password VirtualMachineScaleSet#admin_password}.
     *
     * @stability stable
     */
    readonly adminPassword?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#admin_username VirtualMachineScaleSet#admin_username}.
     *
     * @stability stable
     */
    readonly adminUsername: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#computer_name_prefix VirtualMachineScaleSet#computer_name_prefix}.
     *
     * @stability stable
     */
    readonly computerNamePrefix: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#custom_data VirtualMachineScaleSet#custom_data}.
     *
     * @stability stable
     */
    readonly customData?: string;
}
/**
 * @stability stable
 */
export interface VirtualMachineScaleSetOsProfileLinuxConfigSshKeys {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#key_data VirtualMachineScaleSet#key_data}.
     *
     * @stability stable
     */
    readonly keyData?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#path VirtualMachineScaleSet#path}.
     *
     * @stability stable
     */
    readonly path: string;
}
/**
 * @stability stable
 */
export interface VirtualMachineScaleSetOsProfileLinuxConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#disable_password_authentication VirtualMachineScaleSet#disable_password_authentication}.
     *
     * @stability stable
     */
    readonly disablePasswordAuthentication?: boolean;
    /**
     * ssh_keys block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#ssh_keys VirtualMachineScaleSet#ssh_keys}
     *
     * @stability stable
     */
    readonly sshKeys?: VirtualMachineScaleSetOsProfileLinuxConfigSshKeys[];
}
/**
 * @stability stable
 */
export interface VirtualMachineScaleSetOsProfileSecretsVaultCertificates {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#certificate_store VirtualMachineScaleSet#certificate_store}.
     *
     * @stability stable
     */
    readonly certificateStore?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#certificate_url VirtualMachineScaleSet#certificate_url}.
     *
     * @stability stable
     */
    readonly certificateUrl: string;
}
/**
 * @stability stable
 */
export interface VirtualMachineScaleSetOsProfileSecrets {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#source_vault_id VirtualMachineScaleSet#source_vault_id}.
     *
     * @stability stable
     */
    readonly sourceVaultId: string;
    /**
     * vault_certificates block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#vault_certificates VirtualMachineScaleSet#vault_certificates}
     *
     * @stability stable
     */
    readonly vaultCertificates?: VirtualMachineScaleSetOsProfileSecretsVaultCertificates[];
}
/**
 * @stability stable
 */
export interface VirtualMachineScaleSetOsProfileWindowsConfigAdditionalUnattendConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#component VirtualMachineScaleSet#component}.
     *
     * @stability stable
     */
    readonly component: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#content VirtualMachineScaleSet#content}.
     *
     * @stability stable
     */
    readonly content: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#pass VirtualMachineScaleSet#pass}.
     *
     * @stability stable
     */
    readonly pass: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#setting_name VirtualMachineScaleSet#setting_name}.
     *
     * @stability stable
     */
    readonly settingName: string;
}
/**
 * @stability stable
 */
export interface VirtualMachineScaleSetOsProfileWindowsConfigWinrm {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#certificate_url VirtualMachineScaleSet#certificate_url}.
     *
     * @stability stable
     */
    readonly certificateUrl?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#protocol VirtualMachineScaleSet#protocol}.
     *
     * @stability stable
     */
    readonly protocol: string;
}
/**
 * @stability stable
 */
export interface VirtualMachineScaleSetOsProfileWindowsConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#enable_automatic_upgrades VirtualMachineScaleSet#enable_automatic_upgrades}.
     *
     * @stability stable
     */
    readonly enableAutomaticUpgrades?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#provision_vm_agent VirtualMachineScaleSet#provision_vm_agent}.
     *
     * @stability stable
     */
    readonly provisionVmAgent?: boolean;
    /**
     * additional_unattend_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#additional_unattend_config VirtualMachineScaleSet#additional_unattend_config}
     *
     * @stability stable
     */
    readonly additionalUnattendConfig?: VirtualMachineScaleSetOsProfileWindowsConfigAdditionalUnattendConfig[];
    /**
     * winrm block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#winrm VirtualMachineScaleSet#winrm}
     *
     * @stability stable
     */
    readonly winrm?: VirtualMachineScaleSetOsProfileWindowsConfigWinrm[];
}
/**
 * @stability stable
 */
export interface VirtualMachineScaleSetPlan {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#name VirtualMachineScaleSet#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#product VirtualMachineScaleSet#product}.
     *
     * @stability stable
     */
    readonly product: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#publisher VirtualMachineScaleSet#publisher}.
     *
     * @stability stable
     */
    readonly publisher: string;
}
/**
 * @stability stable
 */
export interface VirtualMachineScaleSetRollingUpgradePolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#max_batch_instance_percent VirtualMachineScaleSet#max_batch_instance_percent}.
     *
     * @stability stable
     */
    readonly maxBatchInstancePercent?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#max_unhealthy_instance_percent VirtualMachineScaleSet#max_unhealthy_instance_percent}.
     *
     * @stability stable
     */
    readonly maxUnhealthyInstancePercent?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#max_unhealthy_upgraded_instance_percent VirtualMachineScaleSet#max_unhealthy_upgraded_instance_percent}.
     *
     * @stability stable
     */
    readonly maxUnhealthyUpgradedInstancePercent?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#pause_time_between_batches VirtualMachineScaleSet#pause_time_between_batches}.
     *
     * @stability stable
     */
    readonly pauseTimeBetweenBatches?: string;
}
/**
 * @stability stable
 */
export interface VirtualMachineScaleSetSku {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#capacity VirtualMachineScaleSet#capacity}.
     *
     * @stability stable
     */
    readonly capacity: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#name VirtualMachineScaleSet#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#tier VirtualMachineScaleSet#tier}.
     *
     * @stability stable
     */
    readonly tier?: string;
}
/**
 * @stability stable
 */
export interface VirtualMachineScaleSetStorageProfileDataDisk {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#caching VirtualMachineScaleSet#caching}.
     *
     * @stability stable
     */
    readonly caching?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#create_option VirtualMachineScaleSet#create_option}.
     *
     * @stability stable
     */
    readonly createOption: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#disk_size_gb VirtualMachineScaleSet#disk_size_gb}.
     *
     * @stability stable
     */
    readonly diskSizeGb?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#lun VirtualMachineScaleSet#lun}.
     *
     * @stability stable
     */
    readonly lun: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#managed_disk_type VirtualMachineScaleSet#managed_disk_type}.
     *
     * @stability stable
     */
    readonly managedDiskType?: string;
}
/**
 * @stability stable
 */
export interface VirtualMachineScaleSetStorageProfileImageReference {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#id VirtualMachineScaleSet#id}.
     *
     * @stability stable
     */
    readonly id?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#offer VirtualMachineScaleSet#offer}.
     *
     * @stability stable
     */
    readonly offer?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#publisher VirtualMachineScaleSet#publisher}.
     *
     * @stability stable
     */
    readonly publisher?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#sku VirtualMachineScaleSet#sku}.
     *
     * @stability stable
     */
    readonly sku?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#version VirtualMachineScaleSet#version}.
     *
     * @stability stable
     */
    readonly version?: string;
}
/**
 * @stability stable
 */
export interface VirtualMachineScaleSetStorageProfileOsDisk {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#caching VirtualMachineScaleSet#caching}.
     *
     * @stability stable
     */
    readonly caching?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#create_option VirtualMachineScaleSet#create_option}.
     *
     * @stability stable
     */
    readonly createOption: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#image VirtualMachineScaleSet#image}.
     *
     * @stability stable
     */
    readonly image?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#managed_disk_type VirtualMachineScaleSet#managed_disk_type}.
     *
     * @stability stable
     */
    readonly managedDiskType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#name VirtualMachineScaleSet#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#os_type VirtualMachineScaleSet#os_type}.
     *
     * @stability stable
     */
    readonly osType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#vhd_containers VirtualMachineScaleSet#vhd_containers}.
     *
     * @stability stable
     */
    readonly vhdContainers?: string[];
}
/**
 * @stability stable
 */
export interface VirtualMachineScaleSetTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#create VirtualMachineScaleSet#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#delete VirtualMachineScaleSet#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#read VirtualMachineScaleSet#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html#update VirtualMachineScaleSet#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html azurerm_virtual_machine_scale_set}.
 *
 * @stability stable
 */
export declare class VirtualMachineScaleSet extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine_scale_set.html azurerm_virtual_machine_scale_set} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: VirtualMachineScaleSetConfig);
    private _automaticOsUpgrade?;
    /**
     * @stability stable
     */
    get automaticOsUpgrade(): boolean;
    /**
     * @stability stable
     */
    set automaticOsUpgrade(value: boolean);
    /**
     * @stability stable
     */
    resetAutomaticOsUpgrade(): void;
    /**
     * @stability stable
     */
    get automaticOsUpgradeInput(): boolean | undefined;
    private _evictionPolicy?;
    /**
     * @stability stable
     */
    get evictionPolicy(): string;
    /**
     * @stability stable
     */
    set evictionPolicy(value: string);
    /**
     * @stability stable
     */
    resetEvictionPolicy(): void;
    /**
     * @stability stable
     */
    get evictionPolicyInput(): string | undefined;
    private _healthProbeId?;
    /**
     * @stability stable
     */
    get healthProbeId(): string;
    /**
     * @stability stable
     */
    set healthProbeId(value: string);
    /**
     * @stability stable
     */
    resetHealthProbeId(): void;
    /**
     * @stability stable
     */
    get healthProbeIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _licenseType?;
    /**
     * @stability stable
     */
    get licenseType(): string;
    /**
     * @stability stable
     */
    set licenseType(value: string);
    /**
     * @stability stable
     */
    resetLicenseType(): void;
    /**
     * @stability stable
     */
    get licenseTypeInput(): string | undefined;
    private _location;
    /**
     * @stability stable
     */
    get location(): string;
    /**
     * @stability stable
     */
    set location(value: string);
    /**
     * @stability stable
     */
    get locationInput(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _overprovision?;
    /**
     * @stability stable
     */
    get overprovision(): boolean;
    /**
     * @stability stable
     */
    set overprovision(value: boolean);
    /**
     * @stability stable
     */
    resetOverprovision(): void;
    /**
     * @stability stable
     */
    get overprovisionInput(): boolean | undefined;
    private _priority?;
    /**
     * @stability stable
     */
    get priority(): string;
    /**
     * @stability stable
     */
    set priority(value: string);
    /**
     * @stability stable
     */
    resetPriority(): void;
    /**
     * @stability stable
     */
    get priorityInput(): string | undefined;
    private _proximityPlacementGroupId?;
    /**
     * @stability stable
     */
    get proximityPlacementGroupId(): string;
    /**
     * @stability stable
     */
    set proximityPlacementGroupId(value: string);
    /**
     * @stability stable
     */
    resetProximityPlacementGroupId(): void;
    /**
     * @stability stable
     */
    get proximityPlacementGroupIdInput(): string | undefined;
    private _resourceGroupName;
    /**
     * @stability stable
     */
    get resourceGroupName(): string;
    /**
     * @stability stable
     */
    set resourceGroupName(value: string);
    /**
     * @stability stable
     */
    get resourceGroupNameInput(): string;
    private _singlePlacementGroup?;
    /**
     * @stability stable
     */
    get singlePlacementGroup(): boolean;
    /**
     * @stability stable
     */
    set singlePlacementGroup(value: boolean);
    /**
     * @stability stable
     */
    resetSinglePlacementGroup(): void;
    /**
     * @stability stable
     */
    get singlePlacementGroupInput(): boolean | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _upgradePolicyMode;
    /**
     * @stability stable
     */
    get upgradePolicyMode(): string;
    /**
     * @stability stable
     */
    set upgradePolicyMode(value: string);
    /**
     * @stability stable
     */
    get upgradePolicyModeInput(): string;
    private _zones?;
    /**
     * @stability stable
     */
    get zones(): string[];
    /**
     * @stability stable
     */
    set zones(value: string[]);
    /**
     * @stability stable
     */
    resetZones(): void;
    /**
     * @stability stable
     */
    get zonesInput(): string[] | undefined;
    private _bootDiagnostics?;
    /**
     * @stability stable
     */
    get bootDiagnostics(): VirtualMachineScaleSetBootDiagnostics[];
    /**
     * @stability stable
     */
    set bootDiagnostics(value: VirtualMachineScaleSetBootDiagnostics[]);
    /**
     * @stability stable
     */
    resetBootDiagnostics(): void;
    /**
     * @stability stable
     */
    get bootDiagnosticsInput(): VirtualMachineScaleSetBootDiagnostics[] | undefined;
    private _extension?;
    /**
     * @stability stable
     */
    get extension(): VirtualMachineScaleSetExtension[];
    /**
     * @stability stable
     */
    set extension(value: VirtualMachineScaleSetExtension[]);
    /**
     * @stability stable
     */
    resetExtension(): void;
    /**
     * @stability stable
     */
    get extensionInput(): VirtualMachineScaleSetExtension[] | undefined;
    private _identity?;
    /**
     * @stability stable
     */
    get identity(): VirtualMachineScaleSetIdentity[];
    /**
     * @stability stable
     */
    set identity(value: VirtualMachineScaleSetIdentity[]);
    /**
     * @stability stable
     */
    resetIdentity(): void;
    /**
     * @stability stable
     */
    get identityInput(): VirtualMachineScaleSetIdentity[] | undefined;
    private _networkProfile;
    /**
     * @stability stable
     */
    get networkProfile(): VirtualMachineScaleSetNetworkProfile[];
    /**
     * @stability stable
     */
    set networkProfile(value: VirtualMachineScaleSetNetworkProfile[]);
    /**
     * @stability stable
     */
    get networkProfileInput(): VirtualMachineScaleSetNetworkProfile[];
    private _osProfile;
    /**
     * @stability stable
     */
    get osProfile(): VirtualMachineScaleSetOsProfile[];
    /**
     * @stability stable
     */
    set osProfile(value: VirtualMachineScaleSetOsProfile[]);
    /**
     * @stability stable
     */
    get osProfileInput(): VirtualMachineScaleSetOsProfile[];
    private _osProfileLinuxConfig?;
    /**
     * @stability stable
     */
    get osProfileLinuxConfig(): VirtualMachineScaleSetOsProfileLinuxConfig[];
    /**
     * @stability stable
     */
    set osProfileLinuxConfig(value: VirtualMachineScaleSetOsProfileLinuxConfig[]);
    /**
     * @stability stable
     */
    resetOsProfileLinuxConfig(): void;
    /**
     * @stability stable
     */
    get osProfileLinuxConfigInput(): VirtualMachineScaleSetOsProfileLinuxConfig[] | undefined;
    private _osProfileSecrets?;
    /**
     * @stability stable
     */
    get osProfileSecrets(): VirtualMachineScaleSetOsProfileSecrets[];
    /**
     * @stability stable
     */
    set osProfileSecrets(value: VirtualMachineScaleSetOsProfileSecrets[]);
    /**
     * @stability stable
     */
    resetOsProfileSecrets(): void;
    /**
     * @stability stable
     */
    get osProfileSecretsInput(): VirtualMachineScaleSetOsProfileSecrets[] | undefined;
    private _osProfileWindowsConfig?;
    /**
     * @stability stable
     */
    get osProfileWindowsConfig(): VirtualMachineScaleSetOsProfileWindowsConfig[];
    /**
     * @stability stable
     */
    set osProfileWindowsConfig(value: VirtualMachineScaleSetOsProfileWindowsConfig[]);
    /**
     * @stability stable
     */
    resetOsProfileWindowsConfig(): void;
    /**
     * @stability stable
     */
    get osProfileWindowsConfigInput(): VirtualMachineScaleSetOsProfileWindowsConfig[] | undefined;
    private _plan?;
    /**
     * @stability stable
     */
    get plan(): VirtualMachineScaleSetPlan[];
    /**
     * @stability stable
     */
    set plan(value: VirtualMachineScaleSetPlan[]);
    /**
     * @stability stable
     */
    resetPlan(): void;
    /**
     * @stability stable
     */
    get planInput(): VirtualMachineScaleSetPlan[] | undefined;
    private _rollingUpgradePolicy?;
    /**
     * @stability stable
     */
    get rollingUpgradePolicy(): VirtualMachineScaleSetRollingUpgradePolicy[];
    /**
     * @stability stable
     */
    set rollingUpgradePolicy(value: VirtualMachineScaleSetRollingUpgradePolicy[]);
    /**
     * @stability stable
     */
    resetRollingUpgradePolicy(): void;
    /**
     * @stability stable
     */
    get rollingUpgradePolicyInput(): VirtualMachineScaleSetRollingUpgradePolicy[] | undefined;
    private _sku;
    /**
     * @stability stable
     */
    get sku(): VirtualMachineScaleSetSku[];
    /**
     * @stability stable
     */
    set sku(value: VirtualMachineScaleSetSku[]);
    /**
     * @stability stable
     */
    get skuInput(): VirtualMachineScaleSetSku[];
    private _storageProfileDataDisk?;
    /**
     * @stability stable
     */
    get storageProfileDataDisk(): VirtualMachineScaleSetStorageProfileDataDisk[];
    /**
     * @stability stable
     */
    set storageProfileDataDisk(value: VirtualMachineScaleSetStorageProfileDataDisk[]);
    /**
     * @stability stable
     */
    resetStorageProfileDataDisk(): void;
    /**
     * @stability stable
     */
    get storageProfileDataDiskInput(): VirtualMachineScaleSetStorageProfileDataDisk[] | undefined;
    private _storageProfileImageReference?;
    /**
     * @stability stable
     */
    get storageProfileImageReference(): VirtualMachineScaleSetStorageProfileImageReference[];
    /**
     * @stability stable
     */
    set storageProfileImageReference(value: VirtualMachineScaleSetStorageProfileImageReference[]);
    /**
     * @stability stable
     */
    resetStorageProfileImageReference(): void;
    /**
     * @stability stable
     */
    get storageProfileImageReferenceInput(): VirtualMachineScaleSetStorageProfileImageReference[] | undefined;
    private _storageProfileOsDisk;
    /**
     * @stability stable
     */
    get storageProfileOsDisk(): VirtualMachineScaleSetStorageProfileOsDisk[];
    /**
     * @stability stable
     */
    set storageProfileOsDisk(value: VirtualMachineScaleSetStorageProfileOsDisk[]);
    /**
     * @stability stable
     */
    get storageProfileOsDiskInput(): VirtualMachineScaleSetStorageProfileOsDisk[];
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): VirtualMachineScaleSetTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: VirtualMachineScaleSetTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): VirtualMachineScaleSetTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
