import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface VirtualMachineConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#availability_set_id VirtualMachine#availability_set_id}.
     *
     * @stability stable
     */
    readonly availabilitySetId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#delete_data_disks_on_termination VirtualMachine#delete_data_disks_on_termination}.
     *
     * @stability stable
     */
    readonly deleteDataDisksOnTermination?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#delete_os_disk_on_termination VirtualMachine#delete_os_disk_on_termination}.
     *
     * @stability stable
     */
    readonly deleteOsDiskOnTermination?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#license_type VirtualMachine#license_type}.
     *
     * @stability stable
     */
    readonly licenseType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#location VirtualMachine#location}.
     *
     * @stability stable
     */
    readonly location: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#name VirtualMachine#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#network_interface_ids VirtualMachine#network_interface_ids}.
     *
     * @stability stable
     */
    readonly networkInterfaceIds: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#primary_network_interface_id VirtualMachine#primary_network_interface_id}.
     *
     * @stability stable
     */
    readonly primaryNetworkInterfaceId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#proximity_placement_group_id VirtualMachine#proximity_placement_group_id}.
     *
     * @stability stable
     */
    readonly proximityPlacementGroupId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#resource_group_name VirtualMachine#resource_group_name}.
     *
     * @stability stable
     */
    readonly resourceGroupName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#tags VirtualMachine#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#vm_size VirtualMachine#vm_size}.
     *
     * @stability stable
     */
    readonly vmSize: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#zones VirtualMachine#zones}.
     *
     * @stability stable
     */
    readonly zones?: string[];
    /**
     * additional_capabilities block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#additional_capabilities VirtualMachine#additional_capabilities}
     *
     * @stability stable
     */
    readonly additionalCapabilities?: VirtualMachineAdditionalCapabilities[];
    /**
     * boot_diagnostics block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#boot_diagnostics VirtualMachine#boot_diagnostics}
     *
     * @stability stable
     */
    readonly bootDiagnostics?: VirtualMachineBootDiagnostics[];
    /**
     * identity block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#identity VirtualMachine#identity}
     *
     * @stability stable
     */
    readonly identity?: VirtualMachineIdentity[];
    /**
     * os_profile block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#os_profile VirtualMachine#os_profile}
     *
     * @stability stable
     */
    readonly osProfile?: VirtualMachineOsProfile[];
    /**
     * os_profile_linux_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#os_profile_linux_config VirtualMachine#os_profile_linux_config}
     *
     * @stability stable
     */
    readonly osProfileLinuxConfig?: VirtualMachineOsProfileLinuxConfig[];
    /**
     * os_profile_secrets block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#os_profile_secrets VirtualMachine#os_profile_secrets}
     *
     * @stability stable
     */
    readonly osProfileSecrets?: VirtualMachineOsProfileSecrets[];
    /**
     * os_profile_windows_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#os_profile_windows_config VirtualMachine#os_profile_windows_config}
     *
     * @stability stable
     */
    readonly osProfileWindowsConfig?: VirtualMachineOsProfileWindowsConfig[];
    /**
     * plan block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#plan VirtualMachine#plan}
     *
     * @stability stable
     */
    readonly plan?: VirtualMachinePlan[];
    /**
     * storage_data_disk block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#storage_data_disk VirtualMachine#storage_data_disk}
     *
     * @stability stable
     */
    readonly storageDataDisk?: VirtualMachineStorageDataDisk[];
    /**
     * storage_image_reference block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#storage_image_reference VirtualMachine#storage_image_reference}
     *
     * @stability stable
     */
    readonly storageImageReference?: VirtualMachineStorageImageReference[];
    /**
     * storage_os_disk block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#storage_os_disk VirtualMachine#storage_os_disk}
     *
     * @stability stable
     */
    readonly storageOsDisk: VirtualMachineStorageOsDisk[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#timeouts VirtualMachine#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: VirtualMachineTimeouts;
}
/**
 * @stability stable
 */
export interface VirtualMachineAdditionalCapabilities {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#ultra_ssd_enabled VirtualMachine#ultra_ssd_enabled}.
     *
     * @stability stable
     */
    readonly ultraSsdEnabled: boolean;
}
/**
 * @stability stable
 */
export interface VirtualMachineBootDiagnostics {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#enabled VirtualMachine#enabled}.
     *
     * @stability stable
     */
    readonly enabled: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#storage_uri VirtualMachine#storage_uri}.
     *
     * @stability stable
     */
    readonly storageUri: string;
}
/**
 * @stability stable
 */
export interface VirtualMachineIdentity {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#identity_ids VirtualMachine#identity_ids}.
     *
     * @stability stable
     */
    readonly identityIds?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#type VirtualMachine#type}.
     *
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface VirtualMachineOsProfile {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#admin_password VirtualMachine#admin_password}.
     *
     * @stability stable
     */
    readonly adminPassword?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#admin_username VirtualMachine#admin_username}.
     *
     * @stability stable
     */
    readonly adminUsername: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#computer_name VirtualMachine#computer_name}.
     *
     * @stability stable
     */
    readonly computerName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#custom_data VirtualMachine#custom_data}.
     *
     * @stability stable
     */
    readonly customData?: string;
}
/**
 * @stability stable
 */
export interface VirtualMachineOsProfileLinuxConfigSshKeys {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#key_data VirtualMachine#key_data}.
     *
     * @stability stable
     */
    readonly keyData: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#path VirtualMachine#path}.
     *
     * @stability stable
     */
    readonly path: string;
}
/**
 * @stability stable
 */
export interface VirtualMachineOsProfileLinuxConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#disable_password_authentication VirtualMachine#disable_password_authentication}.
     *
     * @stability stable
     */
    readonly disablePasswordAuthentication: boolean;
    /**
     * ssh_keys block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#ssh_keys VirtualMachine#ssh_keys}
     *
     * @stability stable
     */
    readonly sshKeys?: VirtualMachineOsProfileLinuxConfigSshKeys[];
}
/**
 * @stability stable
 */
export interface VirtualMachineOsProfileSecretsVaultCertificates {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#certificate_store VirtualMachine#certificate_store}.
     *
     * @stability stable
     */
    readonly certificateStore?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#certificate_url VirtualMachine#certificate_url}.
     *
     * @stability stable
     */
    readonly certificateUrl: string;
}
/**
 * @stability stable
 */
export interface VirtualMachineOsProfileSecrets {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#source_vault_id VirtualMachine#source_vault_id}.
     *
     * @stability stable
     */
    readonly sourceVaultId: string;
    /**
     * vault_certificates block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#vault_certificates VirtualMachine#vault_certificates}
     *
     * @stability stable
     */
    readonly vaultCertificates?: VirtualMachineOsProfileSecretsVaultCertificates[];
}
/**
 * @stability stable
 */
export interface VirtualMachineOsProfileWindowsConfigAdditionalUnattendConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#component VirtualMachine#component}.
     *
     * @stability stable
     */
    readonly component: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#content VirtualMachine#content}.
     *
     * @stability stable
     */
    readonly content: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#pass VirtualMachine#pass}.
     *
     * @stability stable
     */
    readonly pass: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#setting_name VirtualMachine#setting_name}.
     *
     * @stability stable
     */
    readonly settingName: string;
}
/**
 * @stability stable
 */
export interface VirtualMachineOsProfileWindowsConfigWinrm {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#certificate_url VirtualMachine#certificate_url}.
     *
     * @stability stable
     */
    readonly certificateUrl?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#protocol VirtualMachine#protocol}.
     *
     * @stability stable
     */
    readonly protocol: string;
}
/**
 * @stability stable
 */
export interface VirtualMachineOsProfileWindowsConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#enable_automatic_upgrades VirtualMachine#enable_automatic_upgrades}.
     *
     * @stability stable
     */
    readonly enableAutomaticUpgrades?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#provision_vm_agent VirtualMachine#provision_vm_agent}.
     *
     * @stability stable
     */
    readonly provisionVmAgent?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#timezone VirtualMachine#timezone}.
     *
     * @stability stable
     */
    readonly timezone?: string;
    /**
     * additional_unattend_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#additional_unattend_config VirtualMachine#additional_unattend_config}
     *
     * @stability stable
     */
    readonly additionalUnattendConfig?: VirtualMachineOsProfileWindowsConfigAdditionalUnattendConfig[];
    /**
     * winrm block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#winrm VirtualMachine#winrm}
     *
     * @stability stable
     */
    readonly winrm?: VirtualMachineOsProfileWindowsConfigWinrm[];
}
/**
 * @stability stable
 */
export interface VirtualMachinePlan {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#name VirtualMachine#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#product VirtualMachine#product}.
     *
     * @stability stable
     */
    readonly product: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#publisher VirtualMachine#publisher}.
     *
     * @stability stable
     */
    readonly publisher: string;
}
/**
 * @stability stable
 */
export interface VirtualMachineStorageDataDisk {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#caching VirtualMachine#caching}.
     *
     * @stability stable
     */
    readonly caching?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#create_option VirtualMachine#create_option}.
     *
     * @stability stable
     */
    readonly createOption: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#disk_size_gb VirtualMachine#disk_size_gb}.
     *
     * @stability stable
     */
    readonly diskSizeGb?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#lun VirtualMachine#lun}.
     *
     * @stability stable
     */
    readonly lun: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#managed_disk_id VirtualMachine#managed_disk_id}.
     *
     * @stability stable
     */
    readonly managedDiskId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#managed_disk_type VirtualMachine#managed_disk_type}.
     *
     * @stability stable
     */
    readonly managedDiskType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#name VirtualMachine#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#vhd_uri VirtualMachine#vhd_uri}.
     *
     * @stability stable
     */
    readonly vhdUri?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#write_accelerator_enabled VirtualMachine#write_accelerator_enabled}.
     *
     * @stability stable
     */
    readonly writeAcceleratorEnabled?: boolean;
}
/**
 * @stability stable
 */
export interface VirtualMachineStorageImageReference {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#id VirtualMachine#id}.
     *
     * @stability stable
     */
    readonly id?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#offer VirtualMachine#offer}.
     *
     * @stability stable
     */
    readonly offer?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#publisher VirtualMachine#publisher}.
     *
     * @stability stable
     */
    readonly publisher?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#sku VirtualMachine#sku}.
     *
     * @stability stable
     */
    readonly sku?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#version VirtualMachine#version}.
     *
     * @stability stable
     */
    readonly version?: string;
}
/**
 * @stability stable
 */
export interface VirtualMachineStorageOsDisk {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#caching VirtualMachine#caching}.
     *
     * @stability stable
     */
    readonly caching?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#create_option VirtualMachine#create_option}.
     *
     * @stability stable
     */
    readonly createOption: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#disk_size_gb VirtualMachine#disk_size_gb}.
     *
     * @stability stable
     */
    readonly diskSizeGb?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#image_uri VirtualMachine#image_uri}.
     *
     * @stability stable
     */
    readonly imageUri?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#managed_disk_id VirtualMachine#managed_disk_id}.
     *
     * @stability stable
     */
    readonly managedDiskId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#managed_disk_type VirtualMachine#managed_disk_type}.
     *
     * @stability stable
     */
    readonly managedDiskType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#name VirtualMachine#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#os_type VirtualMachine#os_type}.
     *
     * @stability stable
     */
    readonly osType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#vhd_uri VirtualMachine#vhd_uri}.
     *
     * @stability stable
     */
    readonly vhdUri?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#write_accelerator_enabled VirtualMachine#write_accelerator_enabled}.
     *
     * @stability stable
     */
    readonly writeAcceleratorEnabled?: boolean;
}
/**
 * @stability stable
 */
export interface VirtualMachineTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#create VirtualMachine#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#delete VirtualMachine#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#read VirtualMachine#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html#update VirtualMachine#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html azurerm_virtual_machine}.
 *
 * @stability stable
 */
export declare class VirtualMachine extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_machine.html azurerm_virtual_machine} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: VirtualMachineConfig);
    private _availabilitySetId?;
    /**
     * @stability stable
     */
    get availabilitySetId(): string;
    /**
     * @stability stable
     */
    set availabilitySetId(value: string);
    /**
     * @stability stable
     */
    resetAvailabilitySetId(): void;
    /**
     * @stability stable
     */
    get availabilitySetIdInput(): string | undefined;
    private _deleteDataDisksOnTermination?;
    /**
     * @stability stable
     */
    get deleteDataDisksOnTermination(): boolean;
    /**
     * @stability stable
     */
    set deleteDataDisksOnTermination(value: boolean);
    /**
     * @stability stable
     */
    resetDeleteDataDisksOnTermination(): void;
    /**
     * @stability stable
     */
    get deleteDataDisksOnTerminationInput(): boolean | undefined;
    private _deleteOsDiskOnTermination?;
    /**
     * @stability stable
     */
    get deleteOsDiskOnTermination(): boolean;
    /**
     * @stability stable
     */
    set deleteOsDiskOnTermination(value: boolean);
    /**
     * @stability stable
     */
    resetDeleteOsDiskOnTermination(): void;
    /**
     * @stability stable
     */
    get deleteOsDiskOnTerminationInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _licenseType?;
    /**
     * @stability stable
     */
    get licenseType(): string;
    /**
     * @stability stable
     */
    set licenseType(value: string);
    /**
     * @stability stable
     */
    resetLicenseType(): void;
    /**
     * @stability stable
     */
    get licenseTypeInput(): string | undefined;
    private _location;
    /**
     * @stability stable
     */
    get location(): string;
    /**
     * @stability stable
     */
    set location(value: string);
    /**
     * @stability stable
     */
    get locationInput(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _networkInterfaceIds;
    /**
     * @stability stable
     */
    get networkInterfaceIds(): string[];
    /**
     * @stability stable
     */
    set networkInterfaceIds(value: string[]);
    /**
     * @stability stable
     */
    get networkInterfaceIdsInput(): string[];
    private _primaryNetworkInterfaceId?;
    /**
     * @stability stable
     */
    get primaryNetworkInterfaceId(): string;
    /**
     * @stability stable
     */
    set primaryNetworkInterfaceId(value: string);
    /**
     * @stability stable
     */
    resetPrimaryNetworkInterfaceId(): void;
    /**
     * @stability stable
     */
    get primaryNetworkInterfaceIdInput(): string | undefined;
    private _proximityPlacementGroupId?;
    /**
     * @stability stable
     */
    get proximityPlacementGroupId(): string;
    /**
     * @stability stable
     */
    set proximityPlacementGroupId(value: string);
    /**
     * @stability stable
     */
    resetProximityPlacementGroupId(): void;
    /**
     * @stability stable
     */
    get proximityPlacementGroupIdInput(): string | undefined;
    private _resourceGroupName;
    /**
     * @stability stable
     */
    get resourceGroupName(): string;
    /**
     * @stability stable
     */
    set resourceGroupName(value: string);
    /**
     * @stability stable
     */
    get resourceGroupNameInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _vmSize;
    /**
     * @stability stable
     */
    get vmSize(): string;
    /**
     * @stability stable
     */
    set vmSize(value: string);
    /**
     * @stability stable
     */
    get vmSizeInput(): string;
    private _zones?;
    /**
     * @stability stable
     */
    get zones(): string[];
    /**
     * @stability stable
     */
    set zones(value: string[]);
    /**
     * @stability stable
     */
    resetZones(): void;
    /**
     * @stability stable
     */
    get zonesInput(): string[] | undefined;
    private _additionalCapabilities?;
    /**
     * @stability stable
     */
    get additionalCapabilities(): VirtualMachineAdditionalCapabilities[];
    /**
     * @stability stable
     */
    set additionalCapabilities(value: VirtualMachineAdditionalCapabilities[]);
    /**
     * @stability stable
     */
    resetAdditionalCapabilities(): void;
    /**
     * @stability stable
     */
    get additionalCapabilitiesInput(): VirtualMachineAdditionalCapabilities[] | undefined;
    private _bootDiagnostics?;
    /**
     * @stability stable
     */
    get bootDiagnostics(): VirtualMachineBootDiagnostics[];
    /**
     * @stability stable
     */
    set bootDiagnostics(value: VirtualMachineBootDiagnostics[]);
    /**
     * @stability stable
     */
    resetBootDiagnostics(): void;
    /**
     * @stability stable
     */
    get bootDiagnosticsInput(): VirtualMachineBootDiagnostics[] | undefined;
    private _identity?;
    /**
     * @stability stable
     */
    get identity(): VirtualMachineIdentity[];
    /**
     * @stability stable
     */
    set identity(value: VirtualMachineIdentity[]);
    /**
     * @stability stable
     */
    resetIdentity(): void;
    /**
     * @stability stable
     */
    get identityInput(): VirtualMachineIdentity[] | undefined;
    private _osProfile?;
    /**
     * @stability stable
     */
    get osProfile(): VirtualMachineOsProfile[];
    /**
     * @stability stable
     */
    set osProfile(value: VirtualMachineOsProfile[]);
    /**
     * @stability stable
     */
    resetOsProfile(): void;
    /**
     * @stability stable
     */
    get osProfileInput(): VirtualMachineOsProfile[] | undefined;
    private _osProfileLinuxConfig?;
    /**
     * @stability stable
     */
    get osProfileLinuxConfig(): VirtualMachineOsProfileLinuxConfig[];
    /**
     * @stability stable
     */
    set osProfileLinuxConfig(value: VirtualMachineOsProfileLinuxConfig[]);
    /**
     * @stability stable
     */
    resetOsProfileLinuxConfig(): void;
    /**
     * @stability stable
     */
    get osProfileLinuxConfigInput(): VirtualMachineOsProfileLinuxConfig[] | undefined;
    private _osProfileSecrets?;
    /**
     * @stability stable
     */
    get osProfileSecrets(): VirtualMachineOsProfileSecrets[];
    /**
     * @stability stable
     */
    set osProfileSecrets(value: VirtualMachineOsProfileSecrets[]);
    /**
     * @stability stable
     */
    resetOsProfileSecrets(): void;
    /**
     * @stability stable
     */
    get osProfileSecretsInput(): VirtualMachineOsProfileSecrets[] | undefined;
    private _osProfileWindowsConfig?;
    /**
     * @stability stable
     */
    get osProfileWindowsConfig(): VirtualMachineOsProfileWindowsConfig[];
    /**
     * @stability stable
     */
    set osProfileWindowsConfig(value: VirtualMachineOsProfileWindowsConfig[]);
    /**
     * @stability stable
     */
    resetOsProfileWindowsConfig(): void;
    /**
     * @stability stable
     */
    get osProfileWindowsConfigInput(): VirtualMachineOsProfileWindowsConfig[] | undefined;
    private _plan?;
    /**
     * @stability stable
     */
    get plan(): VirtualMachinePlan[];
    /**
     * @stability stable
     */
    set plan(value: VirtualMachinePlan[]);
    /**
     * @stability stable
     */
    resetPlan(): void;
    /**
     * @stability stable
     */
    get planInput(): VirtualMachinePlan[] | undefined;
    private _storageDataDisk?;
    /**
     * @stability stable
     */
    get storageDataDisk(): VirtualMachineStorageDataDisk[];
    /**
     * @stability stable
     */
    set storageDataDisk(value: VirtualMachineStorageDataDisk[]);
    /**
     * @stability stable
     */
    resetStorageDataDisk(): void;
    /**
     * @stability stable
     */
    get storageDataDiskInput(): VirtualMachineStorageDataDisk[] | undefined;
    private _storageImageReference?;
    /**
     * @stability stable
     */
    get storageImageReference(): VirtualMachineStorageImageReference[];
    /**
     * @stability stable
     */
    set storageImageReference(value: VirtualMachineStorageImageReference[]);
    /**
     * @stability stable
     */
    resetStorageImageReference(): void;
    /**
     * @stability stable
     */
    get storageImageReferenceInput(): VirtualMachineStorageImageReference[] | undefined;
    private _storageOsDisk;
    /**
     * @stability stable
     */
    get storageOsDisk(): VirtualMachineStorageOsDisk[];
    /**
     * @stability stable
     */
    set storageOsDisk(value: VirtualMachineStorageOsDisk[]);
    /**
     * @stability stable
     */
    get storageOsDiskInput(): VirtualMachineStorageOsDisk[];
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): VirtualMachineTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: VirtualMachineTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): VirtualMachineTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
